# IO.Swagger.Api.AdminSourcesApi

All URIs are relative to *https://platform.its4land.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**GetAdminSourceByUID**](AdminSourcesApi.md#getadminsourcebyuid) | **GET** /adminsources/{adminsource_uid} | Returns a single Admin Source
[**GetAdminSources**](AdminSourcesApi.md#getadminsources) | **GET** /adminsources | Returns a list of AdminSource document indizes
[**NewAdminSource**](AdminSourcesApi.md#newadminsource) | **POST** /adminsources | Creates a new AdminSource
[**UpdateAdminSource**](AdminSourcesApi.md#updateadminsource) | **PATCH** /adminsources/{adminsource_uid} | Update an Admin Source


<a name="getadminsourcebyuid"></a>
# **GetAdminSourceByUID**
> AdminSourcesEndpointType GetAdminSourceByUID (string adminsourceUid, string envelope = null, List<string> embed = null)

Returns a single Admin Source

Returns a single Admin Source

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class GetAdminSourceByUIDExample
    {
        public void main()
        {
            var apiInstance = new AdminSourcesApi();
            var adminsourceUid = adminsourceUid_example;  // string | AdminSource UID
            var envelope = envelope_example;  // string | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional) 
            var embed = new List<string>(); // List<string> | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional) 

            try
            {
                // Returns a single Admin Source
                AdminSourcesEndpointType result = apiInstance.GetAdminSourceByUID(adminsourceUid, envelope, embed);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling AdminSourcesApi.GetAdminSourceByUID: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **adminsourceUid** | **string**| AdminSource UID | 
 **envelope** | **string**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **embed** | [**List&lt;string&gt;**](string.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional] 

### Return type

[**AdminSourcesEndpointType**](AdminSourcesEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="getadminsources"></a>
# **GetAdminSources**
> List<AdminSourcesEndpointType> GetAdminSources (string envelope = null, List<string> uid = null, List<string> name = null, List<string> type = null, List<string> projects = null, List<string> spatialunits = null, List<string> tags = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null)

Returns a list of AdminSource document indizes

Returns a list of AdminSource document indizes

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class GetAdminSourcesExample
    {
        public void main()
        {
            var apiInstance = new AdminSourcesApi();
            var envelope = envelope_example;  // string | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional) 
            var uid = new List<string>(); // List<string> | Comma separated list of AdminSources UID (optional) 
            var name = new List<string>(); // List<string> | Comma separated list of AdminSources names (optional) 
            var type = new List<string>(); // List<string> | Comma separated list of AdminSources types (optional) 
            var projects = new List<string>(); // List<string> | Comma separated list of project UID (optional) 
            var spatialunits = new List<string>(); // List<string> | Comma separated list of SpatialUnit UID (optional) 
            var tags = new List<string>(); // List<string> | Comma separated list of tags (optional) 
            var page = 56;  // int? | Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional) 
            var sort = sort_example;  // string | The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional) 
            var fields = new List<string>(); // List<string> | Comma separated list of tags (optional) 
            var embed = new List<string>(); // List<string> | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional) 

            try
            {
                // Returns a list of AdminSource document indizes
                List&lt;AdminSourcesEndpointType&gt; result = apiInstance.GetAdminSources(envelope, uid, name, type, projects, spatialunits, tags, page, sort, fields, embed);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling AdminSourcesApi.GetAdminSources: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **envelope** | **string**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **uid** | [**List&lt;string&gt;**](string.md)| Comma separated list of AdminSources UID | [optional] 
 **name** | [**List&lt;string&gt;**](string.md)| Comma separated list of AdminSources names | [optional] 
 **type** | [**List&lt;string&gt;**](string.md)| Comma separated list of AdminSources types | [optional] 
 **projects** | [**List&lt;string&gt;**](string.md)| Comma separated list of project UID | [optional] 
 **spatialunits** | [**List&lt;string&gt;**](string.md)| Comma separated list of SpatialUnit UID | [optional] 
 **tags** | [**List&lt;string&gt;**](string.md)| Comma separated list of tags | [optional] 
 **page** | **int?**| Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. | [optional] 
 **sort** | **string**| The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. | [optional] 
 **fields** | [**List&lt;string&gt;**](string.md)| Comma separated list of tags | [optional] 
 **embed** | [**List&lt;string&gt;**](string.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional] 

### Return type

[**List<AdminSourcesEndpointType>**](AdminSourcesEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="newadminsource"></a>
# **NewAdminSource**
> AdminSourcesEndpointType NewAdminSource (AdminSourcesPostRequest newadminsource, string envelope = null, List<string> embed = null, string i4lProcessUid = null)

Creates a new AdminSource

Creates a new AdminSource

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class NewAdminSourceExample
    {
        public void main()
        {
            var apiInstance = new AdminSourcesApi();
            var newadminsource = new AdminSourcesPostRequest(); // AdminSourcesPostRequest | New AdminSource data
            var envelope = envelope_example;  // string | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional) 
            var embed = new List<string>(); // List<string> | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional) 
            var i4lProcessUid = i4lProcessUid_example;  // string | Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional) 

            try
            {
                // Creates a new AdminSource
                AdminSourcesEndpointType result = apiInstance.NewAdminSource(newadminsource, envelope, embed, i4lProcessUid);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling AdminSourcesApi.NewAdminSource: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **newadminsource** | [**AdminSourcesPostRequest**](AdminSourcesPostRequest.md)| New AdminSource data | 
 **envelope** | **string**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **embed** | [**List&lt;string&gt;**](string.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional] 
 **i4lProcessUid** | **string**| Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. | [optional] 

### Return type

[**AdminSourcesEndpointType**](AdminSourcesEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="updateadminsource"></a>
# **UpdateAdminSource**
> AdminSourcesEndpointType UpdateAdminSource (string adminsourceUid, RFC6902PatchRequest patchadminsource, string envelope = null, string i4lProcessUid = null)

Update an Admin Source

Update an Admin Source

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class UpdateAdminSourceExample
    {
        public void main()
        {
            var apiInstance = new AdminSourcesApi();
            var adminsourceUid = adminsourceUid_example;  // string | AdminSource UID
            var patchadminsource = new RFC6902PatchRequest(); // RFC6902PatchRequest | Update data
            var envelope = envelope_example;  // string | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional) 
            var i4lProcessUid = i4lProcessUid_example;  // string | Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional) 

            try
            {
                // Update an Admin Source
                AdminSourcesEndpointType result = apiInstance.UpdateAdminSource(adminsourceUid, patchadminsource, envelope, i4lProcessUid);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling AdminSourcesApi.UpdateAdminSource: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **adminsourceUid** | **string**| AdminSource UID | 
 **patchadminsource** | [**RFC6902PatchRequest**](RFC6902PatchRequest.md)| Update data | 
 **envelope** | **string**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **i4lProcessUid** | **string**| Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. | [optional] 

### Return type

[**AdminSourcesEndpointType**](AdminSourcesEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

