# IO.Swagger.Api.BoundaryFaceStringApi

All URIs are relative to *https://platform.its4land.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**GetBoundaryFaceString**](BoundaryFaceStringApi.md#getboundaryfacestring) | **GET** /boundaryfacestring | Returns a list of boundary face strings in a GeoJSON structure.
[**GetBoundaryFaceStringByUID**](BoundaryFaceStringApi.md#getboundaryfacestringbyuid) | **GET** /boundaryfacestring/{boundaryfacestring_uid} | Returns a single boundary face string
[**NewBoundaryFaceString**](BoundaryFaceStringApi.md#newboundaryfacestring) | **POST** /boundaryfacestring | Create a new concept for a boundary face string
[**PutBoundaryFaceStringByUID**](BoundaryFaceStringApi.md#putboundaryfacestringbyuid) | **PUT** /boundaryfacestring/{boundaryfacestring_uid} | Replace an existing BoundaryFaceString by a newer version
[**UpdateBoundaryFaceString**](BoundaryFaceStringApi.md#updateboundaryfacestring) | **PATCH** /boundaryfacestring/{boundaryfacestring_uid} | Updates a boundary face string


<a name="getboundaryfacestring"></a>
# **GetBoundaryFaceString**
> BoundaryFaceStringEndpointType GetBoundaryFaceString (string envelope = null, List<string> uid = null, List<string> name = null, List<string> projects = null, List<string> spatialunit = null, List<string> tags = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null)

Returns a list of boundary face strings in a GeoJSON structure.

Returns a list of boundary face strings. A boundary face string is modeled as a GeoJSON feature.

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class GetBoundaryFaceStringExample
    {
        public void main()
        {
            var apiInstance = new BoundaryFaceStringApi();
            var envelope = envelope_example;  // string | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional) 
            var uid = new List<string>(); // List<string> | Comma separated list of Spatial unit UID (optional) 
            var name = new List<string>(); // List<string> | Comma separated list of AdminSources names (optional) 
            var projects = new List<string>(); // List<string> | Comma separated list of project UID (optional) 
            var spatialunit = new List<string>(); // List<string> | Comma separated list of SpatialSource UID (optional) 
            var tags = new List<string>(); // List<string> | Comma separated list of tags (optional) 
            var page = 56;  // int? | Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional) 
            var sort = sort_example;  // string | The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional) 
            var fields = new List<string>(); // List<string> | Comma separated list of tags (optional) 
            var embed = new List<string>(); // List<string> | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional) 

            try
            {
                // Returns a list of boundary face strings in a GeoJSON structure.
                BoundaryFaceStringEndpointType result = apiInstance.GetBoundaryFaceString(envelope, uid, name, projects, spatialunit, tags, page, sort, fields, embed);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling BoundaryFaceStringApi.GetBoundaryFaceString: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **envelope** | **string**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **uid** | [**List&lt;string&gt;**](string.md)| Comma separated list of Spatial unit UID | [optional] 
 **name** | [**List&lt;string&gt;**](string.md)| Comma separated list of AdminSources names | [optional] 
 **projects** | [**List&lt;string&gt;**](string.md)| Comma separated list of project UID | [optional] 
 **spatialunit** | [**List&lt;string&gt;**](string.md)| Comma separated list of SpatialSource UID | [optional] 
 **tags** | [**List&lt;string&gt;**](string.md)| Comma separated list of tags | [optional] 
 **page** | **int?**| Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. | [optional] 
 **sort** | **string**| The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. | [optional] 
 **fields** | [**List&lt;string&gt;**](string.md)| Comma separated list of tags | [optional] 
 **embed** | [**List&lt;string&gt;**](string.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional] 

### Return type

[**BoundaryFaceStringEndpointType**](BoundaryFaceStringEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="getboundaryfacestringbyuid"></a>
# **GetBoundaryFaceStringByUID**
> BoundaryFaceStringEndpointType GetBoundaryFaceStringByUID (string boundaryfacestringUid, string envelope = null, List<string> embed = null)

Returns a single boundary face string

Returns a boundary face string as GeoJSON as a feature in a GeoJSON structure.

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class GetBoundaryFaceStringByUIDExample
    {
        public void main()
        {
            var apiInstance = new BoundaryFaceStringApi();
            var boundaryfacestringUid = boundaryfacestringUid_example;  // string | Boundary face string UID
            var envelope = envelope_example;  // string | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional) 
            var embed = new List<string>(); // List<string> | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional) 

            try
            {
                // Returns a single boundary face string
                BoundaryFaceStringEndpointType result = apiInstance.GetBoundaryFaceStringByUID(boundaryfacestringUid, envelope, embed);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling BoundaryFaceStringApi.GetBoundaryFaceStringByUID: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **boundaryfacestringUid** | **string**| Boundary face string UID | 
 **envelope** | **string**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **embed** | [**List&lt;string&gt;**](string.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional] 

### Return type

[**BoundaryFaceStringEndpointType**](BoundaryFaceStringEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="newboundaryfacestring"></a>
# **NewBoundaryFaceString**
> BoundaryFaceStringEndpointType NewBoundaryFaceString (BoundaryFaceStringPostRequest newboundaryfacestring, string envelope = null, List<string> embed = null, string i4lProcessUid = null)

Create a new concept for a boundary face string

Create a new concept for a boundary face string.

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class NewBoundaryFaceStringExample
    {
        public void main()
        {
            var apiInstance = new BoundaryFaceStringApi();
            var newboundaryfacestring = new BoundaryFaceStringPostRequest(); // BoundaryFaceStringPostRequest | New boundary face string
            var envelope = envelope_example;  // string | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional) 
            var embed = new List<string>(); // List<string> | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional) 
            var i4lProcessUid = i4lProcessUid_example;  // string | Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional) 

            try
            {
                // Create a new concept for a boundary face string
                BoundaryFaceStringEndpointType result = apiInstance.NewBoundaryFaceString(newboundaryfacestring, envelope, embed, i4lProcessUid);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling BoundaryFaceStringApi.NewBoundaryFaceString: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **newboundaryfacestring** | [**BoundaryFaceStringPostRequest**](BoundaryFaceStringPostRequest.md)| New boundary face string | 
 **envelope** | **string**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **embed** | [**List&lt;string&gt;**](string.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional] 
 **i4lProcessUid** | **string**| Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. | [optional] 

### Return type

[**BoundaryFaceStringEndpointType**](BoundaryFaceStringEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="putboundaryfacestringbyuid"></a>
# **PutBoundaryFaceStringByUID**
> BoundaryFaceStringEndpointType PutBoundaryFaceStringByUID (string boundaryfacestringUid, BoundaryFaceStringPostRequest updatedboundaryfacestring, string envelope = null, List<string> embed = null, string i4lProcessUid = null)

Replace an existing BoundaryFaceString by a newer version

An existing BoundaryFaceString will be replaced by a newer version. The UID of BoundaryFaceString remains

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class PutBoundaryFaceStringByUIDExample
    {
        public void main()
        {
            var apiInstance = new BoundaryFaceStringApi();
            var boundaryfacestringUid = boundaryfacestringUid_example;  // string | Boundary face string UID
            var updatedboundaryfacestring = new BoundaryFaceStringPostRequest(); // BoundaryFaceStringPostRequest | Updated boundary face string
            var envelope = envelope_example;  // string | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional) 
            var embed = new List<string>(); // List<string> | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional) 
            var i4lProcessUid = i4lProcessUid_example;  // string | Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional) 

            try
            {
                // Replace an existing BoundaryFaceString by a newer version
                BoundaryFaceStringEndpointType result = apiInstance.PutBoundaryFaceStringByUID(boundaryfacestringUid, updatedboundaryfacestring, envelope, embed, i4lProcessUid);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling BoundaryFaceStringApi.PutBoundaryFaceStringByUID: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **boundaryfacestringUid** | **string**| Boundary face string UID | 
 **updatedboundaryfacestring** | [**BoundaryFaceStringPostRequest**](BoundaryFaceStringPostRequest.md)| Updated boundary face string | 
 **envelope** | **string**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **embed** | [**List&lt;string&gt;**](string.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional] 
 **i4lProcessUid** | **string**| Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. | [optional] 

### Return type

[**BoundaryFaceStringEndpointType**](BoundaryFaceStringEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="updateboundaryfacestring"></a>
# **UpdateBoundaryFaceString**
> BoundaryFaceStringEndpointType UpdateBoundaryFaceString (string boundaryfacestringUid, RFC6902PatchRequest patchboundaryfacestring, string envelope = null, string i4lProcessUid = null)

Updates a boundary face string

Updates a boundary face string

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class UpdateBoundaryFaceStringExample
    {
        public void main()
        {
            var apiInstance = new BoundaryFaceStringApi();
            var boundaryfacestringUid = boundaryfacestringUid_example;  // string | Boundary face string UID
            var patchboundaryfacestring = new RFC6902PatchRequest(); // RFC6902PatchRequest | Update data
            var envelope = envelope_example;  // string | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional) 
            var i4lProcessUid = i4lProcessUid_example;  // string | Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional) 

            try
            {
                // Updates a boundary face string
                BoundaryFaceStringEndpointType result = apiInstance.UpdateBoundaryFaceString(boundaryfacestringUid, patchboundaryfacestring, envelope, i4lProcessUid);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling BoundaryFaceStringApi.UpdateBoundaryFaceString: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **boundaryfacestringUid** | **string**| Boundary face string UID | 
 **patchboundaryfacestring** | [**RFC6902PatchRequest**](RFC6902PatchRequest.md)| Update data | 
 **envelope** | **string**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **i4lProcessUid** | **string**| Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. | [optional] 

### Return type

[**BoundaryFaceStringEndpointType**](BoundaryFaceStringEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

