# IO.Swagger.Api.ClassifierApi

All URIs are relative to *https://platform.its4land.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**GetClassifier**](ClassifierApi.md#getclassifier) | **GET** /classifier | Returns a list of classifier
[**GetClassifierByUID**](ClassifierApi.md#getclassifierbyuid) | **GET** /classifier/{classifier_id} | Returns a single classifier.
[**NewClassifier**](ClassifierApi.md#newclassifier) | **POST** /classifier | Create a new classifier


<a name="getclassifier"></a>
# **GetClassifier**
> List<ClassifierEndpointType> GetClassifier (string envelope = null, List<string> uid = null, List<string> name = null, List<string> models = null, List<string> tags = null, int? page = null, string sort = null, List<string> fields = null)

Returns a list of classifier

Returns a list of classifier

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class GetClassifierExample
    {
        public void main()
        {
            var apiInstance = new ClassifierApi();
            var envelope = envelope_example;  // string | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional) 
            var uid = new List<string>(); // List<string> | Comma separated list of classifier UID (optional) 
            var name = new List<string>(); // List<string> | Comma separated list of classifier names (optional) 
            var models = new List<string>(); // List<string> | Comma separated list of model UID (optional) 
            var tags = new List<string>(); // List<string> | Comma separated list of tags (optional) 
            var page = 56;  // int? | Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional) 
            var sort = sort_example;  // string | The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional) 
            var fields = new List<string>(); // List<string> | Comma separated list of field names (optional) 

            try
            {
                // Returns a list of classifier
                List&lt;ClassifierEndpointType&gt; result = apiInstance.GetClassifier(envelope, uid, name, models, tags, page, sort, fields);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ClassifierApi.GetClassifier: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **envelope** | **string**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **uid** | [**List&lt;string&gt;**](string.md)| Comma separated list of classifier UID | [optional] 
 **name** | [**List&lt;string&gt;**](string.md)| Comma separated list of classifier names | [optional] 
 **models** | [**List&lt;string&gt;**](string.md)| Comma separated list of model UID | [optional] 
 **tags** | [**List&lt;string&gt;**](string.md)| Comma separated list of tags | [optional] 
 **page** | **int?**| Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. | [optional] 
 **sort** | **string**| The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. | [optional] 
 **fields** | [**List&lt;string&gt;**](string.md)| Comma separated list of field names | [optional] 

### Return type

[**List<ClassifierEndpointType>**](ClassifierEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="getclassifierbyuid"></a>
# **GetClassifierByUID**
> ClassifierEndpointType GetClassifierByUID (string classifierId, string envelope = null)

Returns a single classifier.

Returns a single classifier.

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class GetClassifierByUIDExample
    {
        public void main()
        {
            var apiInstance = new ClassifierApi();
            var classifierId = classifierId_example;  // string | Classifier UID
            var envelope = envelope_example;  // string | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional) 

            try
            {
                // Returns a single classifier.
                ClassifierEndpointType result = apiInstance.GetClassifierByUID(classifierId, envelope);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ClassifierApi.GetClassifierByUID: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **classifierId** | **string**| Classifier UID | 
 **envelope** | **string**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 

### Return type

[**ClassifierEndpointType**](ClassifierEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="newclassifier"></a>
# **NewClassifier**
> ClassifierEndpointType NewClassifier (ClassifierPostRequest newclassifier, string envelope = null, string i4lProcessUid = null)

Create a new classifier

Create a new classifier. To add a new Classifier , the content of Classifier must be stored in advanced via the ContentItem endpoint

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class NewClassifierExample
    {
        public void main()
        {
            var apiInstance = new ClassifierApi();
            var newclassifier = new ClassifierPostRequest(); // ClassifierPostRequest | New Classifier data
            var envelope = envelope_example;  // string | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional) 
            var i4lProcessUid = i4lProcessUid_example;  // string | Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional) 

            try
            {
                // Create a new classifier
                ClassifierEndpointType result = apiInstance.NewClassifier(newclassifier, envelope, i4lProcessUid);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ClassifierApi.NewClassifier: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **newclassifier** | [**ClassifierPostRequest**](ClassifierPostRequest.md)| New Classifier data | 
 **envelope** | **string**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **i4lProcessUid** | **string**| Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. | [optional] 

### Return type

[**ClassifierEndpointType**](ClassifierEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

