# IO.Swagger.Api.ContentItemsApi

All URIs are relative to *https://platform.its4land.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**GetContentItem**](ContentItemsApi.md#getcontentitem) | **GET** /contentitems/{contentitem_id} | Returns a single content from the object storage.
[**GetContentItems**](ContentItemsApi.md#getcontentitems) | **GET** /contentitems | Returns a list of contentitems
[**NewContentItem**](ContentItemsApi.md#newcontentitem) | **POST** /contentitems | Create a new content in the object storage


<a name="getcontentitem"></a>
# **GetContentItem**
> System.IO.Stream GetContentItem (string contentitemId, string envelope = null)

Returns a single content from the object storage.

Returns a single content from the object storage.

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class GetContentItemExample
    {
        public void main()
        {
            var apiInstance = new ContentItemsApi();
            var contentitemId = contentitemId_example;  // string | UID of the ContentItem
            var envelope = envelope_example;  // string | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional) 

            try
            {
                // Returns a single content from the object storage.
                System.IO.Stream result = apiInstance.GetContentItem(contentitemId, envelope);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ContentItemsApi.GetContentItem: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **contentitemId** | **string**| UID of the ContentItem | 
 **envelope** | **string**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 

### Return type

**System.IO.Stream**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: multipart/form-data

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="getcontentitems"></a>
# **GetContentItems**
> List<ContentItemEndpointType> GetContentItems (string envelope = null, List<string> uid = null, List<string> contentname = null, List<string> contenttype = null, string contentdescription = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null)

Returns a list of contentitems

Returns a list of contentitem metadata based on the filter criteria

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class GetContentItemsExample
    {
        public void main()
        {
            var apiInstance = new ContentItemsApi();
            var envelope = envelope_example;  // string | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional) 
            var uid = new List<string>(); // List<string> | UID of a ContentItem (optional) 
            var contentname = new List<string>(); // List<string> | Name of File (optional) 
            var contenttype = new List<string>(); // List<string> | mime/type of the content (optional) 
            var contentdescription = contentdescription_example;  // string | Free text for description. Only plain text. (optional) 
            var page = 56;  // int? | Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional) 
            var sort = sort_example;  // string | The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional) 
            var fields = new List<string>(); // List<string> | Comma separated list of field names (optional) 
            var embed = new List<string>(); // List<string> | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional) 

            try
            {
                // Returns a list of contentitems
                List&lt;ContentItemEndpointType&gt; result = apiInstance.GetContentItems(envelope, uid, contentname, contenttype, contentdescription, page, sort, fields, embed);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ContentItemsApi.GetContentItems: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **envelope** | **string**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **uid** | [**List&lt;string&gt;**](string.md)| UID of a ContentItem | [optional] 
 **contentname** | [**List&lt;string&gt;**](string.md)| Name of File | [optional] 
 **contenttype** | [**List&lt;string&gt;**](string.md)| mime/type of the content | [optional] 
 **contentdescription** | **string**| Free text for description. Only plain text. | [optional] 
 **page** | **int?**| Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. | [optional] 
 **sort** | **string**| The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. | [optional] 
 **fields** | [**List&lt;string&gt;**](string.md)| Comma separated list of field names | [optional] 
 **embed** | [**List&lt;string&gt;**](string.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional] 

### Return type

[**List<ContentItemEndpointType>**](ContentItemEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="newcontentitem"></a>
# **NewContentItem**
> ContentItemEndpointType NewContentItem (System.IO.Stream newcontent, string envelope = null, string description = null, string i4lProcessUid = null)

Create a new content in the object storage

Create a new content in the object storage

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class NewContentItemExample
    {
        public void main()
        {
            var apiInstance = new ContentItemsApi();
            var newcontent = new System.IO.Stream(); // System.IO.Stream | Content as multipart from-data
            var envelope = envelope_example;  // string | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional) 
            var description = description_example;  // string | Description of content (optional) (optional) 
            var i4lProcessUid = i4lProcessUid_example;  // string | Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional) 

            try
            {
                // Create a new content in the object storage
                ContentItemEndpointType result = apiInstance.NewContentItem(newcontent, envelope, description, i4lProcessUid);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ContentItemsApi.NewContentItem: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **newcontent** | **System.IO.Stream**| Content as multipart from-data | 
 **envelope** | **string**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **description** | **string**| Description of content (optional) | [optional] 
 **i4lProcessUid** | **string**| Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. | [optional] 

### Return type

[**ContentItemEndpointType**](ContentItemEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

