# IO.Swagger.Api.MetricMapFeaturesApi

All URIs are relative to *https://platform.its4land.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**GetMetricMapFeature**](MetricMapFeaturesApi.md#getmetricmapfeature) | **GET** /metricmapfeature | Returns MetricMapFeature
[**NewMetricMapFeature**](MetricMapFeaturesApi.md#newmetricmapfeature) | **POST** /metricmapfeature | Create a new metricMapFeature
[**UpdateMetricMapFeature**](MetricMapFeaturesApi.md#updatemetricmapfeature) | **PATCH** /metricmapfeature/{mmf_uid} | Updates a metric map feature


<a name="getmetricmapfeature"></a>
# **GetMetricMapFeature**
> MetricMapFeaturesEndpointType GetMetricMapFeature (string querywindow, string envelope = null, string fgroup = null, string ftype = null, string fsubtype = null)

Returns MetricMapFeature

Returns MetricMapFeature in a GeoJSON structure. A metric map feature is modeled as a feature in  the GeoJSON structure.

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class GetMetricMapFeatureExample
    {
        public void main()
        {
            var apiInstance = new MetricMapFeaturesApi();
            var querywindow = querywindow_example;  // string | Polygon. The polygon is encoded a comma separated list of coordinates. X1, Y1, X2, Y2, ..., Xn, Yn, X1, Y1
            var envelope = envelope_example;  // string | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional) 
            var fgroup = fgroup_example;  // string | Restricts the output to the listed feature group (optional) 
            var ftype = ftype_example;  // string | Restricts the output to the listed feature types. When used in combination with fgroup, output contains only those ftype which are contained in the feature groups (optional) 
            var fsubtype = fsubtype_example;  // string | Restricts the output to the listed feature types. When used in combination with fgroup and/or ftype, output contains only those fsubtype which are contained in the feature groups and feature types (optional) 

            try
            {
                // Returns MetricMapFeature
                MetricMapFeaturesEndpointType result = apiInstance.GetMetricMapFeature(querywindow, envelope, fgroup, ftype, fsubtype);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling MetricMapFeaturesApi.GetMetricMapFeature: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **querywindow** | **string**| Polygon. The polygon is encoded a comma separated list of coordinates. X1, Y1, X2, Y2, ..., Xn, Yn, X1, Y1 | 
 **envelope** | **string**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **fgroup** | **string**| Restricts the output to the listed feature group | [optional] 
 **ftype** | **string**| Restricts the output to the listed feature types. When used in combination with fgroup, output contains only those ftype which are contained in the feature groups | [optional] 
 **fsubtype** | **string**| Restricts the output to the listed feature types. When used in combination with fgroup and/or ftype, output contains only those fsubtype which are contained in the feature groups and feature types | [optional] 

### Return type

[**MetricMapFeaturesEndpointType**](MetricMapFeaturesEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="newmetricmapfeature"></a>
# **NewMetricMapFeature**
> MetricMapFeaturesEndpointType NewMetricMapFeature (MetricMapFeaturePostRequest newmetricmapfeature, string envelope = null, string i4lProcessUid = null)

Create a new metricMapFeature

Create a new MetricMapFeature. The new metric map feature is a feature in the GeoJSON structure. Currently ony one new feature per request is allowed.

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class NewMetricMapFeatureExample
    {
        public void main()
        {
            var apiInstance = new MetricMapFeaturesApi();
            var newmetricmapfeature = new MetricMapFeaturePostRequest(); // MetricMapFeaturePostRequest | New MetricMap Feature data
            var envelope = envelope_example;  // string | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional) 
            var i4lProcessUid = i4lProcessUid_example;  // string | Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional) 

            try
            {
                // Create a new metricMapFeature
                MetricMapFeaturesEndpointType result = apiInstance.NewMetricMapFeature(newmetricmapfeature, envelope, i4lProcessUid);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling MetricMapFeaturesApi.NewMetricMapFeature: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **newmetricmapfeature** | [**MetricMapFeaturePostRequest**](MetricMapFeaturePostRequest.md)| New MetricMap Feature data | 
 **envelope** | **string**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **i4lProcessUid** | **string**| Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. | [optional] 

### Return type

[**MetricMapFeaturesEndpointType**](MetricMapFeaturesEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="updatemetricmapfeature"></a>
# **UpdateMetricMapFeature**
> MetricMapFeaturesEndpointType UpdateMetricMapFeature (string mmfUid, RFC6902PatchRequest patchmetricmapfeature, string envelope = null, string i4lProcessUid = null)

Updates a metric map feature

Updates a metric map feature. Only fgroup, fname, ftype, fsubtype and fURI can be updated

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class UpdateMetricMapFeatureExample
    {
        public void main()
        {
            var apiInstance = new MetricMapFeaturesApi();
            var mmfUid = mmfUid_example;  // string | MetricMapFeature UID
            var patchmetricmapfeature = new RFC6902PatchRequest(); // RFC6902PatchRequest | Update data
            var envelope = envelope_example;  // string | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional) 
            var i4lProcessUid = i4lProcessUid_example;  // string | Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional) 

            try
            {
                // Updates a metric map feature
                MetricMapFeaturesEndpointType result = apiInstance.UpdateMetricMapFeature(mmfUid, patchmetricmapfeature, envelope, i4lProcessUid);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling MetricMapFeaturesApi.UpdateMetricMapFeature: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **mmfUid** | **string**| MetricMapFeature UID | 
 **patchmetricmapfeature** | [**RFC6902PatchRequest**](RFC6902PatchRequest.md)| Update data | 
 **envelope** | **string**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **i4lProcessUid** | **string**| Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. | [optional] 

### Return type

[**MetricMapFeaturesEndpointType**](MetricMapFeaturesEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

