# IO.Swagger.Api.ProcessesApi

All URIs are relative to *https://platform.its4land.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**CreateProcessLog**](ProcessesApi.md#createprocesslog) | **POST** /processes/{process_uid}/log | Writes a single log entry
[**CreateProcesses**](ProcessesApi.md#createprocesses) | **POST** /processes | Creates a new  processes
[**GetProcessByUID**](ProcessesApi.md#getprocessbyuid) | **GET** /processes/{process_uid} | Returns metadata for a single process
[**GetProcessLog**](ProcessesApi.md#getprocesslog) | **GET** /processes/{process_uid}/log | Get the full log of a process
[**GetProcesses**](ProcessesApi.md#getprocesses) | **GET** /processes | Get a list of processes


<a name="createprocesslog"></a>
# **CreateProcessLog**
> LogEntryEndpointType CreateProcessLog (string processUid, LogEntryPostRequest newlogentry, string envelope = null, string i4lProcessUid = null)

Writes a single log entry

Writes a single log entry

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class CreateProcessLogExample
    {
        public void main()
        {
            var apiInstance = new ProcessesApi();
            var processUid = processUid_example;  // string | Process UID
            var newlogentry = new LogEntryPostRequest(); // LogEntryPostRequest | New log entry
            var envelope = envelope_example;  // string | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional) 
            var i4lProcessUid = i4lProcessUid_example;  // string | Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional) 

            try
            {
                // Writes a single log entry
                LogEntryEndpointType result = apiInstance.CreateProcessLog(processUid, newlogentry, envelope, i4lProcessUid);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ProcessesApi.CreateProcessLog: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **processUid** | **string**| Process UID | 
 **newlogentry** | [**LogEntryPostRequest**](LogEntryPostRequest.md)| New log entry | 
 **envelope** | **string**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **i4lProcessUid** | **string**| Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. | [optional] 

### Return type

[**LogEntryEndpointType**](LogEntryEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="createprocesses"></a>
# **CreateProcesses**
> ProcessEndpointType CreateProcesses (ProcessPostRequest newprocess, string envelope = null, List<string> embed = null, string i4lProcessUid = null)

Creates a new  processes

Creates a new  processes

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class CreateProcessesExample
    {
        public void main()
        {
            var apiInstance = new ProcessesApi();
            var newprocess = new ProcessPostRequest(); // ProcessPostRequest | New process metadata
            var envelope = envelope_example;  // string | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional) 
            var embed = new List<string>(); // List<string> | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional) 
            var i4lProcessUid = i4lProcessUid_example;  // string | Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional) 

            try
            {
                // Creates a new  processes
                ProcessEndpointType result = apiInstance.CreateProcesses(newprocess, envelope, embed, i4lProcessUid);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ProcessesApi.CreateProcesses: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **newprocess** | [**ProcessPostRequest**](ProcessPostRequest.md)| New process metadata | 
 **envelope** | **string**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **embed** | [**List&lt;string&gt;**](string.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional] 
 **i4lProcessUid** | **string**| Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. | [optional] 

### Return type

[**ProcessEndpointType**](ProcessEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="getprocessbyuid"></a>
# **GetProcessByUID**
> ProcessEndpointType GetProcessByUID (string processUid, string envelope = null, List<string> embed = null)

Returns metadata for a single process

Returns metadata for a single process

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class GetProcessByUIDExample
    {
        public void main()
        {
            var apiInstance = new ProcessesApi();
            var processUid = processUid_example;  // string | Process UID
            var envelope = envelope_example;  // string | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional) 
            var embed = new List<string>(); // List<string> | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional) 

            try
            {
                // Returns metadata for a single process
                ProcessEndpointType result = apiInstance.GetProcessByUID(processUid, envelope, embed);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ProcessesApi.GetProcessByUID: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **processUid** | **string**| Process UID | 
 **envelope** | **string**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **embed** | [**List&lt;string&gt;**](string.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional] 

### Return type

[**ProcessEndpointType**](ProcessEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="getprocesslog"></a>
# **GetProcessLog**
> List<LogEntryEndpointType> GetProcessLog (string processUid, string envelope = null, List<string> loglevel = null, List<string> logsource = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null)

Get the full log of a process

Get the full log of a process. Oldest entry first

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class GetProcessLogExample
    {
        public void main()
        {
            var apiInstance = new ProcessesApi();
            var processUid = processUid_example;  // string | Process UID
            var envelope = envelope_example;  // string | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional) 
            var loglevel = new List<string>(); // List<string> | LogLevel : error, info, warning, debug. Default is info. The higher order level includes the lower level (optional) 
            var logsource = new List<string>(); // List<string> | Source of the log entry. Values: GUI, <ToolName> (optional) 
            var page = 56;  // int? | Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional) 
            var sort = sort_example;  // string | The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional) 
            var fields = new List<string>(); // List<string> | Comma separated list of field names (optional) 
            var embed = new List<string>(); // List<string> | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional) 

            try
            {
                // Get the full log of a process
                List&lt;LogEntryEndpointType&gt; result = apiInstance.GetProcessLog(processUid, envelope, loglevel, logsource, page, sort, fields, embed);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ProcessesApi.GetProcessLog: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **processUid** | **string**| Process UID | 
 **envelope** | **string**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **loglevel** | [**List&lt;string&gt;**](string.md)| LogLevel : error, info, warning, debug. Default is info. The higher order level includes the lower level | [optional] 
 **logsource** | [**List&lt;string&gt;**](string.md)| Source of the log entry. Values: GUI, &lt;ToolName&gt; | [optional] 
 **page** | **int?**| Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. | [optional] 
 **sort** | **string**| The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. | [optional] 
 **fields** | [**List&lt;string&gt;**](string.md)| Comma separated list of field names | [optional] 
 **embed** | [**List&lt;string&gt;**](string.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional] 

### Return type

[**List<LogEntryEndpointType>**](LogEntryEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="getprocesses"></a>
# **GetProcesses**
> List<ProcessEndpointType> GetProcesses (string envelope = null, List<string> uid = null, List<string> project = null, string status = null, List<string> tooluid = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null)

Get a list of processes

Get a list of processes

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class GetProcessesExample
    {
        public void main()
        {
            var apiInstance = new ProcessesApi();
            var envelope = envelope_example;  // string | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional) 
            var uid = new List<string>(); // List<string> | Comma separated list of Tag UID (optional) 
            var project = new List<string>(); // List<string> | Comma separated list of project uid (optional) 
            var status = status_example;  // string | Status of the project. Can be one of:   * WAITING: Process is queued for execution   * RUNNING: Process is currently executing   * FINISHED: Process terminated normally   * ABORTED: Process terminated unexpectedly   * ZOMBIE: Process is listed in the platform process table, but the internal (process) API has no information about it. Possible in case of historical/archived processes or due to platform error.  (optional) 
            var tooluid = new List<string>(); // List<string> | Comma separated list of tool UID (optional) 
            var page = 56;  // int? | Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional) 
            var sort = sort_example;  // string | The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional) 
            var fields = new List<string>(); // List<string> | Comma separated list of fields (optional) 
            var embed = new List<string>(); // List<string> | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional) 

            try
            {
                // Get a list of processes
                List&lt;ProcessEndpointType&gt; result = apiInstance.GetProcesses(envelope, uid, project, status, tooluid, page, sort, fields, embed);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ProcessesApi.GetProcesses: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **envelope** | **string**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **uid** | [**List&lt;string&gt;**](string.md)| Comma separated list of Tag UID | [optional] 
 **project** | [**List&lt;string&gt;**](string.md)| Comma separated list of project uid | [optional] 
 **status** | **string**| Status of the project. Can be one of:   * WAITING: Process is queued for execution   * RUNNING: Process is currently executing   * FINISHED: Process terminated normally   * ABORTED: Process terminated unexpectedly   * ZOMBIE: Process is listed in the platform process table, but the internal (process) API has no information about it. Possible in case of historical/archived processes or due to platform error.  | [optional] 
 **tooluid** | [**List&lt;string&gt;**](string.md)| Comma separated list of tool UID | [optional] 
 **page** | **int?**| Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. | [optional] 
 **sort** | **string**| The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. | [optional] 
 **fields** | [**List&lt;string&gt;**](string.md)| Comma separated list of fields | [optional] 
 **embed** | [**List&lt;string&gt;**](string.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional] 

### Return type

[**List<ProcessEndpointType>**](ProcessEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

