# IO.Swagger.Api.SpatialUnitsApi

All URIs are relative to *https://platform.its4land.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**Create2PpolygonSPUfromBFS**](SpatialUnitsApi.md#create2ppolygonspufrombfs) | **POST** /spatialunits/create2Dpolygonspatialunit | Creates a spatial unit
[**GetSpatialUnitByUID**](SpatialUnitsApi.md#getspatialunitbyuid) | **GET** /spatialunits/qualitative/{spatialunit_uid} | Returns a single spatial unit
[**GetSpatialUnitConceptByUID**](SpatialUnitsApi.md#getspatialunitconceptbyuid) | **GET** /spatialunits/concepts/{concept_uid} | Returns a single spatial unit concept
[**GetSpatialUnits**](SpatialUnitsApi.md#getspatialunits) | **GET** /spatialunits | Returns a list of SpatialUnits in a GeoJSON structure.
[**GetSpatialUnitsByUUID**](SpatialUnitsApi.md#getspatialunitsbyuuid) | **GET** /spatialunits/{spatialunit_uid} | Returns a list of SpatialUnits
[**GetSpatialUnitsConcepts**](SpatialUnitsApi.md#getspatialunitsconcepts) | **GET** /spatialunits/concepts | Returns a list of spatial units concepts
[**GetSpatialUnitsQualitative**](SpatialUnitsApi.md#getspatialunitsqualitative) | **GET** /spatialunits/qualitative | Returns a list of SpatialUnits
[**NewSpatialUnit**](SpatialUnitsApi.md#newspatialunit) | **POST** /spatialunits | Create a new SpatialUnit
[**NewSpatialUnitConcept**](SpatialUnitsApi.md#newspatialunitconcept) | **POST** /spatialunits/concepts | Create a new concept for a spatial unit
[**NewSpatialUnitQualitative**](SpatialUnitsApi.md#newspatialunitqualitative) | **POST** /spatialunits/qualitative | Create a new SpatialUnit
[**UpdateSpatialUnit**](SpatialUnitsApi.md#updatespatialunit) | **PATCH** /spatialunits/{spatialunit_uid} | Update an spatial unit
[**UpdateSpatialUnitConcept**](SpatialUnitsApi.md#updatespatialunitconcept) | **PATCH** /spatialunits/concepts/{concept_uid} | Updates a new spatial unit concept
[**UpdateSpatialUnitQualitative**](SpatialUnitsApi.md#updatespatialunitqualitative) | **PATCH** /spatialunits/qualitative/{spatialunit_uid} | Updates a new SpatialUnit


<a name="create2ppolygonspufrombfs"></a>
# **Create2PpolygonSPUfromBFS**
> SpatialUnitsFeatureEndpointType Create2PpolygonSPUfromBFS (SpatialUnitBaseFeaturePostRequest spatialunitdata, string envelope = null, string i4lProcessUid = null, List<string> embed = null)

Creates a spatial unit

Create a 2D polygon base spatial unit from a boundary face string  as GeoJSON

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class Create2PpolygonSPUfromBFSExample
    {
        public void main()
        {
            var apiInstance = new SpatialUnitsApi();
            var spatialunitdata = new SpatialUnitBaseFeaturePostRequest(); // SpatialUnitBaseFeaturePostRequest | Update data
            var envelope = envelope_example;  // string | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional) 
            var i4lProcessUid = i4lProcessUid_example;  // string | Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional) 
            var embed = new List<string>(); // List<string> | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional) 

            try
            {
                // Creates a spatial unit
                SpatialUnitsFeatureEndpointType result = apiInstance.Create2PpolygonSPUfromBFS(spatialunitdata, envelope, i4lProcessUid, embed);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling SpatialUnitsApi.Create2PpolygonSPUfromBFS: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **spatialunitdata** | [**SpatialUnitBaseFeaturePostRequest**](SpatialUnitBaseFeaturePostRequest.md)| Update data | 
 **envelope** | **string**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **i4lProcessUid** | **string**| Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. | [optional] 
 **embed** | [**List&lt;string&gt;**](string.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional] 

### Return type

[**SpatialUnitsFeatureEndpointType**](SpatialUnitsFeatureEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="getspatialunitbyuid"></a>
# **GetSpatialUnitByUID**
> SpatialUnitsFeatureEndpointType GetSpatialUnitByUID (string spatialunitUid, string envelope = null, List<string> embed = null)

Returns a single spatial unit

Returns a single spatial unit with qualitative base qualitative base spatial profile

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class GetSpatialUnitByUIDExample
    {
        public void main()
        {
            var apiInstance = new SpatialUnitsApi();
            var spatialunitUid = spatialunitUid_example;  // string | Spatial unit UID
            var envelope = envelope_example;  // string | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional) 
            var embed = new List<string>(); // List<string> | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional) 

            try
            {
                // Returns a single spatial unit
                SpatialUnitsFeatureEndpointType result = apiInstance.GetSpatialUnitByUID(spatialunitUid, envelope, embed);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling SpatialUnitsApi.GetSpatialUnitByUID: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **spatialunitUid** | **string**| Spatial unit UID | 
 **envelope** | **string**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **embed** | [**List&lt;string&gt;**](string.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional] 

### Return type

[**SpatialUnitsFeatureEndpointType**](SpatialUnitsFeatureEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="getspatialunitconceptbyuid"></a>
# **GetSpatialUnitConceptByUID**
> SpatialUnitConceptEndpointType GetSpatialUnitConceptByUID (string conceptUid, string envelope = null, List<string> embed = null)

Returns a single spatial unit concept

Returns a single spatial unit concept

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class GetSpatialUnitConceptByUIDExample
    {
        public void main()
        {
            var apiInstance = new SpatialUnitsApi();
            var conceptUid = conceptUid_example;  // string | Spatial unit concept UID
            var envelope = envelope_example;  // string | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional) 
            var embed = new List<string>(); // List<string> | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional) 

            try
            {
                // Returns a single spatial unit concept
                SpatialUnitConceptEndpointType result = apiInstance.GetSpatialUnitConceptByUID(conceptUid, envelope, embed);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling SpatialUnitsApi.GetSpatialUnitConceptByUID: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **conceptUid** | **string**| Spatial unit concept UID | 
 **envelope** | **string**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **embed** | [**List&lt;string&gt;**](string.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional] 

### Return type

[**SpatialUnitConceptEndpointType**](SpatialUnitConceptEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="getspatialunits"></a>
# **GetSpatialUnits**
> List<SpatialUnitsFeatureEndpointType> GetSpatialUnits (string querywindow, string envelope = null, List<string> uid = null, List<string> name = null, List<string> concept = null, List<string> level = null, List<string> projects = null, List<string> adminsource = null, List<string> tags = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null)

Returns a list of SpatialUnits in a GeoJSON structure.

Returns a list of SpatialUnits as GeoJSON feature with 2D polygon base spatial profile

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class GetSpatialUnitsExample
    {
        public void main()
        {
            var apiInstance = new SpatialUnitsApi();
            var querywindow = querywindow_example;  // string | Polygon. The polygon is encoded a comma separated list of coordinates. X1, Y1, X2, Y2, ..., Xn, Yn, X1, Y1
            var envelope = envelope_example;  // string | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional) 
            var uid = new List<string>(); // List<string> | Comma separated list of AdminSources UID (optional) 
            var name = new List<string>(); // List<string> | Comma separated list of AdminSources names (optional) 
            var concept = new List<string>(); // List<string> | Comma separated list of Spatial Unit concepts (optional) 
            var level = new List<string>(); // List<string> | Comma separated list of LADM Levels (optional) 
            var projects = new List<string>(); // List<string> | Comma separated list of project UID (optional) 
            var adminsource = new List<string>(); // List<string> | Comma separated list of SpatialSource UID (optional) 
            var tags = new List<string>(); // List<string> | Comma separated list of tags (optional) 
            var page = 56;  // int? | Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional) 
            var sort = sort_example;  // string | The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional) 
            var fields = new List<string>(); // List<string> | Comma separated list of tags (optional) 
            var embed = new List<string>(); // List<string> | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional) 

            try
            {
                // Returns a list of SpatialUnits in a GeoJSON structure.
                List&lt;SpatialUnitsFeatureEndpointType&gt; result = apiInstance.GetSpatialUnits(querywindow, envelope, uid, name, concept, level, projects, adminsource, tags, page, sort, fields, embed);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling SpatialUnitsApi.GetSpatialUnits: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **querywindow** | **string**| Polygon. The polygon is encoded a comma separated list of coordinates. X1, Y1, X2, Y2, ..., Xn, Yn, X1, Y1 | 
 **envelope** | **string**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **uid** | [**List&lt;string&gt;**](string.md)| Comma separated list of AdminSources UID | [optional] 
 **name** | [**List&lt;string&gt;**](string.md)| Comma separated list of AdminSources names | [optional] 
 **concept** | [**List&lt;string&gt;**](string.md)| Comma separated list of Spatial Unit concepts | [optional] 
 **level** | [**List&lt;string&gt;**](string.md)| Comma separated list of LADM Levels | [optional] 
 **projects** | [**List&lt;string&gt;**](string.md)| Comma separated list of project UID | [optional] 
 **adminsource** | [**List&lt;string&gt;**](string.md)| Comma separated list of SpatialSource UID | [optional] 
 **tags** | [**List&lt;string&gt;**](string.md)| Comma separated list of tags | [optional] 
 **page** | **int?**| Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. | [optional] 
 **sort** | **string**| The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. | [optional] 
 **fields** | [**List&lt;string&gt;**](string.md)| Comma separated list of tags | [optional] 
 **embed** | [**List&lt;string&gt;**](string.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional] 

### Return type

[**List<SpatialUnitsFeatureEndpointType>**](SpatialUnitsFeatureEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="getspatialunitsbyuuid"></a>
# **GetSpatialUnitsByUUID**
> List<SpatialUnitsFeatureEndpointType> GetSpatialUnitsByUUID (string spatialunitUid, string envelope = null, List<string> embed = null)

Returns a list of SpatialUnits

Returns a list of SpatialUnits as feature with 2d polygon base spatial profile

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class GetSpatialUnitsByUUIDExample
    {
        public void main()
        {
            var apiInstance = new SpatialUnitsApi();
            var spatialunitUid = spatialunitUid_example;  // string | Spatial unit UID
            var envelope = envelope_example;  // string | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional) 
            var embed = new List<string>(); // List<string> | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional) 

            try
            {
                // Returns a list of SpatialUnits
                List&lt;SpatialUnitsFeatureEndpointType&gt; result = apiInstance.GetSpatialUnitsByUUID(spatialunitUid, envelope, embed);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling SpatialUnitsApi.GetSpatialUnitsByUUID: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **spatialunitUid** | **string**| Spatial unit UID | 
 **envelope** | **string**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **embed** | [**List&lt;string&gt;**](string.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional] 

### Return type

[**List<SpatialUnitsFeatureEndpointType>**](SpatialUnitsFeatureEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="getspatialunitsconcepts"></a>
# **GetSpatialUnitsConcepts**
> List<SpatialUnitsFeatureEndpointType> GetSpatialUnitsConcepts (string envelope = null, List<string> uid = null, List<string> name = null, List<string> projects = null, List<string> spatialunit = null, List<string> tags = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null)

Returns a list of spatial units concepts

Returns a list of spatial units concepts

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class GetSpatialUnitsConceptsExample
    {
        public void main()
        {
            var apiInstance = new SpatialUnitsApi();
            var envelope = envelope_example;  // string | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional) 
            var uid = new List<string>(); // List<string> | Comma separated list of Spatial unit UID (optional) 
            var name = new List<string>(); // List<string> | Comma separated list of AdminSources names (optional) 
            var projects = new List<string>(); // List<string> | Comma separated list of project UID (optional) 
            var spatialunit = new List<string>(); // List<string> | Comma separated list of SpatialSource UID (optional) 
            var tags = new List<string>(); // List<string> | Comma separated list of tags (optional) 
            var page = 56;  // int? | Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional) 
            var sort = sort_example;  // string | The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional) 
            var fields = new List<string>(); // List<string> | Comma separated list of tags (optional) 
            var embed = new List<string>(); // List<string> | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional) 

            try
            {
                // Returns a list of spatial units concepts
                List&lt;SpatialUnitsFeatureEndpointType&gt; result = apiInstance.GetSpatialUnitsConcepts(envelope, uid, name, projects, spatialunit, tags, page, sort, fields, embed);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling SpatialUnitsApi.GetSpatialUnitsConcepts: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **envelope** | **string**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **uid** | [**List&lt;string&gt;**](string.md)| Comma separated list of Spatial unit UID | [optional] 
 **name** | [**List&lt;string&gt;**](string.md)| Comma separated list of AdminSources names | [optional] 
 **projects** | [**List&lt;string&gt;**](string.md)| Comma separated list of project UID | [optional] 
 **spatialunit** | [**List&lt;string&gt;**](string.md)| Comma separated list of SpatialSource UID | [optional] 
 **tags** | [**List&lt;string&gt;**](string.md)| Comma separated list of tags | [optional] 
 **page** | **int?**| Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. | [optional] 
 **sort** | **string**| The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. | [optional] 
 **fields** | [**List&lt;string&gt;**](string.md)| Comma separated list of tags | [optional] 
 **embed** | [**List&lt;string&gt;**](string.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional] 

### Return type

[**List<SpatialUnitsFeatureEndpointType>**](SpatialUnitsFeatureEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="getspatialunitsqualitative"></a>
# **GetSpatialUnitsQualitative**
> List<SpatialUnitsFeatureEndpointType> GetSpatialUnitsQualitative (string querywindow, string envelope = null, List<string> uid = null, List<string> name = null, List<string> concept = null, List<string> level = null, List<string> projects = null, List<string> adminsource = null, List<string> tags = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null)

Returns a list of SpatialUnits

Returns a list of SpatialUnits as feature with geometry

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class GetSpatialUnitsQualitativeExample
    {
        public void main()
        {
            var apiInstance = new SpatialUnitsApi();
            var querywindow = querywindow_example;  // string | Polygon. The polygon is encoded a comma separated list of coordinates. X1, Y1, X2, Y2, ..., Xn, Yn, X1, Y1
            var envelope = envelope_example;  // string | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional) 
            var uid = new List<string>(); // List<string> | Comma separated list of Spatial unit UID (optional) 
            var name = new List<string>(); // List<string> | Comma separated list of AdminSources names (optional) 
            var concept = new List<string>(); // List<string> | Comma separated list of Spatial Unit concepts (optional) 
            var level = new List<string>(); // List<string> | Comma separated list of LADM Levels (optional) 
            var projects = new List<string>(); // List<string> | Comma separated list of project UID (optional) 
            var adminsource = new List<string>(); // List<string> | Comma separated list of SpatialSource UID (optional) 
            var tags = new List<string>(); // List<string> | Comma separated list of tags (optional) 
            var page = 56;  // int? | Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional) 
            var sort = sort_example;  // string | The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional) 
            var fields = new List<string>(); // List<string> | Comma separated list of tags (optional) 
            var embed = new List<string>(); // List<string> | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional) 

            try
            {
                // Returns a list of SpatialUnits
                List&lt;SpatialUnitsFeatureEndpointType&gt; result = apiInstance.GetSpatialUnitsQualitative(querywindow, envelope, uid, name, concept, level, projects, adminsource, tags, page, sort, fields, embed);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling SpatialUnitsApi.GetSpatialUnitsQualitative: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **querywindow** | **string**| Polygon. The polygon is encoded a comma separated list of coordinates. X1, Y1, X2, Y2, ..., Xn, Yn, X1, Y1 | 
 **envelope** | **string**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **uid** | [**List&lt;string&gt;**](string.md)| Comma separated list of Spatial unit UID | [optional] 
 **name** | [**List&lt;string&gt;**](string.md)| Comma separated list of AdminSources names | [optional] 
 **concept** | [**List&lt;string&gt;**](string.md)| Comma separated list of Spatial Unit concepts | [optional] 
 **level** | [**List&lt;string&gt;**](string.md)| Comma separated list of LADM Levels | [optional] 
 **projects** | [**List&lt;string&gt;**](string.md)| Comma separated list of project UID | [optional] 
 **adminsource** | [**List&lt;string&gt;**](string.md)| Comma separated list of SpatialSource UID | [optional] 
 **tags** | [**List&lt;string&gt;**](string.md)| Comma separated list of tags | [optional] 
 **page** | **int?**| Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. | [optional] 
 **sort** | **string**| The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. | [optional] 
 **fields** | [**List&lt;string&gt;**](string.md)| Comma separated list of tags | [optional] 
 **embed** | [**List&lt;string&gt;**](string.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional] 

### Return type

[**List<SpatialUnitsFeatureEndpointType>**](SpatialUnitsFeatureEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="newspatialunit"></a>
# **NewSpatialUnit**
> SpatialUnitsFeatureEndpointType NewSpatialUnit (SpatialUnitsFeaturePostRequest newspatialunit, string envelope = null, List<string> embed = null, string i4lProcessUid = null)

Create a new SpatialUnit

Create a new SpatialUnit with 2d polygon base spatial profile. The spatial unit is modeled as a GeoJSON feature. The endpoint currently allows only one spatial unit per request.

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class NewSpatialUnitExample
    {
        public void main()
        {
            var apiInstance = new SpatialUnitsApi();
            var newspatialunit = new SpatialUnitsFeaturePostRequest(); // SpatialUnitsFeaturePostRequest | New Spatial Unit data
            var envelope = envelope_example;  // string | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional) 
            var embed = new List<string>(); // List<string> | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional) 
            var i4lProcessUid = i4lProcessUid_example;  // string | Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional) 

            try
            {
                // Create a new SpatialUnit
                SpatialUnitsFeatureEndpointType result = apiInstance.NewSpatialUnit(newspatialunit, envelope, embed, i4lProcessUid);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling SpatialUnitsApi.NewSpatialUnit: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **newspatialunit** | [**SpatialUnitsFeaturePostRequest**](SpatialUnitsFeaturePostRequest.md)| New Spatial Unit data | 
 **envelope** | **string**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **embed** | [**List&lt;string&gt;**](string.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional] 
 **i4lProcessUid** | **string**| Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. | [optional] 

### Return type

[**SpatialUnitsFeatureEndpointType**](SpatialUnitsFeatureEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="newspatialunitconcept"></a>
# **NewSpatialUnitConcept**
> SpatialUnitConceptEndpointType NewSpatialUnitConcept (SpatialUnitConceptPostRequest newspatialunitconcept, string envelope = null, List<string> embed = null, string i4lProcessUid = null)

Create a new concept for a spatial unit

Create a new concept for a spatial unit.

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class NewSpatialUnitConceptExample
    {
        public void main()
        {
            var apiInstance = new SpatialUnitsApi();
            var newspatialunitconcept = new SpatialUnitConceptPostRequest(); // SpatialUnitConceptPostRequest | New Spatial Unit concept data
            var envelope = envelope_example;  // string | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional) 
            var embed = new List<string>(); // List<string> | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional) 
            var i4lProcessUid = i4lProcessUid_example;  // string | Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional) 

            try
            {
                // Create a new concept for a spatial unit
                SpatialUnitConceptEndpointType result = apiInstance.NewSpatialUnitConcept(newspatialunitconcept, envelope, embed, i4lProcessUid);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling SpatialUnitsApi.NewSpatialUnitConcept: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **newspatialunitconcept** | [**SpatialUnitConceptPostRequest**](SpatialUnitConceptPostRequest.md)| New Spatial Unit concept data | 
 **envelope** | **string**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **embed** | [**List&lt;string&gt;**](string.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional] 
 **i4lProcessUid** | **string**| Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. | [optional] 

### Return type

[**SpatialUnitConceptEndpointType**](SpatialUnitConceptEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="newspatialunitqualitative"></a>
# **NewSpatialUnitQualitative**
> SpatialUnitsFeatureEndpointType NewSpatialUnitQualitative (SpatialUnitsFeaturePostRequest newspatialunit, string envelope = null, List<string> embed = null, string i4lProcessUid = null)

Create a new SpatialUnit

Create a new SpatialUnit with qualitative base spatial profile

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class NewSpatialUnitQualitativeExample
    {
        public void main()
        {
            var apiInstance = new SpatialUnitsApi();
            var newspatialunit = new SpatialUnitsFeaturePostRequest(); // SpatialUnitsFeaturePostRequest | New Spatial Unit data
            var envelope = envelope_example;  // string | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional) 
            var embed = new List<string>(); // List<string> | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional) 
            var i4lProcessUid = i4lProcessUid_example;  // string | Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional) 

            try
            {
                // Create a new SpatialUnit
                SpatialUnitsFeatureEndpointType result = apiInstance.NewSpatialUnitQualitative(newspatialunit, envelope, embed, i4lProcessUid);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling SpatialUnitsApi.NewSpatialUnitQualitative: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **newspatialunit** | [**SpatialUnitsFeaturePostRequest**](SpatialUnitsFeaturePostRequest.md)| New Spatial Unit data | 
 **envelope** | **string**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **embed** | [**List&lt;string&gt;**](string.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional] 
 **i4lProcessUid** | **string**| Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. | [optional] 

### Return type

[**SpatialUnitsFeatureEndpointType**](SpatialUnitsFeatureEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="updatespatialunit"></a>
# **UpdateSpatialUnit**
> SpatialUnitsFeatureEndpointType UpdateSpatialUnit (string spatialunitUid, RFC6902PatchRequest patchspatialunit, string envelope = null, string i4lProcessUid = null)

Update an spatial unit

Update an spatial unit with 2d polygon base spatial profile

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class UpdateSpatialUnitExample
    {
        public void main()
        {
            var apiInstance = new SpatialUnitsApi();
            var spatialunitUid = spatialunitUid_example;  // string | Spatial unit UID
            var patchspatialunit = new RFC6902PatchRequest(); // RFC6902PatchRequest | Update data
            var envelope = envelope_example;  // string | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional) 
            var i4lProcessUid = i4lProcessUid_example;  // string | Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional) 

            try
            {
                // Update an spatial unit
                SpatialUnitsFeatureEndpointType result = apiInstance.UpdateSpatialUnit(spatialunitUid, patchspatialunit, envelope, i4lProcessUid);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling SpatialUnitsApi.UpdateSpatialUnit: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **spatialunitUid** | **string**| Spatial unit UID | 
 **patchspatialunit** | [**RFC6902PatchRequest**](RFC6902PatchRequest.md)| Update data | 
 **envelope** | **string**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **i4lProcessUid** | **string**| Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. | [optional] 

### Return type

[**SpatialUnitsFeatureEndpointType**](SpatialUnitsFeatureEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="updatespatialunitconcept"></a>
# **UpdateSpatialUnitConcept**
> SpatialUnitConceptEndpointType UpdateSpatialUnitConcept (string conceptUid, RFC6902PatchRequest patchspatialunitconcept, string envelope = null, string i4lProcessUid = null)

Updates a new spatial unit concept

Updates a spatial unit concept

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class UpdateSpatialUnitConceptExample
    {
        public void main()
        {
            var apiInstance = new SpatialUnitsApi();
            var conceptUid = conceptUid_example;  // string | Spatial unit concept UID
            var patchspatialunitconcept = new RFC6902PatchRequest(); // RFC6902PatchRequest | Update data
            var envelope = envelope_example;  // string | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional) 
            var i4lProcessUid = i4lProcessUid_example;  // string | Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional) 

            try
            {
                // Updates a new spatial unit concept
                SpatialUnitConceptEndpointType result = apiInstance.UpdateSpatialUnitConcept(conceptUid, patchspatialunitconcept, envelope, i4lProcessUid);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling SpatialUnitsApi.UpdateSpatialUnitConcept: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **conceptUid** | **string**| Spatial unit concept UID | 
 **patchspatialunitconcept** | [**RFC6902PatchRequest**](RFC6902PatchRequest.md)| Update data | 
 **envelope** | **string**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **i4lProcessUid** | **string**| Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. | [optional] 

### Return type

[**SpatialUnitConceptEndpointType**](SpatialUnitConceptEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="updatespatialunitqualitative"></a>
# **UpdateSpatialUnitQualitative**
> SpatialUnitsFeatureEndpointType UpdateSpatialUnitQualitative (string spatialunitUid, RFC6902PatchRequest patchspatialunit, string envelope = null, string i4lProcessUid = null)

Updates a new SpatialUnit

Updates SpatialUnit with qualitative base spatial profile

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class UpdateSpatialUnitQualitativeExample
    {
        public void main()
        {
            var apiInstance = new SpatialUnitsApi();
            var spatialunitUid = spatialunitUid_example;  // string | Spatial unit UID
            var patchspatialunit = new RFC6902PatchRequest(); // RFC6902PatchRequest | Update data
            var envelope = envelope_example;  // string | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional) 
            var i4lProcessUid = i4lProcessUid_example;  // string | Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional) 

            try
            {
                // Updates a new SpatialUnit
                SpatialUnitsFeatureEndpointType result = apiInstance.UpdateSpatialUnitQualitative(spatialunitUid, patchspatialunit, envelope, i4lProcessUid);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling SpatialUnitsApi.UpdateSpatialUnitQualitative: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **spatialunitUid** | **string**| Spatial unit UID | 
 **patchspatialunit** | [**RFC6902PatchRequest**](RFC6902PatchRequest.md)| Update data | 
 **envelope** | **string**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **i4lProcessUid** | **string**| Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. | [optional] 

### Return type

[**SpatialUnitsFeatureEndpointType**](SpatialUnitsFeatureEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

