# IO.Swagger.Api.ToolsApi

All URIs are relative to *https://platform.its4land.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**GetTools**](ToolsApi.md#gettools) | **GET** /tools | Get a list of tools


<a name="gettools"></a>
# **GetTools**
> List<ToolsEndpointType> GetTools (string envelope = null, List<string> uid = null, List<string> name = null, string version = null, List<string> supplier = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null)

Get a list of tools

Get a list of tools

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class GetToolsExample
    {
        public void main()
        {
            var apiInstance = new ToolsApi();
            var envelope = envelope_example;  // string | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional) 
            var uid = new List<string>(); // List<string> | Comma separated list of Tag UID (optional) 
            var name = new List<string>(); // List<string> | Comma separated list of tool names (optional) 
            var version = version_example;  // string | Tool version. By default, the latest version will be returned. * returns all versions. (optional) 
            var supplier = new List<string>(); // List<string> | Comma separated list of supplier (optional) 
            var page = 56;  // int? | Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional) 
            var sort = sort_example;  // string | The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional) 
            var fields = new List<string>(); // List<string> | Comma separated list of fields (optional) 
            var embed = new List<string>(); // List<string> | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional) 

            try
            {
                // Get a list of tools
                List&lt;ToolsEndpointType&gt; result = apiInstance.GetTools(envelope, uid, name, version, supplier, page, sort, fields, embed);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ToolsApi.GetTools: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **envelope** | **string**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **uid** | [**List&lt;string&gt;**](string.md)| Comma separated list of Tag UID | [optional] 
 **name** | [**List&lt;string&gt;**](string.md)| Comma separated list of tool names | [optional] 
 **version** | **string**| Tool version. By default, the latest version will be returned. * returns all versions. | [optional] 
 **supplier** | [**List&lt;string&gt;**](string.md)| Comma separated list of supplier | [optional] 
 **page** | **int?**| Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. | [optional] 
 **sort** | **string**| The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. | [optional] 
 **fields** | [**List&lt;string&gt;**](string.md)| Comma separated list of fields | [optional] 
 **embed** | [**List&lt;string&gt;**](string.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional] 

### Return type

[**List<ToolsEndpointType>**](ToolsEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

