# IO.Swagger.Api.WP5ValidationSetsApi

All URIs are relative to *https://platform.its4land.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**GetWP5ValidationSetByUID**](WP5ValidationSetsApi.md#getwp5validationsetbyuid) | **GET** /WP5ValidationSets/{wp5validationset_uid} | Returns a single WP5ValidationSet
[**GetWP5ValidationSets**](WP5ValidationSetsApi.md#getwp5validationsets) | **GET** /WP5ValidationSets | Returns a list of WP5ValidationSets
[**NewWP5ValidationSets**](WP5ValidationSetsApi.md#newwp5validationsets) | **POST** /WP5ValidationSets | Create a new WP5ValidationSets


<a name="getwp5validationsetbyuid"></a>
# **GetWP5ValidationSetByUID**
> WP5ValidationSetsEndpointType GetWP5ValidationSetByUID (string wp5validationsetUid, string envelope = null, List<string> embed = null)

Returns a single WP5ValidationSet

Returns a single WP5ValidationSet

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class GetWP5ValidationSetByUIDExample
    {
        public void main()
        {
            var apiInstance = new WP5ValidationSetsApi();
            var wp5validationsetUid = wp5validationsetUid_example;  // string | WP5ValidationSet UID
            var envelope = envelope_example;  // string | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional) 
            var embed = new List<string>(); // List<string> | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional) 

            try
            {
                // Returns a single WP5ValidationSet
                WP5ValidationSetsEndpointType result = apiInstance.GetWP5ValidationSetByUID(wp5validationsetUid, envelope, embed);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling WP5ValidationSetsApi.GetWP5ValidationSetByUID: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **wp5validationsetUid** | **string**| WP5ValidationSet UID | 
 **envelope** | **string**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **embed** | [**List&lt;string&gt;**](string.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional] 

### Return type

[**WP5ValidationSetsEndpointType**](WP5ValidationSetsEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="getwp5validationsets"></a>
# **GetWP5ValidationSets**
> List<WP5ValidationSetsEndpointType> GetWP5ValidationSets (string envelope = null, List<string> uid = null, List<string> name = null, List<string> models = null, List<string> projects = null, List<string> tags = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null)

Returns a list of WP5ValidationSets

Returns a list of WP5ValidationSets

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class GetWP5ValidationSetsExample
    {
        public void main()
        {
            var apiInstance = new WP5ValidationSetsApi();
            var envelope = envelope_example;  // string | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional) 
            var uid = new List<string>(); // List<string> | Comma separated list of TrainingSet UID (optional) 
            var name = new List<string>(); // List<string> | Comma separated list of WP5ValidationSets Names (optional) 
            var models = new List<string>(); // List<string> | Comma separated list of model UID (optional) 
            var projects = new List<string>(); // List<string> | Comma separated list of project UID (optional) 
            var tags = new List<string>(); // List<string> | Comma separated list of tags (optional) 
            var page = 56;  // int? | Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional) 
            var sort = sort_example;  // string | The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional) 
            var fields = new List<string>(); // List<string> | Comma separated list of field names (optional) 
            var embed = new List<string>(); // List<string> | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional) 

            try
            {
                // Returns a list of WP5ValidationSets
                List&lt;WP5ValidationSetsEndpointType&gt; result = apiInstance.GetWP5ValidationSets(envelope, uid, name, models, projects, tags, page, sort, fields, embed);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling WP5ValidationSetsApi.GetWP5ValidationSets: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **envelope** | **string**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **uid** | [**List&lt;string&gt;**](string.md)| Comma separated list of TrainingSet UID | [optional] 
 **name** | [**List&lt;string&gt;**](string.md)| Comma separated list of WP5ValidationSets Names | [optional] 
 **models** | [**List&lt;string&gt;**](string.md)| Comma separated list of model UID | [optional] 
 **projects** | [**List&lt;string&gt;**](string.md)| Comma separated list of project UID | [optional] 
 **tags** | [**List&lt;string&gt;**](string.md)| Comma separated list of tags | [optional] 
 **page** | **int?**| Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. | [optional] 
 **sort** | **string**| The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. | [optional] 
 **fields** | [**List&lt;string&gt;**](string.md)| Comma separated list of field names | [optional] 
 **embed** | [**List&lt;string&gt;**](string.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional] 

### Return type

[**List<WP5ValidationSetsEndpointType>**](WP5ValidationSetsEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="newwp5validationsets"></a>
# **NewWP5ValidationSets**
> WP5ValidationSetsEndpointType NewWP5ValidationSets (WP5ValidationSetsPostRequest newwp5validationsets, string envelope = null, List<string> embed = null, string i4lProcessUid = null)

Create a new WP5ValidationSets

Create a new TrainingSet. To add a new WP5ValidationSets , the content of WP5ValidationSets  must be stored in advanced via the ContentItem endpoint

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class NewWP5ValidationSetsExample
    {
        public void main()
        {
            var apiInstance = new WP5ValidationSetsApi();
            var newwp5validationsets = new WP5ValidationSetsPostRequest(); // WP5ValidationSetsPostRequest | New WP5ValidationSet data
            var envelope = envelope_example;  // string | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional) 
            var embed = new List<string>(); // List<string> | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional) 
            var i4lProcessUid = i4lProcessUid_example;  // string | Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional) 

            try
            {
                // Create a new WP5ValidationSets
                WP5ValidationSetsEndpointType result = apiInstance.NewWP5ValidationSets(newwp5validationsets, envelope, embed, i4lProcessUid);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling WP5ValidationSetsApi.NewWP5ValidationSets: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **newwp5validationsets** | [**WP5ValidationSetsPostRequest**](WP5ValidationSetsPostRequest.md)| New WP5ValidationSet data | 
 **envelope** | **string**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **embed** | [**List&lt;string&gt;**](string.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional] 
 **i4lProcessUid** | **string**| Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. | [optional] 

### Return type

[**WP5ValidationSetsEndpointType**](WP5ValidationSetsEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

