/* 
 * its4land Public API
 *
 * The its4land Public API provides access to the services of the its4land Publish and Share platform.
 *
 * OpenAPI spec version: 0.0.2
 * Contact: contact@its4land.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using RestSharp;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace IO.Swagger.Api
{
    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public interface IBoundaryFaceStringApi : IApiAccessor
    {
        #region Synchronous Operations
        /// <summary>
        /// Returns a list of boundary face strings in a GeoJSON structure.
        /// </summary>
        /// <remarks>
        /// Returns a list of boundary face strings. A boundary face string is modeled as a GeoJSON feature.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="uid">Comma separated list of Spatial unit UID (optional)</param>
        /// <param name="name">Comma separated list of AdminSources names (optional)</param>
        /// <param name="projects">Comma separated list of project UID (optional)</param>
        /// <param name="spatialunit">Comma separated list of SpatialSource UID (optional)</param>
        /// <param name="tags">Comma separated list of tags (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of tags (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>BoundaryFaceStringEndpointType</returns>
        BoundaryFaceStringEndpointType GetBoundaryFaceString (string envelope = null, List<string> uid = null, List<string> name = null, List<string> projects = null, List<string> spatialunit = null, List<string> tags = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null);

        /// <summary>
        /// Returns a list of boundary face strings in a GeoJSON structure.
        /// </summary>
        /// <remarks>
        /// Returns a list of boundary face strings. A boundary face string is modeled as a GeoJSON feature.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="uid">Comma separated list of Spatial unit UID (optional)</param>
        /// <param name="name">Comma separated list of AdminSources names (optional)</param>
        /// <param name="projects">Comma separated list of project UID (optional)</param>
        /// <param name="spatialunit">Comma separated list of SpatialSource UID (optional)</param>
        /// <param name="tags">Comma separated list of tags (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of tags (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>ApiResponse of BoundaryFaceStringEndpointType</returns>
        ApiResponse<BoundaryFaceStringEndpointType> GetBoundaryFaceStringWithHttpInfo (string envelope = null, List<string> uid = null, List<string> name = null, List<string> projects = null, List<string> spatialunit = null, List<string> tags = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null);
        /// <summary>
        /// Returns a single boundary face string
        /// </summary>
        /// <remarks>
        /// Returns a boundary face string as GeoJSON as a feature in a GeoJSON structure.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="boundaryfacestringUid">Boundary face string UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>BoundaryFaceStringEndpointType</returns>
        BoundaryFaceStringEndpointType GetBoundaryFaceStringByUID (string boundaryfacestringUid, string envelope = null, List<string> embed = null);

        /// <summary>
        /// Returns a single boundary face string
        /// </summary>
        /// <remarks>
        /// Returns a boundary face string as GeoJSON as a feature in a GeoJSON structure.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="boundaryfacestringUid">Boundary face string UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>ApiResponse of BoundaryFaceStringEndpointType</returns>
        ApiResponse<BoundaryFaceStringEndpointType> GetBoundaryFaceStringByUIDWithHttpInfo (string boundaryfacestringUid, string envelope = null, List<string> embed = null);
        /// <summary>
        /// Create a new concept for a boundary face string
        /// </summary>
        /// <remarks>
        /// Create a new concept for a boundary face string.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newboundaryfacestring">New boundary face string</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>BoundaryFaceStringEndpointType</returns>
        BoundaryFaceStringEndpointType NewBoundaryFaceString (BoundaryFaceStringPostRequest newboundaryfacestring, string envelope = null, List<string> embed = null, string i4lProcessUid = null);

        /// <summary>
        /// Create a new concept for a boundary face string
        /// </summary>
        /// <remarks>
        /// Create a new concept for a boundary face string.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newboundaryfacestring">New boundary face string</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>ApiResponse of BoundaryFaceStringEndpointType</returns>
        ApiResponse<BoundaryFaceStringEndpointType> NewBoundaryFaceStringWithHttpInfo (BoundaryFaceStringPostRequest newboundaryfacestring, string envelope = null, List<string> embed = null, string i4lProcessUid = null);
        /// <summary>
        /// Replace an existing BoundaryFaceString by a newer version
        /// </summary>
        /// <remarks>
        /// An existing BoundaryFaceString will be replaced by a newer version. The UID of BoundaryFaceString remains
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="boundaryfacestringUid">Boundary face string UID</param>
        /// <param name="updatedboundaryfacestring">Updated boundary face string</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>BoundaryFaceStringEndpointType</returns>
        BoundaryFaceStringEndpointType PutBoundaryFaceStringByUID (string boundaryfacestringUid, BoundaryFaceStringPostRequest updatedboundaryfacestring, string envelope = null, List<string> embed = null, string i4lProcessUid = null);

        /// <summary>
        /// Replace an existing BoundaryFaceString by a newer version
        /// </summary>
        /// <remarks>
        /// An existing BoundaryFaceString will be replaced by a newer version. The UID of BoundaryFaceString remains
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="boundaryfacestringUid">Boundary face string UID</param>
        /// <param name="updatedboundaryfacestring">Updated boundary face string</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>ApiResponse of BoundaryFaceStringEndpointType</returns>
        ApiResponse<BoundaryFaceStringEndpointType> PutBoundaryFaceStringByUIDWithHttpInfo (string boundaryfacestringUid, BoundaryFaceStringPostRequest updatedboundaryfacestring, string envelope = null, List<string> embed = null, string i4lProcessUid = null);
        /// <summary>
        /// Updates a boundary face string
        /// </summary>
        /// <remarks>
        /// Updates a boundary face string
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="boundaryfacestringUid">Boundary face string UID</param>
        /// <param name="patchboundaryfacestring">Update data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>BoundaryFaceStringEndpointType</returns>
        BoundaryFaceStringEndpointType UpdateBoundaryFaceString (string boundaryfacestringUid, RFC6902PatchRequest patchboundaryfacestring, string envelope = null, string i4lProcessUid = null);

        /// <summary>
        /// Updates a boundary face string
        /// </summary>
        /// <remarks>
        /// Updates a boundary face string
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="boundaryfacestringUid">Boundary face string UID</param>
        /// <param name="patchboundaryfacestring">Update data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>ApiResponse of BoundaryFaceStringEndpointType</returns>
        ApiResponse<BoundaryFaceStringEndpointType> UpdateBoundaryFaceStringWithHttpInfo (string boundaryfacestringUid, RFC6902PatchRequest patchboundaryfacestring, string envelope = null, string i4lProcessUid = null);
        #endregion Synchronous Operations
        #region Asynchronous Operations
        /// <summary>
        /// Returns a list of boundary face strings in a GeoJSON structure.
        /// </summary>
        /// <remarks>
        /// Returns a list of boundary face strings. A boundary face string is modeled as a GeoJSON feature.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="uid">Comma separated list of Spatial unit UID (optional)</param>
        /// <param name="name">Comma separated list of AdminSources names (optional)</param>
        /// <param name="projects">Comma separated list of project UID (optional)</param>
        /// <param name="spatialunit">Comma separated list of SpatialSource UID (optional)</param>
        /// <param name="tags">Comma separated list of tags (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of tags (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of BoundaryFaceStringEndpointType</returns>
        System.Threading.Tasks.Task<BoundaryFaceStringEndpointType> GetBoundaryFaceStringAsync (string envelope = null, List<string> uid = null, List<string> name = null, List<string> projects = null, List<string> spatialunit = null, List<string> tags = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null);

        /// <summary>
        /// Returns a list of boundary face strings in a GeoJSON structure.
        /// </summary>
        /// <remarks>
        /// Returns a list of boundary face strings. A boundary face string is modeled as a GeoJSON feature.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="uid">Comma separated list of Spatial unit UID (optional)</param>
        /// <param name="name">Comma separated list of AdminSources names (optional)</param>
        /// <param name="projects">Comma separated list of project UID (optional)</param>
        /// <param name="spatialunit">Comma separated list of SpatialSource UID (optional)</param>
        /// <param name="tags">Comma separated list of tags (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of tags (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of ApiResponse (BoundaryFaceStringEndpointType)</returns>
        System.Threading.Tasks.Task<ApiResponse<BoundaryFaceStringEndpointType>> GetBoundaryFaceStringAsyncWithHttpInfo (string envelope = null, List<string> uid = null, List<string> name = null, List<string> projects = null, List<string> spatialunit = null, List<string> tags = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null);
        /// <summary>
        /// Returns a single boundary face string
        /// </summary>
        /// <remarks>
        /// Returns a boundary face string as GeoJSON as a feature in a GeoJSON structure.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="boundaryfacestringUid">Boundary face string UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of BoundaryFaceStringEndpointType</returns>
        System.Threading.Tasks.Task<BoundaryFaceStringEndpointType> GetBoundaryFaceStringByUIDAsync (string boundaryfacestringUid, string envelope = null, List<string> embed = null);

        /// <summary>
        /// Returns a single boundary face string
        /// </summary>
        /// <remarks>
        /// Returns a boundary face string as GeoJSON as a feature in a GeoJSON structure.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="boundaryfacestringUid">Boundary face string UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of ApiResponse (BoundaryFaceStringEndpointType)</returns>
        System.Threading.Tasks.Task<ApiResponse<BoundaryFaceStringEndpointType>> GetBoundaryFaceStringByUIDAsyncWithHttpInfo (string boundaryfacestringUid, string envelope = null, List<string> embed = null);
        /// <summary>
        /// Create a new concept for a boundary face string
        /// </summary>
        /// <remarks>
        /// Create a new concept for a boundary face string.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newboundaryfacestring">New boundary face string</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of BoundaryFaceStringEndpointType</returns>
        System.Threading.Tasks.Task<BoundaryFaceStringEndpointType> NewBoundaryFaceStringAsync (BoundaryFaceStringPostRequest newboundaryfacestring, string envelope = null, List<string> embed = null, string i4lProcessUid = null);

        /// <summary>
        /// Create a new concept for a boundary face string
        /// </summary>
        /// <remarks>
        /// Create a new concept for a boundary face string.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newboundaryfacestring">New boundary face string</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of ApiResponse (BoundaryFaceStringEndpointType)</returns>
        System.Threading.Tasks.Task<ApiResponse<BoundaryFaceStringEndpointType>> NewBoundaryFaceStringAsyncWithHttpInfo (BoundaryFaceStringPostRequest newboundaryfacestring, string envelope = null, List<string> embed = null, string i4lProcessUid = null);
        /// <summary>
        /// Replace an existing BoundaryFaceString by a newer version
        /// </summary>
        /// <remarks>
        /// An existing BoundaryFaceString will be replaced by a newer version. The UID of BoundaryFaceString remains
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="boundaryfacestringUid">Boundary face string UID</param>
        /// <param name="updatedboundaryfacestring">Updated boundary face string</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of BoundaryFaceStringEndpointType</returns>
        System.Threading.Tasks.Task<BoundaryFaceStringEndpointType> PutBoundaryFaceStringByUIDAsync (string boundaryfacestringUid, BoundaryFaceStringPostRequest updatedboundaryfacestring, string envelope = null, List<string> embed = null, string i4lProcessUid = null);

        /// <summary>
        /// Replace an existing BoundaryFaceString by a newer version
        /// </summary>
        /// <remarks>
        /// An existing BoundaryFaceString will be replaced by a newer version. The UID of BoundaryFaceString remains
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="boundaryfacestringUid">Boundary face string UID</param>
        /// <param name="updatedboundaryfacestring">Updated boundary face string</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of ApiResponse (BoundaryFaceStringEndpointType)</returns>
        System.Threading.Tasks.Task<ApiResponse<BoundaryFaceStringEndpointType>> PutBoundaryFaceStringByUIDAsyncWithHttpInfo (string boundaryfacestringUid, BoundaryFaceStringPostRequest updatedboundaryfacestring, string envelope = null, List<string> embed = null, string i4lProcessUid = null);
        /// <summary>
        /// Updates a boundary face string
        /// </summary>
        /// <remarks>
        /// Updates a boundary face string
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="boundaryfacestringUid">Boundary face string UID</param>
        /// <param name="patchboundaryfacestring">Update data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of BoundaryFaceStringEndpointType</returns>
        System.Threading.Tasks.Task<BoundaryFaceStringEndpointType> UpdateBoundaryFaceStringAsync (string boundaryfacestringUid, RFC6902PatchRequest patchboundaryfacestring, string envelope = null, string i4lProcessUid = null);

        /// <summary>
        /// Updates a boundary face string
        /// </summary>
        /// <remarks>
        /// Updates a boundary face string
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="boundaryfacestringUid">Boundary face string UID</param>
        /// <param name="patchboundaryfacestring">Update data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of ApiResponse (BoundaryFaceStringEndpointType)</returns>
        System.Threading.Tasks.Task<ApiResponse<BoundaryFaceStringEndpointType>> UpdateBoundaryFaceStringAsyncWithHttpInfo (string boundaryfacestringUid, RFC6902PatchRequest patchboundaryfacestring, string envelope = null, string i4lProcessUid = null);
        #endregion Asynchronous Operations
    }

    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public partial class BoundaryFaceStringApi : IBoundaryFaceStringApi
    {
        private IO.Swagger.Client.ExceptionFactory _exceptionFactory = (name, response) => null;

        /// <summary>
        /// Initializes a new instance of the <see cref="BoundaryFaceStringApi"/> class.
        /// </summary>
        /// <returns></returns>
        public BoundaryFaceStringApi(String basePath)
        {
            this.Configuration = new Configuration { BasePath = basePath };

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="BoundaryFaceStringApi"/> class
        /// using Configuration object
        /// </summary>
        /// <param name="configuration">An instance of Configuration</param>
        /// <returns></returns>
        public BoundaryFaceStringApi(Configuration configuration = null)
        {
            if (configuration == null) // use the default one in Configuration
                this.Configuration = Configuration.Default;
            else
                this.Configuration = configuration;

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Gets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        public String GetBasePath()
        {
            return this.Configuration.ApiClient.RestClient.BaseUrl.ToString();
        }

        /// <summary>
        /// Sets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        [Obsolete("SetBasePath is deprecated, please do 'Configuration.ApiClient = new ApiClient(\"http://new-path\")' instead.")]
        public void SetBasePath(String basePath)
        {
            // do nothing
        }

        /// <summary>
        /// Gets or sets the configuration object
        /// </summary>
        /// <value>An instance of the Configuration</value>
        public Configuration Configuration {get; set;}

        /// <summary>
        /// Provides a factory method hook for the creation of exceptions.
        /// </summary>
        public IO.Swagger.Client.ExceptionFactory ExceptionFactory
        {
            get
            {
                if (_exceptionFactory != null && _exceptionFactory.GetInvocationList().Length > 1)
                {
                    throw new InvalidOperationException("Multicast delegate for ExceptionFactory is unsupported.");
                }
                return _exceptionFactory;
            }
            set { _exceptionFactory = value; }
        }

        /// <summary>
        /// Gets the default header.
        /// </summary>
        /// <returns>Dictionary of HTTP header</returns>
        [Obsolete("DefaultHeader is deprecated, please use Configuration.DefaultHeader instead.")]
        public IDictionary<String, String> DefaultHeader()
        {
            return new ReadOnlyDictionary<string, string>(this.Configuration.DefaultHeader);
        }

        /// <summary>
        /// Add default header.
        /// </summary>
        /// <param name="key">Header field name.</param>
        /// <param name="value">Header field value.</param>
        /// <returns></returns>
        [Obsolete("AddDefaultHeader is deprecated, please use Configuration.AddDefaultHeader instead.")]
        public void AddDefaultHeader(string key, string value)
        {
            this.Configuration.AddDefaultHeader(key, value);
        }

        /// <summary>
        /// Returns a list of boundary face strings in a GeoJSON structure. Returns a list of boundary face strings. A boundary face string is modeled as a GeoJSON feature.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="uid">Comma separated list of Spatial unit UID (optional)</param>
        /// <param name="name">Comma separated list of AdminSources names (optional)</param>
        /// <param name="projects">Comma separated list of project UID (optional)</param>
        /// <param name="spatialunit">Comma separated list of SpatialSource UID (optional)</param>
        /// <param name="tags">Comma separated list of tags (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of tags (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>BoundaryFaceStringEndpointType</returns>
        public BoundaryFaceStringEndpointType GetBoundaryFaceString (string envelope = null, List<string> uid = null, List<string> name = null, List<string> projects = null, List<string> spatialunit = null, List<string> tags = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null)
        {
             ApiResponse<BoundaryFaceStringEndpointType> localVarResponse = GetBoundaryFaceStringWithHttpInfo(envelope, uid, name, projects, spatialunit, tags, page, sort, fields, embed);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Returns a list of boundary face strings in a GeoJSON structure. Returns a list of boundary face strings. A boundary face string is modeled as a GeoJSON feature.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="uid">Comma separated list of Spatial unit UID (optional)</param>
        /// <param name="name">Comma separated list of AdminSources names (optional)</param>
        /// <param name="projects">Comma separated list of project UID (optional)</param>
        /// <param name="spatialunit">Comma separated list of SpatialSource UID (optional)</param>
        /// <param name="tags">Comma separated list of tags (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of tags (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>ApiResponse of BoundaryFaceStringEndpointType</returns>
        public ApiResponse< BoundaryFaceStringEndpointType > GetBoundaryFaceStringWithHttpInfo (string envelope = null, List<string> uid = null, List<string> name = null, List<string> projects = null, List<string> spatialunit = null, List<string> tags = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null)
        {

            var localVarPath = "/boundaryfacestring";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (uid != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "uid", uid)); // query parameter
            if (name != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "name", name)); // query parameter
            if (projects != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "projects", projects)); // query parameter
            if (spatialunit != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "spatialunit", spatialunit)); // query parameter
            if (tags != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "tags", tags)); // query parameter
            if (page != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "page", page)); // query parameter
            if (sort != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "sort", sort)); // query parameter
            if (fields != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "fields", fields)); // query parameter
            if (embed != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "embed", embed)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetBoundaryFaceString", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<BoundaryFaceStringEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (BoundaryFaceStringEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(BoundaryFaceStringEndpointType)));
        }

        /// <summary>
        /// Returns a list of boundary face strings in a GeoJSON structure. Returns a list of boundary face strings. A boundary face string is modeled as a GeoJSON feature.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="uid">Comma separated list of Spatial unit UID (optional)</param>
        /// <param name="name">Comma separated list of AdminSources names (optional)</param>
        /// <param name="projects">Comma separated list of project UID (optional)</param>
        /// <param name="spatialunit">Comma separated list of SpatialSource UID (optional)</param>
        /// <param name="tags">Comma separated list of tags (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of tags (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of BoundaryFaceStringEndpointType</returns>
        public async System.Threading.Tasks.Task<BoundaryFaceStringEndpointType> GetBoundaryFaceStringAsync (string envelope = null, List<string> uid = null, List<string> name = null, List<string> projects = null, List<string> spatialunit = null, List<string> tags = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null)
        {
             ApiResponse<BoundaryFaceStringEndpointType> localVarResponse = await GetBoundaryFaceStringAsyncWithHttpInfo(envelope, uid, name, projects, spatialunit, tags, page, sort, fields, embed);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Returns a list of boundary face strings in a GeoJSON structure. Returns a list of boundary face strings. A boundary face string is modeled as a GeoJSON feature.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="uid">Comma separated list of Spatial unit UID (optional)</param>
        /// <param name="name">Comma separated list of AdminSources names (optional)</param>
        /// <param name="projects">Comma separated list of project UID (optional)</param>
        /// <param name="spatialunit">Comma separated list of SpatialSource UID (optional)</param>
        /// <param name="tags">Comma separated list of tags (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of tags (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of ApiResponse (BoundaryFaceStringEndpointType)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<BoundaryFaceStringEndpointType>> GetBoundaryFaceStringAsyncWithHttpInfo (string envelope = null, List<string> uid = null, List<string> name = null, List<string> projects = null, List<string> spatialunit = null, List<string> tags = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null)
        {

            var localVarPath = "/boundaryfacestring";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (uid != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "uid", uid)); // query parameter
            if (name != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "name", name)); // query parameter
            if (projects != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "projects", projects)); // query parameter
            if (spatialunit != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "spatialunit", spatialunit)); // query parameter
            if (tags != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "tags", tags)); // query parameter
            if (page != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "page", page)); // query parameter
            if (sort != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "sort", sort)); // query parameter
            if (fields != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "fields", fields)); // query parameter
            if (embed != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "embed", embed)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetBoundaryFaceString", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<BoundaryFaceStringEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (BoundaryFaceStringEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(BoundaryFaceStringEndpointType)));
        }

        /// <summary>
        /// Returns a single boundary face string Returns a boundary face string as GeoJSON as a feature in a GeoJSON structure.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="boundaryfacestringUid">Boundary face string UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>BoundaryFaceStringEndpointType</returns>
        public BoundaryFaceStringEndpointType GetBoundaryFaceStringByUID (string boundaryfacestringUid, string envelope = null, List<string> embed = null)
        {
             ApiResponse<BoundaryFaceStringEndpointType> localVarResponse = GetBoundaryFaceStringByUIDWithHttpInfo(boundaryfacestringUid, envelope, embed);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Returns a single boundary face string Returns a boundary face string as GeoJSON as a feature in a GeoJSON structure.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="boundaryfacestringUid">Boundary face string UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>ApiResponse of BoundaryFaceStringEndpointType</returns>
        public ApiResponse< BoundaryFaceStringEndpointType > GetBoundaryFaceStringByUIDWithHttpInfo (string boundaryfacestringUid, string envelope = null, List<string> embed = null)
        {
            // verify the required parameter 'boundaryfacestringUid' is set
            if (boundaryfacestringUid == null)
                throw new ApiException(400, "Missing required parameter 'boundaryfacestringUid' when calling BoundaryFaceStringApi->GetBoundaryFaceStringByUID");

            var localVarPath = "/boundaryfacestring/{boundaryfacestring_uid}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (boundaryfacestringUid != null) localVarPathParams.Add("boundaryfacestring_uid", Configuration.ApiClient.ParameterToString(boundaryfacestringUid)); // path parameter
            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (embed != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "embed", embed)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetBoundaryFaceStringByUID", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<BoundaryFaceStringEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (BoundaryFaceStringEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(BoundaryFaceStringEndpointType)));
        }

        /// <summary>
        /// Returns a single boundary face string Returns a boundary face string as GeoJSON as a feature in a GeoJSON structure.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="boundaryfacestringUid">Boundary face string UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of BoundaryFaceStringEndpointType</returns>
        public async System.Threading.Tasks.Task<BoundaryFaceStringEndpointType> GetBoundaryFaceStringByUIDAsync (string boundaryfacestringUid, string envelope = null, List<string> embed = null)
        {
             ApiResponse<BoundaryFaceStringEndpointType> localVarResponse = await GetBoundaryFaceStringByUIDAsyncWithHttpInfo(boundaryfacestringUid, envelope, embed);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Returns a single boundary face string Returns a boundary face string as GeoJSON as a feature in a GeoJSON structure.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="boundaryfacestringUid">Boundary face string UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of ApiResponse (BoundaryFaceStringEndpointType)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<BoundaryFaceStringEndpointType>> GetBoundaryFaceStringByUIDAsyncWithHttpInfo (string boundaryfacestringUid, string envelope = null, List<string> embed = null)
        {
            // verify the required parameter 'boundaryfacestringUid' is set
            if (boundaryfacestringUid == null)
                throw new ApiException(400, "Missing required parameter 'boundaryfacestringUid' when calling BoundaryFaceStringApi->GetBoundaryFaceStringByUID");

            var localVarPath = "/boundaryfacestring/{boundaryfacestring_uid}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (boundaryfacestringUid != null) localVarPathParams.Add("boundaryfacestring_uid", Configuration.ApiClient.ParameterToString(boundaryfacestringUid)); // path parameter
            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (embed != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "embed", embed)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetBoundaryFaceStringByUID", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<BoundaryFaceStringEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (BoundaryFaceStringEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(BoundaryFaceStringEndpointType)));
        }

        /// <summary>
        /// Create a new concept for a boundary face string Create a new concept for a boundary face string.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newboundaryfacestring">New boundary face string</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>BoundaryFaceStringEndpointType</returns>
        public BoundaryFaceStringEndpointType NewBoundaryFaceString (BoundaryFaceStringPostRequest newboundaryfacestring, string envelope = null, List<string> embed = null, string i4lProcessUid = null)
        {
             ApiResponse<BoundaryFaceStringEndpointType> localVarResponse = NewBoundaryFaceStringWithHttpInfo(newboundaryfacestring, envelope, embed, i4lProcessUid);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Create a new concept for a boundary face string Create a new concept for a boundary face string.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newboundaryfacestring">New boundary face string</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>ApiResponse of BoundaryFaceStringEndpointType</returns>
        public ApiResponse< BoundaryFaceStringEndpointType > NewBoundaryFaceStringWithHttpInfo (BoundaryFaceStringPostRequest newboundaryfacestring, string envelope = null, List<string> embed = null, string i4lProcessUid = null)
        {
            // verify the required parameter 'newboundaryfacestring' is set
            if (newboundaryfacestring == null)
                throw new ApiException(400, "Missing required parameter 'newboundaryfacestring' when calling BoundaryFaceStringApi->NewBoundaryFaceString");

            var localVarPath = "/boundaryfacestring";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (embed != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "embed", embed)); // query parameter
            if (i4lProcessUid != null) localVarHeaderParams.Add("i4l-process-uid", Configuration.ApiClient.ParameterToString(i4lProcessUid)); // header parameter
            if (newboundaryfacestring != null && newboundaryfacestring.GetType() != typeof(byte[]))
            {
                localVarPostBody = Configuration.ApiClient.Serialize(newboundaryfacestring); // http body (model) parameter
            }
            else
            {
                localVarPostBody = newboundaryfacestring; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("NewBoundaryFaceString", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<BoundaryFaceStringEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (BoundaryFaceStringEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(BoundaryFaceStringEndpointType)));
        }

        /// <summary>
        /// Create a new concept for a boundary face string Create a new concept for a boundary face string.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newboundaryfacestring">New boundary face string</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of BoundaryFaceStringEndpointType</returns>
        public async System.Threading.Tasks.Task<BoundaryFaceStringEndpointType> NewBoundaryFaceStringAsync (BoundaryFaceStringPostRequest newboundaryfacestring, string envelope = null, List<string> embed = null, string i4lProcessUid = null)
        {
             ApiResponse<BoundaryFaceStringEndpointType> localVarResponse = await NewBoundaryFaceStringAsyncWithHttpInfo(newboundaryfacestring, envelope, embed, i4lProcessUid);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Create a new concept for a boundary face string Create a new concept for a boundary face string.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newboundaryfacestring">New boundary face string</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of ApiResponse (BoundaryFaceStringEndpointType)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<BoundaryFaceStringEndpointType>> NewBoundaryFaceStringAsyncWithHttpInfo (BoundaryFaceStringPostRequest newboundaryfacestring, string envelope = null, List<string> embed = null, string i4lProcessUid = null)
        {
            // verify the required parameter 'newboundaryfacestring' is set
            if (newboundaryfacestring == null)
                throw new ApiException(400, "Missing required parameter 'newboundaryfacestring' when calling BoundaryFaceStringApi->NewBoundaryFaceString");

            var localVarPath = "/boundaryfacestring";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (embed != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "embed", embed)); // query parameter
            if (i4lProcessUid != null) localVarHeaderParams.Add("i4l-process-uid", Configuration.ApiClient.ParameterToString(i4lProcessUid)); // header parameter
            if (newboundaryfacestring != null && newboundaryfacestring.GetType() != typeof(byte[]))
            {
                localVarPostBody = Configuration.ApiClient.Serialize(newboundaryfacestring); // http body (model) parameter
            }
            else
            {
                localVarPostBody = newboundaryfacestring; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("NewBoundaryFaceString", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<BoundaryFaceStringEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (BoundaryFaceStringEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(BoundaryFaceStringEndpointType)));
        }

        /// <summary>
        /// Replace an existing BoundaryFaceString by a newer version An existing BoundaryFaceString will be replaced by a newer version. The UID of BoundaryFaceString remains
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="boundaryfacestringUid">Boundary face string UID</param>
        /// <param name="updatedboundaryfacestring">Updated boundary face string</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>BoundaryFaceStringEndpointType</returns>
        public BoundaryFaceStringEndpointType PutBoundaryFaceStringByUID (string boundaryfacestringUid, BoundaryFaceStringPostRequest updatedboundaryfacestring, string envelope = null, List<string> embed = null, string i4lProcessUid = null)
        {
             ApiResponse<BoundaryFaceStringEndpointType> localVarResponse = PutBoundaryFaceStringByUIDWithHttpInfo(boundaryfacestringUid, updatedboundaryfacestring, envelope, embed, i4lProcessUid);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Replace an existing BoundaryFaceString by a newer version An existing BoundaryFaceString will be replaced by a newer version. The UID of BoundaryFaceString remains
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="boundaryfacestringUid">Boundary face string UID</param>
        /// <param name="updatedboundaryfacestring">Updated boundary face string</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>ApiResponse of BoundaryFaceStringEndpointType</returns>
        public ApiResponse< BoundaryFaceStringEndpointType > PutBoundaryFaceStringByUIDWithHttpInfo (string boundaryfacestringUid, BoundaryFaceStringPostRequest updatedboundaryfacestring, string envelope = null, List<string> embed = null, string i4lProcessUid = null)
        {
            // verify the required parameter 'boundaryfacestringUid' is set
            if (boundaryfacestringUid == null)
                throw new ApiException(400, "Missing required parameter 'boundaryfacestringUid' when calling BoundaryFaceStringApi->PutBoundaryFaceStringByUID");
            // verify the required parameter 'updatedboundaryfacestring' is set
            if (updatedboundaryfacestring == null)
                throw new ApiException(400, "Missing required parameter 'updatedboundaryfacestring' when calling BoundaryFaceStringApi->PutBoundaryFaceStringByUID");

            var localVarPath = "/boundaryfacestring/{boundaryfacestring_uid}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (boundaryfacestringUid != null) localVarPathParams.Add("boundaryfacestring_uid", Configuration.ApiClient.ParameterToString(boundaryfacestringUid)); // path parameter
            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (embed != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "embed", embed)); // query parameter
            if (i4lProcessUid != null) localVarHeaderParams.Add("i4l-process-uid", Configuration.ApiClient.ParameterToString(i4lProcessUid)); // header parameter
            if (updatedboundaryfacestring != null && updatedboundaryfacestring.GetType() != typeof(byte[]))
            {
                localVarPostBody = Configuration.ApiClient.Serialize(updatedboundaryfacestring); // http body (model) parameter
            }
            else
            {
                localVarPostBody = updatedboundaryfacestring; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.PUT, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PutBoundaryFaceStringByUID", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<BoundaryFaceStringEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (BoundaryFaceStringEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(BoundaryFaceStringEndpointType)));
        }

        /// <summary>
        /// Replace an existing BoundaryFaceString by a newer version An existing BoundaryFaceString will be replaced by a newer version. The UID of BoundaryFaceString remains
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="boundaryfacestringUid">Boundary face string UID</param>
        /// <param name="updatedboundaryfacestring">Updated boundary face string</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of BoundaryFaceStringEndpointType</returns>
        public async System.Threading.Tasks.Task<BoundaryFaceStringEndpointType> PutBoundaryFaceStringByUIDAsync (string boundaryfacestringUid, BoundaryFaceStringPostRequest updatedboundaryfacestring, string envelope = null, List<string> embed = null, string i4lProcessUid = null)
        {
             ApiResponse<BoundaryFaceStringEndpointType> localVarResponse = await PutBoundaryFaceStringByUIDAsyncWithHttpInfo(boundaryfacestringUid, updatedboundaryfacestring, envelope, embed, i4lProcessUid);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Replace an existing BoundaryFaceString by a newer version An existing BoundaryFaceString will be replaced by a newer version. The UID of BoundaryFaceString remains
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="boundaryfacestringUid">Boundary face string UID</param>
        /// <param name="updatedboundaryfacestring">Updated boundary face string</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of ApiResponse (BoundaryFaceStringEndpointType)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<BoundaryFaceStringEndpointType>> PutBoundaryFaceStringByUIDAsyncWithHttpInfo (string boundaryfacestringUid, BoundaryFaceStringPostRequest updatedboundaryfacestring, string envelope = null, List<string> embed = null, string i4lProcessUid = null)
        {
            // verify the required parameter 'boundaryfacestringUid' is set
            if (boundaryfacestringUid == null)
                throw new ApiException(400, "Missing required parameter 'boundaryfacestringUid' when calling BoundaryFaceStringApi->PutBoundaryFaceStringByUID");
            // verify the required parameter 'updatedboundaryfacestring' is set
            if (updatedboundaryfacestring == null)
                throw new ApiException(400, "Missing required parameter 'updatedboundaryfacestring' when calling BoundaryFaceStringApi->PutBoundaryFaceStringByUID");

            var localVarPath = "/boundaryfacestring/{boundaryfacestring_uid}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (boundaryfacestringUid != null) localVarPathParams.Add("boundaryfacestring_uid", Configuration.ApiClient.ParameterToString(boundaryfacestringUid)); // path parameter
            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (embed != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "embed", embed)); // query parameter
            if (i4lProcessUid != null) localVarHeaderParams.Add("i4l-process-uid", Configuration.ApiClient.ParameterToString(i4lProcessUid)); // header parameter
            if (updatedboundaryfacestring != null && updatedboundaryfacestring.GetType() != typeof(byte[]))
            {
                localVarPostBody = Configuration.ApiClient.Serialize(updatedboundaryfacestring); // http body (model) parameter
            }
            else
            {
                localVarPostBody = updatedboundaryfacestring; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.PUT, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PutBoundaryFaceStringByUID", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<BoundaryFaceStringEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (BoundaryFaceStringEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(BoundaryFaceStringEndpointType)));
        }

        /// <summary>
        /// Updates a boundary face string Updates a boundary face string
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="boundaryfacestringUid">Boundary face string UID</param>
        /// <param name="patchboundaryfacestring">Update data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>BoundaryFaceStringEndpointType</returns>
        public BoundaryFaceStringEndpointType UpdateBoundaryFaceString (string boundaryfacestringUid, RFC6902PatchRequest patchboundaryfacestring, string envelope = null, string i4lProcessUid = null)
        {
             ApiResponse<BoundaryFaceStringEndpointType> localVarResponse = UpdateBoundaryFaceStringWithHttpInfo(boundaryfacestringUid, patchboundaryfacestring, envelope, i4lProcessUid);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Updates a boundary face string Updates a boundary face string
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="boundaryfacestringUid">Boundary face string UID</param>
        /// <param name="patchboundaryfacestring">Update data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>ApiResponse of BoundaryFaceStringEndpointType</returns>
        public ApiResponse< BoundaryFaceStringEndpointType > UpdateBoundaryFaceStringWithHttpInfo (string boundaryfacestringUid, RFC6902PatchRequest patchboundaryfacestring, string envelope = null, string i4lProcessUid = null)
        {
            // verify the required parameter 'boundaryfacestringUid' is set
            if (boundaryfacestringUid == null)
                throw new ApiException(400, "Missing required parameter 'boundaryfacestringUid' when calling BoundaryFaceStringApi->UpdateBoundaryFaceString");
            // verify the required parameter 'patchboundaryfacestring' is set
            if (patchboundaryfacestring == null)
                throw new ApiException(400, "Missing required parameter 'patchboundaryfacestring' when calling BoundaryFaceStringApi->UpdateBoundaryFaceString");

            var localVarPath = "/boundaryfacestring/{boundaryfacestring_uid}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (boundaryfacestringUid != null) localVarPathParams.Add("boundaryfacestring_uid", Configuration.ApiClient.ParameterToString(boundaryfacestringUid)); // path parameter
            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (i4lProcessUid != null) localVarHeaderParams.Add("i4l-process-uid", Configuration.ApiClient.ParameterToString(i4lProcessUid)); // header parameter
            if (patchboundaryfacestring != null && patchboundaryfacestring.GetType() != typeof(byte[]))
            {
                localVarPostBody = Configuration.ApiClient.Serialize(patchboundaryfacestring); // http body (model) parameter
            }
            else
            {
                localVarPostBody = patchboundaryfacestring; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.PATCH, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("UpdateBoundaryFaceString", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<BoundaryFaceStringEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (BoundaryFaceStringEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(BoundaryFaceStringEndpointType)));
        }

        /// <summary>
        /// Updates a boundary face string Updates a boundary face string
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="boundaryfacestringUid">Boundary face string UID</param>
        /// <param name="patchboundaryfacestring">Update data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of BoundaryFaceStringEndpointType</returns>
        public async System.Threading.Tasks.Task<BoundaryFaceStringEndpointType> UpdateBoundaryFaceStringAsync (string boundaryfacestringUid, RFC6902PatchRequest patchboundaryfacestring, string envelope = null, string i4lProcessUid = null)
        {
             ApiResponse<BoundaryFaceStringEndpointType> localVarResponse = await UpdateBoundaryFaceStringAsyncWithHttpInfo(boundaryfacestringUid, patchboundaryfacestring, envelope, i4lProcessUid);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Updates a boundary face string Updates a boundary face string
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="boundaryfacestringUid">Boundary face string UID</param>
        /// <param name="patchboundaryfacestring">Update data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of ApiResponse (BoundaryFaceStringEndpointType)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<BoundaryFaceStringEndpointType>> UpdateBoundaryFaceStringAsyncWithHttpInfo (string boundaryfacestringUid, RFC6902PatchRequest patchboundaryfacestring, string envelope = null, string i4lProcessUid = null)
        {
            // verify the required parameter 'boundaryfacestringUid' is set
            if (boundaryfacestringUid == null)
                throw new ApiException(400, "Missing required parameter 'boundaryfacestringUid' when calling BoundaryFaceStringApi->UpdateBoundaryFaceString");
            // verify the required parameter 'patchboundaryfacestring' is set
            if (patchboundaryfacestring == null)
                throw new ApiException(400, "Missing required parameter 'patchboundaryfacestring' when calling BoundaryFaceStringApi->UpdateBoundaryFaceString");

            var localVarPath = "/boundaryfacestring/{boundaryfacestring_uid}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (boundaryfacestringUid != null) localVarPathParams.Add("boundaryfacestring_uid", Configuration.ApiClient.ParameterToString(boundaryfacestringUid)); // path parameter
            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (i4lProcessUid != null) localVarHeaderParams.Add("i4l-process-uid", Configuration.ApiClient.ParameterToString(i4lProcessUid)); // header parameter
            if (patchboundaryfacestring != null && patchboundaryfacestring.GetType() != typeof(byte[]))
            {
                localVarPostBody = Configuration.ApiClient.Serialize(patchboundaryfacestring); // http body (model) parameter
            }
            else
            {
                localVarPostBody = patchboundaryfacestring; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.PATCH, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("UpdateBoundaryFaceString", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<BoundaryFaceStringEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (BoundaryFaceStringEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(BoundaryFaceStringEndpointType)));
        }

    }
}
