/* 
 * its4land Public API
 *
 * The its4land Public API provides access to the services of the its4land Publish and Share platform.
 *
 * OpenAPI spec version: 0.0.2
 * Contact: contact@its4land.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using RestSharp;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace IO.Swagger.Api
{
    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public interface IMetricMapFeaturesApi : IApiAccessor
    {
        #region Synchronous Operations
        /// <summary>
        /// Returns MetricMapFeature
        /// </summary>
        /// <remarks>
        /// Returns MetricMapFeature in a GeoJSON structure. A metric map feature is modeled as a feature in  the GeoJSON structure.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="querywindow">Polygon. The polygon is encoded a comma separated list of coordinates. X1, Y1, X2, Y2, ..., Xn, Yn, X1, Y1</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="fgroup">Restricts the output to the listed feature group (optional)</param>
        /// <param name="ftype">Restricts the output to the listed feature types. When used in combination with fgroup, output contains only those ftype which are contained in the feature groups (optional)</param>
        /// <param name="fsubtype">Restricts the output to the listed feature types. When used in combination with fgroup and/or ftype, output contains only those fsubtype which are contained in the feature groups and feature types (optional)</param>
        /// <returns>MetricMapFeaturesEndpointType</returns>
        MetricMapFeaturesEndpointType GetMetricMapFeature (string querywindow, string envelope = null, string fgroup = null, string ftype = null, string fsubtype = null);

        /// <summary>
        /// Returns MetricMapFeature
        /// </summary>
        /// <remarks>
        /// Returns MetricMapFeature in a GeoJSON structure. A metric map feature is modeled as a feature in  the GeoJSON structure.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="querywindow">Polygon. The polygon is encoded a comma separated list of coordinates. X1, Y1, X2, Y2, ..., Xn, Yn, X1, Y1</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="fgroup">Restricts the output to the listed feature group (optional)</param>
        /// <param name="ftype">Restricts the output to the listed feature types. When used in combination with fgroup, output contains only those ftype which are contained in the feature groups (optional)</param>
        /// <param name="fsubtype">Restricts the output to the listed feature types. When used in combination with fgroup and/or ftype, output contains only those fsubtype which are contained in the feature groups and feature types (optional)</param>
        /// <returns>ApiResponse of MetricMapFeaturesEndpointType</returns>
        ApiResponse<MetricMapFeaturesEndpointType> GetMetricMapFeatureWithHttpInfo (string querywindow, string envelope = null, string fgroup = null, string ftype = null, string fsubtype = null);
        /// <summary>
        /// Create a new metricMapFeature
        /// </summary>
        /// <remarks>
        /// Create a new MetricMapFeature. The new metric map feature is a feature in the GeoJSON structure. Currently ony one new feature per request is allowed.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newmetricmapfeature">New MetricMap Feature data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>MetricMapFeaturesEndpointType</returns>
        MetricMapFeaturesEndpointType NewMetricMapFeature (MetricMapFeaturePostRequest newmetricmapfeature, string envelope = null, string i4lProcessUid = null);

        /// <summary>
        /// Create a new metricMapFeature
        /// </summary>
        /// <remarks>
        /// Create a new MetricMapFeature. The new metric map feature is a feature in the GeoJSON structure. Currently ony one new feature per request is allowed.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newmetricmapfeature">New MetricMap Feature data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>ApiResponse of MetricMapFeaturesEndpointType</returns>
        ApiResponse<MetricMapFeaturesEndpointType> NewMetricMapFeatureWithHttpInfo (MetricMapFeaturePostRequest newmetricmapfeature, string envelope = null, string i4lProcessUid = null);
        /// <summary>
        /// Updates a metric map feature
        /// </summary>
        /// <remarks>
        /// Updates a metric map feature. Only fgroup, fname, ftype, fsubtype and fURI can be updated
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="mmfUid">MetricMapFeature UID</param>
        /// <param name="patchmetricmapfeature">Update data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>MetricMapFeaturesEndpointType</returns>
        MetricMapFeaturesEndpointType UpdateMetricMapFeature (string mmfUid, RFC6902PatchRequest patchmetricmapfeature, string envelope = null, string i4lProcessUid = null);

        /// <summary>
        /// Updates a metric map feature
        /// </summary>
        /// <remarks>
        /// Updates a metric map feature. Only fgroup, fname, ftype, fsubtype and fURI can be updated
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="mmfUid">MetricMapFeature UID</param>
        /// <param name="patchmetricmapfeature">Update data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>ApiResponse of MetricMapFeaturesEndpointType</returns>
        ApiResponse<MetricMapFeaturesEndpointType> UpdateMetricMapFeatureWithHttpInfo (string mmfUid, RFC6902PatchRequest patchmetricmapfeature, string envelope = null, string i4lProcessUid = null);
        #endregion Synchronous Operations
        #region Asynchronous Operations
        /// <summary>
        /// Returns MetricMapFeature
        /// </summary>
        /// <remarks>
        /// Returns MetricMapFeature in a GeoJSON structure. A metric map feature is modeled as a feature in  the GeoJSON structure.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="querywindow">Polygon. The polygon is encoded a comma separated list of coordinates. X1, Y1, X2, Y2, ..., Xn, Yn, X1, Y1</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="fgroup">Restricts the output to the listed feature group (optional)</param>
        /// <param name="ftype">Restricts the output to the listed feature types. When used in combination with fgroup, output contains only those ftype which are contained in the feature groups (optional)</param>
        /// <param name="fsubtype">Restricts the output to the listed feature types. When used in combination with fgroup and/or ftype, output contains only those fsubtype which are contained in the feature groups and feature types (optional)</param>
        /// <returns>Task of MetricMapFeaturesEndpointType</returns>
        System.Threading.Tasks.Task<MetricMapFeaturesEndpointType> GetMetricMapFeatureAsync (string querywindow, string envelope = null, string fgroup = null, string ftype = null, string fsubtype = null);

        /// <summary>
        /// Returns MetricMapFeature
        /// </summary>
        /// <remarks>
        /// Returns MetricMapFeature in a GeoJSON structure. A metric map feature is modeled as a feature in  the GeoJSON structure.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="querywindow">Polygon. The polygon is encoded a comma separated list of coordinates. X1, Y1, X2, Y2, ..., Xn, Yn, X1, Y1</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="fgroup">Restricts the output to the listed feature group (optional)</param>
        /// <param name="ftype">Restricts the output to the listed feature types. When used in combination with fgroup, output contains only those ftype which are contained in the feature groups (optional)</param>
        /// <param name="fsubtype">Restricts the output to the listed feature types. When used in combination with fgroup and/or ftype, output contains only those fsubtype which are contained in the feature groups and feature types (optional)</param>
        /// <returns>Task of ApiResponse (MetricMapFeaturesEndpointType)</returns>
        System.Threading.Tasks.Task<ApiResponse<MetricMapFeaturesEndpointType>> GetMetricMapFeatureAsyncWithHttpInfo (string querywindow, string envelope = null, string fgroup = null, string ftype = null, string fsubtype = null);
        /// <summary>
        /// Create a new metricMapFeature
        /// </summary>
        /// <remarks>
        /// Create a new MetricMapFeature. The new metric map feature is a feature in the GeoJSON structure. Currently ony one new feature per request is allowed.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newmetricmapfeature">New MetricMap Feature data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of MetricMapFeaturesEndpointType</returns>
        System.Threading.Tasks.Task<MetricMapFeaturesEndpointType> NewMetricMapFeatureAsync (MetricMapFeaturePostRequest newmetricmapfeature, string envelope = null, string i4lProcessUid = null);

        /// <summary>
        /// Create a new metricMapFeature
        /// </summary>
        /// <remarks>
        /// Create a new MetricMapFeature. The new metric map feature is a feature in the GeoJSON structure. Currently ony one new feature per request is allowed.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newmetricmapfeature">New MetricMap Feature data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of ApiResponse (MetricMapFeaturesEndpointType)</returns>
        System.Threading.Tasks.Task<ApiResponse<MetricMapFeaturesEndpointType>> NewMetricMapFeatureAsyncWithHttpInfo (MetricMapFeaturePostRequest newmetricmapfeature, string envelope = null, string i4lProcessUid = null);
        /// <summary>
        /// Updates a metric map feature
        /// </summary>
        /// <remarks>
        /// Updates a metric map feature. Only fgroup, fname, ftype, fsubtype and fURI can be updated
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="mmfUid">MetricMapFeature UID</param>
        /// <param name="patchmetricmapfeature">Update data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of MetricMapFeaturesEndpointType</returns>
        System.Threading.Tasks.Task<MetricMapFeaturesEndpointType> UpdateMetricMapFeatureAsync (string mmfUid, RFC6902PatchRequest patchmetricmapfeature, string envelope = null, string i4lProcessUid = null);

        /// <summary>
        /// Updates a metric map feature
        /// </summary>
        /// <remarks>
        /// Updates a metric map feature. Only fgroup, fname, ftype, fsubtype and fURI can be updated
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="mmfUid">MetricMapFeature UID</param>
        /// <param name="patchmetricmapfeature">Update data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of ApiResponse (MetricMapFeaturesEndpointType)</returns>
        System.Threading.Tasks.Task<ApiResponse<MetricMapFeaturesEndpointType>> UpdateMetricMapFeatureAsyncWithHttpInfo (string mmfUid, RFC6902PatchRequest patchmetricmapfeature, string envelope = null, string i4lProcessUid = null);
        #endregion Asynchronous Operations
    }

    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public partial class MetricMapFeaturesApi : IMetricMapFeaturesApi
    {
        private IO.Swagger.Client.ExceptionFactory _exceptionFactory = (name, response) => null;

        /// <summary>
        /// Initializes a new instance of the <see cref="MetricMapFeaturesApi"/> class.
        /// </summary>
        /// <returns></returns>
        public MetricMapFeaturesApi(String basePath)
        {
            this.Configuration = new Configuration { BasePath = basePath };

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="MetricMapFeaturesApi"/> class
        /// using Configuration object
        /// </summary>
        /// <param name="configuration">An instance of Configuration</param>
        /// <returns></returns>
        public MetricMapFeaturesApi(Configuration configuration = null)
        {
            if (configuration == null) // use the default one in Configuration
                this.Configuration = Configuration.Default;
            else
                this.Configuration = configuration;

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Gets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        public String GetBasePath()
        {
            return this.Configuration.ApiClient.RestClient.BaseUrl.ToString();
        }

        /// <summary>
        /// Sets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        [Obsolete("SetBasePath is deprecated, please do 'Configuration.ApiClient = new ApiClient(\"http://new-path\")' instead.")]
        public void SetBasePath(String basePath)
        {
            // do nothing
        }

        /// <summary>
        /// Gets or sets the configuration object
        /// </summary>
        /// <value>An instance of the Configuration</value>
        public Configuration Configuration {get; set;}

        /// <summary>
        /// Provides a factory method hook for the creation of exceptions.
        /// </summary>
        public IO.Swagger.Client.ExceptionFactory ExceptionFactory
        {
            get
            {
                if (_exceptionFactory != null && _exceptionFactory.GetInvocationList().Length > 1)
                {
                    throw new InvalidOperationException("Multicast delegate for ExceptionFactory is unsupported.");
                }
                return _exceptionFactory;
            }
            set { _exceptionFactory = value; }
        }

        /// <summary>
        /// Gets the default header.
        /// </summary>
        /// <returns>Dictionary of HTTP header</returns>
        [Obsolete("DefaultHeader is deprecated, please use Configuration.DefaultHeader instead.")]
        public IDictionary<String, String> DefaultHeader()
        {
            return new ReadOnlyDictionary<string, string>(this.Configuration.DefaultHeader);
        }

        /// <summary>
        /// Add default header.
        /// </summary>
        /// <param name="key">Header field name.</param>
        /// <param name="value">Header field value.</param>
        /// <returns></returns>
        [Obsolete("AddDefaultHeader is deprecated, please use Configuration.AddDefaultHeader instead.")]
        public void AddDefaultHeader(string key, string value)
        {
            this.Configuration.AddDefaultHeader(key, value);
        }

        /// <summary>
        /// Returns MetricMapFeature Returns MetricMapFeature in a GeoJSON structure. A metric map feature is modeled as a feature in  the GeoJSON structure.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="querywindow">Polygon. The polygon is encoded a comma separated list of coordinates. X1, Y1, X2, Y2, ..., Xn, Yn, X1, Y1</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="fgroup">Restricts the output to the listed feature group (optional)</param>
        /// <param name="ftype">Restricts the output to the listed feature types. When used in combination with fgroup, output contains only those ftype which are contained in the feature groups (optional)</param>
        /// <param name="fsubtype">Restricts the output to the listed feature types. When used in combination with fgroup and/or ftype, output contains only those fsubtype which are contained in the feature groups and feature types (optional)</param>
        /// <returns>MetricMapFeaturesEndpointType</returns>
        public MetricMapFeaturesEndpointType GetMetricMapFeature (string querywindow, string envelope = null, string fgroup = null, string ftype = null, string fsubtype = null)
        {
             ApiResponse<MetricMapFeaturesEndpointType> localVarResponse = GetMetricMapFeatureWithHttpInfo(querywindow, envelope, fgroup, ftype, fsubtype);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Returns MetricMapFeature Returns MetricMapFeature in a GeoJSON structure. A metric map feature is modeled as a feature in  the GeoJSON structure.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="querywindow">Polygon. The polygon is encoded a comma separated list of coordinates. X1, Y1, X2, Y2, ..., Xn, Yn, X1, Y1</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="fgroup">Restricts the output to the listed feature group (optional)</param>
        /// <param name="ftype">Restricts the output to the listed feature types. When used in combination with fgroup, output contains only those ftype which are contained in the feature groups (optional)</param>
        /// <param name="fsubtype">Restricts the output to the listed feature types. When used in combination with fgroup and/or ftype, output contains only those fsubtype which are contained in the feature groups and feature types (optional)</param>
        /// <returns>ApiResponse of MetricMapFeaturesEndpointType</returns>
        public ApiResponse< MetricMapFeaturesEndpointType > GetMetricMapFeatureWithHttpInfo (string querywindow, string envelope = null, string fgroup = null, string ftype = null, string fsubtype = null)
        {
            // verify the required parameter 'querywindow' is set
            if (querywindow == null)
                throw new ApiException(400, "Missing required parameter 'querywindow' when calling MetricMapFeaturesApi->GetMetricMapFeature");

            var localVarPath = "/metricmapfeature";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (querywindow != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "querywindow", querywindow)); // query parameter
            if (fgroup != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "fgroup", fgroup)); // query parameter
            if (ftype != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "ftype", ftype)); // query parameter
            if (fsubtype != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "fsubtype", fsubtype)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetMetricMapFeature", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<MetricMapFeaturesEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (MetricMapFeaturesEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(MetricMapFeaturesEndpointType)));
        }

        /// <summary>
        /// Returns MetricMapFeature Returns MetricMapFeature in a GeoJSON structure. A metric map feature is modeled as a feature in  the GeoJSON structure.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="querywindow">Polygon. The polygon is encoded a comma separated list of coordinates. X1, Y1, X2, Y2, ..., Xn, Yn, X1, Y1</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="fgroup">Restricts the output to the listed feature group (optional)</param>
        /// <param name="ftype">Restricts the output to the listed feature types. When used in combination with fgroup, output contains only those ftype which are contained in the feature groups (optional)</param>
        /// <param name="fsubtype">Restricts the output to the listed feature types. When used in combination with fgroup and/or ftype, output contains only those fsubtype which are contained in the feature groups and feature types (optional)</param>
        /// <returns>Task of MetricMapFeaturesEndpointType</returns>
        public async System.Threading.Tasks.Task<MetricMapFeaturesEndpointType> GetMetricMapFeatureAsync (string querywindow, string envelope = null, string fgroup = null, string ftype = null, string fsubtype = null)
        {
             ApiResponse<MetricMapFeaturesEndpointType> localVarResponse = await GetMetricMapFeatureAsyncWithHttpInfo(querywindow, envelope, fgroup, ftype, fsubtype);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Returns MetricMapFeature Returns MetricMapFeature in a GeoJSON structure. A metric map feature is modeled as a feature in  the GeoJSON structure.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="querywindow">Polygon. The polygon is encoded a comma separated list of coordinates. X1, Y1, X2, Y2, ..., Xn, Yn, X1, Y1</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="fgroup">Restricts the output to the listed feature group (optional)</param>
        /// <param name="ftype">Restricts the output to the listed feature types. When used in combination with fgroup, output contains only those ftype which are contained in the feature groups (optional)</param>
        /// <param name="fsubtype">Restricts the output to the listed feature types. When used in combination with fgroup and/or ftype, output contains only those fsubtype which are contained in the feature groups and feature types (optional)</param>
        /// <returns>Task of ApiResponse (MetricMapFeaturesEndpointType)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<MetricMapFeaturesEndpointType>> GetMetricMapFeatureAsyncWithHttpInfo (string querywindow, string envelope = null, string fgroup = null, string ftype = null, string fsubtype = null)
        {
            // verify the required parameter 'querywindow' is set
            if (querywindow == null)
                throw new ApiException(400, "Missing required parameter 'querywindow' when calling MetricMapFeaturesApi->GetMetricMapFeature");

            var localVarPath = "/metricmapfeature";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (querywindow != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "querywindow", querywindow)); // query parameter
            if (fgroup != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "fgroup", fgroup)); // query parameter
            if (ftype != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "ftype", ftype)); // query parameter
            if (fsubtype != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "fsubtype", fsubtype)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetMetricMapFeature", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<MetricMapFeaturesEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (MetricMapFeaturesEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(MetricMapFeaturesEndpointType)));
        }

        /// <summary>
        /// Create a new metricMapFeature Create a new MetricMapFeature. The new metric map feature is a feature in the GeoJSON structure. Currently ony one new feature per request is allowed.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newmetricmapfeature">New MetricMap Feature data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>MetricMapFeaturesEndpointType</returns>
        public MetricMapFeaturesEndpointType NewMetricMapFeature (MetricMapFeaturePostRequest newmetricmapfeature, string envelope = null, string i4lProcessUid = null)
        {
             ApiResponse<MetricMapFeaturesEndpointType> localVarResponse = NewMetricMapFeatureWithHttpInfo(newmetricmapfeature, envelope, i4lProcessUid);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Create a new metricMapFeature Create a new MetricMapFeature. The new metric map feature is a feature in the GeoJSON structure. Currently ony one new feature per request is allowed.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newmetricmapfeature">New MetricMap Feature data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>ApiResponse of MetricMapFeaturesEndpointType</returns>
        public ApiResponse< MetricMapFeaturesEndpointType > NewMetricMapFeatureWithHttpInfo (MetricMapFeaturePostRequest newmetricmapfeature, string envelope = null, string i4lProcessUid = null)
        {
            // verify the required parameter 'newmetricmapfeature' is set
            if (newmetricmapfeature == null)
                throw new ApiException(400, "Missing required parameter 'newmetricmapfeature' when calling MetricMapFeaturesApi->NewMetricMapFeature");

            var localVarPath = "/metricmapfeature";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (i4lProcessUid != null) localVarHeaderParams.Add("i4l-process-uid", Configuration.ApiClient.ParameterToString(i4lProcessUid)); // header parameter
            if (newmetricmapfeature != null && newmetricmapfeature.GetType() != typeof(byte[]))
            {
                localVarPostBody = Configuration.ApiClient.Serialize(newmetricmapfeature); // http body (model) parameter
            }
            else
            {
                localVarPostBody = newmetricmapfeature; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("NewMetricMapFeature", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<MetricMapFeaturesEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (MetricMapFeaturesEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(MetricMapFeaturesEndpointType)));
        }

        /// <summary>
        /// Create a new metricMapFeature Create a new MetricMapFeature. The new metric map feature is a feature in the GeoJSON structure. Currently ony one new feature per request is allowed.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newmetricmapfeature">New MetricMap Feature data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of MetricMapFeaturesEndpointType</returns>
        public async System.Threading.Tasks.Task<MetricMapFeaturesEndpointType> NewMetricMapFeatureAsync (MetricMapFeaturePostRequest newmetricmapfeature, string envelope = null, string i4lProcessUid = null)
        {
             ApiResponse<MetricMapFeaturesEndpointType> localVarResponse = await NewMetricMapFeatureAsyncWithHttpInfo(newmetricmapfeature, envelope, i4lProcessUid);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Create a new metricMapFeature Create a new MetricMapFeature. The new metric map feature is a feature in the GeoJSON structure. Currently ony one new feature per request is allowed.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newmetricmapfeature">New MetricMap Feature data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of ApiResponse (MetricMapFeaturesEndpointType)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<MetricMapFeaturesEndpointType>> NewMetricMapFeatureAsyncWithHttpInfo (MetricMapFeaturePostRequest newmetricmapfeature, string envelope = null, string i4lProcessUid = null)
        {
            // verify the required parameter 'newmetricmapfeature' is set
            if (newmetricmapfeature == null)
                throw new ApiException(400, "Missing required parameter 'newmetricmapfeature' when calling MetricMapFeaturesApi->NewMetricMapFeature");

            var localVarPath = "/metricmapfeature";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (i4lProcessUid != null) localVarHeaderParams.Add("i4l-process-uid", Configuration.ApiClient.ParameterToString(i4lProcessUid)); // header parameter
            if (newmetricmapfeature != null && newmetricmapfeature.GetType() != typeof(byte[]))
            {
                localVarPostBody = Configuration.ApiClient.Serialize(newmetricmapfeature); // http body (model) parameter
            }
            else
            {
                localVarPostBody = newmetricmapfeature; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("NewMetricMapFeature", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<MetricMapFeaturesEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (MetricMapFeaturesEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(MetricMapFeaturesEndpointType)));
        }

        /// <summary>
        /// Updates a metric map feature Updates a metric map feature. Only fgroup, fname, ftype, fsubtype and fURI can be updated
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="mmfUid">MetricMapFeature UID</param>
        /// <param name="patchmetricmapfeature">Update data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>MetricMapFeaturesEndpointType</returns>
        public MetricMapFeaturesEndpointType UpdateMetricMapFeature (string mmfUid, RFC6902PatchRequest patchmetricmapfeature, string envelope = null, string i4lProcessUid = null)
        {
             ApiResponse<MetricMapFeaturesEndpointType> localVarResponse = UpdateMetricMapFeatureWithHttpInfo(mmfUid, patchmetricmapfeature, envelope, i4lProcessUid);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Updates a metric map feature Updates a metric map feature. Only fgroup, fname, ftype, fsubtype and fURI can be updated
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="mmfUid">MetricMapFeature UID</param>
        /// <param name="patchmetricmapfeature">Update data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>ApiResponse of MetricMapFeaturesEndpointType</returns>
        public ApiResponse< MetricMapFeaturesEndpointType > UpdateMetricMapFeatureWithHttpInfo (string mmfUid, RFC6902PatchRequest patchmetricmapfeature, string envelope = null, string i4lProcessUid = null)
        {
            // verify the required parameter 'mmfUid' is set
            if (mmfUid == null)
                throw new ApiException(400, "Missing required parameter 'mmfUid' when calling MetricMapFeaturesApi->UpdateMetricMapFeature");
            // verify the required parameter 'patchmetricmapfeature' is set
            if (patchmetricmapfeature == null)
                throw new ApiException(400, "Missing required parameter 'patchmetricmapfeature' when calling MetricMapFeaturesApi->UpdateMetricMapFeature");

            var localVarPath = "/metricmapfeature/{mmf_uid}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (mmfUid != null) localVarPathParams.Add("mmf_uid", Configuration.ApiClient.ParameterToString(mmfUid)); // path parameter
            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (i4lProcessUid != null) localVarHeaderParams.Add("i4l-process-uid", Configuration.ApiClient.ParameterToString(i4lProcessUid)); // header parameter
            if (patchmetricmapfeature != null && patchmetricmapfeature.GetType() != typeof(byte[]))
            {
                localVarPostBody = Configuration.ApiClient.Serialize(patchmetricmapfeature); // http body (model) parameter
            }
            else
            {
                localVarPostBody = patchmetricmapfeature; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.PATCH, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("UpdateMetricMapFeature", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<MetricMapFeaturesEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (MetricMapFeaturesEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(MetricMapFeaturesEndpointType)));
        }

        /// <summary>
        /// Updates a metric map feature Updates a metric map feature. Only fgroup, fname, ftype, fsubtype and fURI can be updated
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="mmfUid">MetricMapFeature UID</param>
        /// <param name="patchmetricmapfeature">Update data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of MetricMapFeaturesEndpointType</returns>
        public async System.Threading.Tasks.Task<MetricMapFeaturesEndpointType> UpdateMetricMapFeatureAsync (string mmfUid, RFC6902PatchRequest patchmetricmapfeature, string envelope = null, string i4lProcessUid = null)
        {
             ApiResponse<MetricMapFeaturesEndpointType> localVarResponse = await UpdateMetricMapFeatureAsyncWithHttpInfo(mmfUid, patchmetricmapfeature, envelope, i4lProcessUid);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Updates a metric map feature Updates a metric map feature. Only fgroup, fname, ftype, fsubtype and fURI can be updated
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="mmfUid">MetricMapFeature UID</param>
        /// <param name="patchmetricmapfeature">Update data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of ApiResponse (MetricMapFeaturesEndpointType)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<MetricMapFeaturesEndpointType>> UpdateMetricMapFeatureAsyncWithHttpInfo (string mmfUid, RFC6902PatchRequest patchmetricmapfeature, string envelope = null, string i4lProcessUid = null)
        {
            // verify the required parameter 'mmfUid' is set
            if (mmfUid == null)
                throw new ApiException(400, "Missing required parameter 'mmfUid' when calling MetricMapFeaturesApi->UpdateMetricMapFeature");
            // verify the required parameter 'patchmetricmapfeature' is set
            if (patchmetricmapfeature == null)
                throw new ApiException(400, "Missing required parameter 'patchmetricmapfeature' when calling MetricMapFeaturesApi->UpdateMetricMapFeature");

            var localVarPath = "/metricmapfeature/{mmf_uid}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (mmfUid != null) localVarPathParams.Add("mmf_uid", Configuration.ApiClient.ParameterToString(mmfUid)); // path parameter
            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (i4lProcessUid != null) localVarHeaderParams.Add("i4l-process-uid", Configuration.ApiClient.ParameterToString(i4lProcessUid)); // header parameter
            if (patchmetricmapfeature != null && patchmetricmapfeature.GetType() != typeof(byte[]))
            {
                localVarPostBody = Configuration.ApiClient.Serialize(patchmetricmapfeature); // http body (model) parameter
            }
            else
            {
                localVarPostBody = patchmetricmapfeature; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.PATCH, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("UpdateMetricMapFeature", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<MetricMapFeaturesEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (MetricMapFeaturesEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(MetricMapFeaturesEndpointType)));
        }

    }
}
