/* 
 * its4land Public API
 *
 * The its4land Public API provides access to the services of the its4land Publish and Share platform.
 *
 * OpenAPI spec version: 0.0.2
 * Contact: contact@its4land.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using RestSharp;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace IO.Swagger.Api
{
    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public interface IModelsApi : IApiAccessor
    {
        #region Synchronous Operations
        /// <summary>
        /// Returns a list of models.
        /// </summary>
        /// <remarks>
        /// Returns a list of models.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="uid">Comma separated list of model UID (optional)</param>
        /// <param name="name">Comma separated list of model names (optional)</param>
        /// <param name="tools">Comma separated list tool names which can make use of the model. (optional)</param>
        /// <param name="projects">Comma separated list of project UID (optional)</param>
        /// <param name="tags">Comma separated list of tags (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of field names (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>List&lt;ModelsEndpointType&gt;</returns>
        List<ModelsEndpointType> GetModels (string envelope = null, List<string> uid = null, List<string> name = null, List<string> tools = null, List<string> projects = null, List<string> tags = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null);

        /// <summary>
        /// Returns a list of models.
        /// </summary>
        /// <remarks>
        /// Returns a list of models.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="uid">Comma separated list of model UID (optional)</param>
        /// <param name="name">Comma separated list of model names (optional)</param>
        /// <param name="tools">Comma separated list tool names which can make use of the model. (optional)</param>
        /// <param name="projects">Comma separated list of project UID (optional)</param>
        /// <param name="tags">Comma separated list of tags (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of field names (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>ApiResponse of List&lt;ModelsEndpointType&gt;</returns>
        ApiResponse<List<ModelsEndpointType>> GetModelsWithHttpInfo (string envelope = null, List<string> uid = null, List<string> name = null, List<string> tools = null, List<string> projects = null, List<string> tags = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null);
        /// <summary>
        /// Returns a single model
        /// </summary>
        /// <remarks>
        /// Returns a single model
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="modelUid">Model  UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>ModelsEndpointType</returns>
        ModelsEndpointType GetModelsByUID (string modelUid, string envelope = null, List<string> embed = null);

        /// <summary>
        /// Returns a single model
        /// </summary>
        /// <remarks>
        /// Returns a single model
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="modelUid">Model  UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>ApiResponse of ModelsEndpointType</returns>
        ApiResponse<ModelsEndpointType> GetModelsByUIDWithHttpInfo (string modelUid, string envelope = null, List<string> embed = null);
        /// <summary>
        /// Returns the model classes of the classifier.
        /// </summary>
        /// <remarks>
        /// Returns the model classes of the classifier.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="modelUid">Model  UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>List&lt;ModelClassesEndpointType&gt;</returns>
        List<ModelClassesEndpointType> GetModelsClassesByModel (string modelUid, string envelope = null, List<string> embed = null);

        /// <summary>
        /// Returns the model classes of the classifier.
        /// </summary>
        /// <remarks>
        /// Returns the model classes of the classifier.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="modelUid">Model  UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>ApiResponse of List&lt;ModelClassesEndpointType&gt;</returns>
        ApiResponse<List<ModelClassesEndpointType>> GetModelsClassesByModelWithHttpInfo (string modelUid, string envelope = null, List<string> embed = null);
        /// <summary>
        /// Create a new model
        /// </summary>
        /// <remarks>
        /// Create a new model. The model can be assigned to a project via the patch://project method. To add a new SpatialSources , the content of Models  must be stored in advanced via the ContentItem endpoint
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newmodel">New Model data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>ModelsEndpointType</returns>
        ModelsEndpointType NewModel (ModelsPostRequest newmodel, string envelope = null, List<string> embed = null, string i4lProcessUid = null);

        /// <summary>
        /// Create a new model
        /// </summary>
        /// <remarks>
        /// Create a new model. The model can be assigned to a project via the patch://project method. To add a new SpatialSources , the content of Models  must be stored in advanced via the ContentItem endpoint
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newmodel">New Model data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>ApiResponse of ModelsEndpointType</returns>
        ApiResponse<ModelsEndpointType> NewModelWithHttpInfo (ModelsPostRequest newmodel, string envelope = null, List<string> embed = null, string i4lProcessUid = null);
        /// <summary>
        /// Create a new ModelClass under a model
        /// </summary>
        /// <remarks>
        /// Create a new ModelClass under a model
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="modelUid">Model  UID</param>
        /// <param name="newmodelclass">New ModelClass data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>ModelClassesEndpointType</returns>
        ModelClassesEndpointType NewModelClassUnderModel (string modelUid, ModelClassesPostRequest newmodelclass, string envelope = null, List<string> embed = null, string i4lProcessUid = null);

        /// <summary>
        /// Create a new ModelClass under a model
        /// </summary>
        /// <remarks>
        /// Create a new ModelClass under a model
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="modelUid">Model  UID</param>
        /// <param name="newmodelclass">New ModelClass data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>ApiResponse of ModelClassesEndpointType</returns>
        ApiResponse<ModelClassesEndpointType> NewModelClassUnderModelWithHttpInfo (string modelUid, ModelClassesPostRequest newmodelclass, string envelope = null, List<string> embed = null, string i4lProcessUid = null);
        /// <summary>
        /// Updates some attributes of a model
        /// </summary>
        /// <remarks>
        /// Updates some attributes of a model
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="modelUid">Model  UID</param>
        /// <param name="patchmodel">Update data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>ModelsEndpointType</returns>
        ModelsEndpointType UpdateModels (string modelUid, RFC6902PatchRequest patchmodel, string envelope = null, List<string> embed = null, string i4lProcessUid = null);

        /// <summary>
        /// Updates some attributes of a model
        /// </summary>
        /// <remarks>
        /// Updates some attributes of a model
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="modelUid">Model  UID</param>
        /// <param name="patchmodel">Update data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>ApiResponse of ModelsEndpointType</returns>
        ApiResponse<ModelsEndpointType> UpdateModelsWithHttpInfo (string modelUid, RFC6902PatchRequest patchmodel, string envelope = null, List<string> embed = null, string i4lProcessUid = null);
        #endregion Synchronous Operations
        #region Asynchronous Operations
        /// <summary>
        /// Returns a list of models.
        /// </summary>
        /// <remarks>
        /// Returns a list of models.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="uid">Comma separated list of model UID (optional)</param>
        /// <param name="name">Comma separated list of model names (optional)</param>
        /// <param name="tools">Comma separated list tool names which can make use of the model. (optional)</param>
        /// <param name="projects">Comma separated list of project UID (optional)</param>
        /// <param name="tags">Comma separated list of tags (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of field names (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of List&lt;ModelsEndpointType&gt;</returns>
        System.Threading.Tasks.Task<List<ModelsEndpointType>> GetModelsAsync (string envelope = null, List<string> uid = null, List<string> name = null, List<string> tools = null, List<string> projects = null, List<string> tags = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null);

        /// <summary>
        /// Returns a list of models.
        /// </summary>
        /// <remarks>
        /// Returns a list of models.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="uid">Comma separated list of model UID (optional)</param>
        /// <param name="name">Comma separated list of model names (optional)</param>
        /// <param name="tools">Comma separated list tool names which can make use of the model. (optional)</param>
        /// <param name="projects">Comma separated list of project UID (optional)</param>
        /// <param name="tags">Comma separated list of tags (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of field names (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;ModelsEndpointType&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<ModelsEndpointType>>> GetModelsAsyncWithHttpInfo (string envelope = null, List<string> uid = null, List<string> name = null, List<string> tools = null, List<string> projects = null, List<string> tags = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null);
        /// <summary>
        /// Returns a single model
        /// </summary>
        /// <remarks>
        /// Returns a single model
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="modelUid">Model  UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of ModelsEndpointType</returns>
        System.Threading.Tasks.Task<ModelsEndpointType> GetModelsByUIDAsync (string modelUid, string envelope = null, List<string> embed = null);

        /// <summary>
        /// Returns a single model
        /// </summary>
        /// <remarks>
        /// Returns a single model
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="modelUid">Model  UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of ApiResponse (ModelsEndpointType)</returns>
        System.Threading.Tasks.Task<ApiResponse<ModelsEndpointType>> GetModelsByUIDAsyncWithHttpInfo (string modelUid, string envelope = null, List<string> embed = null);
        /// <summary>
        /// Returns the model classes of the classifier.
        /// </summary>
        /// <remarks>
        /// Returns the model classes of the classifier.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="modelUid">Model  UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of List&lt;ModelClassesEndpointType&gt;</returns>
        System.Threading.Tasks.Task<List<ModelClassesEndpointType>> GetModelsClassesByModelAsync (string modelUid, string envelope = null, List<string> embed = null);

        /// <summary>
        /// Returns the model classes of the classifier.
        /// </summary>
        /// <remarks>
        /// Returns the model classes of the classifier.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="modelUid">Model  UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;ModelClassesEndpointType&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<ModelClassesEndpointType>>> GetModelsClassesByModelAsyncWithHttpInfo (string modelUid, string envelope = null, List<string> embed = null);
        /// <summary>
        /// Create a new model
        /// </summary>
        /// <remarks>
        /// Create a new model. The model can be assigned to a project via the patch://project method. To add a new SpatialSources , the content of Models  must be stored in advanced via the ContentItem endpoint
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newmodel">New Model data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of ModelsEndpointType</returns>
        System.Threading.Tasks.Task<ModelsEndpointType> NewModelAsync (ModelsPostRequest newmodel, string envelope = null, List<string> embed = null, string i4lProcessUid = null);

        /// <summary>
        /// Create a new model
        /// </summary>
        /// <remarks>
        /// Create a new model. The model can be assigned to a project via the patch://project method. To add a new SpatialSources , the content of Models  must be stored in advanced via the ContentItem endpoint
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newmodel">New Model data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of ApiResponse (ModelsEndpointType)</returns>
        System.Threading.Tasks.Task<ApiResponse<ModelsEndpointType>> NewModelAsyncWithHttpInfo (ModelsPostRequest newmodel, string envelope = null, List<string> embed = null, string i4lProcessUid = null);
        /// <summary>
        /// Create a new ModelClass under a model
        /// </summary>
        /// <remarks>
        /// Create a new ModelClass under a model
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="modelUid">Model  UID</param>
        /// <param name="newmodelclass">New ModelClass data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of ModelClassesEndpointType</returns>
        System.Threading.Tasks.Task<ModelClassesEndpointType> NewModelClassUnderModelAsync (string modelUid, ModelClassesPostRequest newmodelclass, string envelope = null, List<string> embed = null, string i4lProcessUid = null);

        /// <summary>
        /// Create a new ModelClass under a model
        /// </summary>
        /// <remarks>
        /// Create a new ModelClass under a model
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="modelUid">Model  UID</param>
        /// <param name="newmodelclass">New ModelClass data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of ApiResponse (ModelClassesEndpointType)</returns>
        System.Threading.Tasks.Task<ApiResponse<ModelClassesEndpointType>> NewModelClassUnderModelAsyncWithHttpInfo (string modelUid, ModelClassesPostRequest newmodelclass, string envelope = null, List<string> embed = null, string i4lProcessUid = null);
        /// <summary>
        /// Updates some attributes of a model
        /// </summary>
        /// <remarks>
        /// Updates some attributes of a model
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="modelUid">Model  UID</param>
        /// <param name="patchmodel">Update data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of ModelsEndpointType</returns>
        System.Threading.Tasks.Task<ModelsEndpointType> UpdateModelsAsync (string modelUid, RFC6902PatchRequest patchmodel, string envelope = null, List<string> embed = null, string i4lProcessUid = null);

        /// <summary>
        /// Updates some attributes of a model
        /// </summary>
        /// <remarks>
        /// Updates some attributes of a model
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="modelUid">Model  UID</param>
        /// <param name="patchmodel">Update data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of ApiResponse (ModelsEndpointType)</returns>
        System.Threading.Tasks.Task<ApiResponse<ModelsEndpointType>> UpdateModelsAsyncWithHttpInfo (string modelUid, RFC6902PatchRequest patchmodel, string envelope = null, List<string> embed = null, string i4lProcessUid = null);
        #endregion Asynchronous Operations
    }

    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public partial class ModelsApi : IModelsApi
    {
        private IO.Swagger.Client.ExceptionFactory _exceptionFactory = (name, response) => null;

        /// <summary>
        /// Initializes a new instance of the <see cref="ModelsApi"/> class.
        /// </summary>
        /// <returns></returns>
        public ModelsApi(String basePath)
        {
            this.Configuration = new Configuration { BasePath = basePath };

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="ModelsApi"/> class
        /// using Configuration object
        /// </summary>
        /// <param name="configuration">An instance of Configuration</param>
        /// <returns></returns>
        public ModelsApi(Configuration configuration = null)
        {
            if (configuration == null) // use the default one in Configuration
                this.Configuration = Configuration.Default;
            else
                this.Configuration = configuration;

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Gets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        public String GetBasePath()
        {
            return this.Configuration.ApiClient.RestClient.BaseUrl.ToString();
        }

        /// <summary>
        /// Sets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        [Obsolete("SetBasePath is deprecated, please do 'Configuration.ApiClient = new ApiClient(\"http://new-path\")' instead.")]
        public void SetBasePath(String basePath)
        {
            // do nothing
        }

        /// <summary>
        /// Gets or sets the configuration object
        /// </summary>
        /// <value>An instance of the Configuration</value>
        public Configuration Configuration {get; set;}

        /// <summary>
        /// Provides a factory method hook for the creation of exceptions.
        /// </summary>
        public IO.Swagger.Client.ExceptionFactory ExceptionFactory
        {
            get
            {
                if (_exceptionFactory != null && _exceptionFactory.GetInvocationList().Length > 1)
                {
                    throw new InvalidOperationException("Multicast delegate for ExceptionFactory is unsupported.");
                }
                return _exceptionFactory;
            }
            set { _exceptionFactory = value; }
        }

        /// <summary>
        /// Gets the default header.
        /// </summary>
        /// <returns>Dictionary of HTTP header</returns>
        [Obsolete("DefaultHeader is deprecated, please use Configuration.DefaultHeader instead.")]
        public IDictionary<String, String> DefaultHeader()
        {
            return new ReadOnlyDictionary<string, string>(this.Configuration.DefaultHeader);
        }

        /// <summary>
        /// Add default header.
        /// </summary>
        /// <param name="key">Header field name.</param>
        /// <param name="value">Header field value.</param>
        /// <returns></returns>
        [Obsolete("AddDefaultHeader is deprecated, please use Configuration.AddDefaultHeader instead.")]
        public void AddDefaultHeader(string key, string value)
        {
            this.Configuration.AddDefaultHeader(key, value);
        }

        /// <summary>
        /// Returns a list of models. Returns a list of models.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="uid">Comma separated list of model UID (optional)</param>
        /// <param name="name">Comma separated list of model names (optional)</param>
        /// <param name="tools">Comma separated list tool names which can make use of the model. (optional)</param>
        /// <param name="projects">Comma separated list of project UID (optional)</param>
        /// <param name="tags">Comma separated list of tags (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of field names (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>List&lt;ModelsEndpointType&gt;</returns>
        public List<ModelsEndpointType> GetModels (string envelope = null, List<string> uid = null, List<string> name = null, List<string> tools = null, List<string> projects = null, List<string> tags = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null)
        {
             ApiResponse<List<ModelsEndpointType>> localVarResponse = GetModelsWithHttpInfo(envelope, uid, name, tools, projects, tags, page, sort, fields, embed);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Returns a list of models. Returns a list of models.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="uid">Comma separated list of model UID (optional)</param>
        /// <param name="name">Comma separated list of model names (optional)</param>
        /// <param name="tools">Comma separated list tool names which can make use of the model. (optional)</param>
        /// <param name="projects">Comma separated list of project UID (optional)</param>
        /// <param name="tags">Comma separated list of tags (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of field names (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>ApiResponse of List&lt;ModelsEndpointType&gt;</returns>
        public ApiResponse< List<ModelsEndpointType> > GetModelsWithHttpInfo (string envelope = null, List<string> uid = null, List<string> name = null, List<string> tools = null, List<string> projects = null, List<string> tags = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null)
        {

            var localVarPath = "/models";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (uid != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "uid", uid)); // query parameter
            if (name != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "name", name)); // query parameter
            if (tools != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "tools", tools)); // query parameter
            if (projects != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "projects", projects)); // query parameter
            if (tags != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "tags", tags)); // query parameter
            if (page != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "page", page)); // query parameter
            if (sort != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "sort", sort)); // query parameter
            if (fields != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "fields", fields)); // query parameter
            if (embed != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "embed", embed)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetModels", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<ModelsEndpointType>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<ModelsEndpointType>) Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<ModelsEndpointType>)));
        }

        /// <summary>
        /// Returns a list of models. Returns a list of models.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="uid">Comma separated list of model UID (optional)</param>
        /// <param name="name">Comma separated list of model names (optional)</param>
        /// <param name="tools">Comma separated list tool names which can make use of the model. (optional)</param>
        /// <param name="projects">Comma separated list of project UID (optional)</param>
        /// <param name="tags">Comma separated list of tags (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of field names (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of List&lt;ModelsEndpointType&gt;</returns>
        public async System.Threading.Tasks.Task<List<ModelsEndpointType>> GetModelsAsync (string envelope = null, List<string> uid = null, List<string> name = null, List<string> tools = null, List<string> projects = null, List<string> tags = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null)
        {
             ApiResponse<List<ModelsEndpointType>> localVarResponse = await GetModelsAsyncWithHttpInfo(envelope, uid, name, tools, projects, tags, page, sort, fields, embed);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Returns a list of models. Returns a list of models.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="uid">Comma separated list of model UID (optional)</param>
        /// <param name="name">Comma separated list of model names (optional)</param>
        /// <param name="tools">Comma separated list tool names which can make use of the model. (optional)</param>
        /// <param name="projects">Comma separated list of project UID (optional)</param>
        /// <param name="tags">Comma separated list of tags (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of field names (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;ModelsEndpointType&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<ModelsEndpointType>>> GetModelsAsyncWithHttpInfo (string envelope = null, List<string> uid = null, List<string> name = null, List<string> tools = null, List<string> projects = null, List<string> tags = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null)
        {

            var localVarPath = "/models";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (uid != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "uid", uid)); // query parameter
            if (name != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "name", name)); // query parameter
            if (tools != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "tools", tools)); // query parameter
            if (projects != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "projects", projects)); // query parameter
            if (tags != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "tags", tags)); // query parameter
            if (page != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "page", page)); // query parameter
            if (sort != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "sort", sort)); // query parameter
            if (fields != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "fields", fields)); // query parameter
            if (embed != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "embed", embed)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetModels", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<ModelsEndpointType>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<ModelsEndpointType>) Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<ModelsEndpointType>)));
        }

        /// <summary>
        /// Returns a single model Returns a single model
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="modelUid">Model  UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>ModelsEndpointType</returns>
        public ModelsEndpointType GetModelsByUID (string modelUid, string envelope = null, List<string> embed = null)
        {
             ApiResponse<ModelsEndpointType> localVarResponse = GetModelsByUIDWithHttpInfo(modelUid, envelope, embed);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Returns a single model Returns a single model
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="modelUid">Model  UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>ApiResponse of ModelsEndpointType</returns>
        public ApiResponse< ModelsEndpointType > GetModelsByUIDWithHttpInfo (string modelUid, string envelope = null, List<string> embed = null)
        {
            // verify the required parameter 'modelUid' is set
            if (modelUid == null)
                throw new ApiException(400, "Missing required parameter 'modelUid' when calling ModelsApi->GetModelsByUID");

            var localVarPath = "/models/{model_uid}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (modelUid != null) localVarPathParams.Add("model_uid", Configuration.ApiClient.ParameterToString(modelUid)); // path parameter
            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (embed != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "embed", embed)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetModelsByUID", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ModelsEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (ModelsEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(ModelsEndpointType)));
        }

        /// <summary>
        /// Returns a single model Returns a single model
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="modelUid">Model  UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of ModelsEndpointType</returns>
        public async System.Threading.Tasks.Task<ModelsEndpointType> GetModelsByUIDAsync (string modelUid, string envelope = null, List<string> embed = null)
        {
             ApiResponse<ModelsEndpointType> localVarResponse = await GetModelsByUIDAsyncWithHttpInfo(modelUid, envelope, embed);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Returns a single model Returns a single model
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="modelUid">Model  UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of ApiResponse (ModelsEndpointType)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<ModelsEndpointType>> GetModelsByUIDAsyncWithHttpInfo (string modelUid, string envelope = null, List<string> embed = null)
        {
            // verify the required parameter 'modelUid' is set
            if (modelUid == null)
                throw new ApiException(400, "Missing required parameter 'modelUid' when calling ModelsApi->GetModelsByUID");

            var localVarPath = "/models/{model_uid}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (modelUid != null) localVarPathParams.Add("model_uid", Configuration.ApiClient.ParameterToString(modelUid)); // path parameter
            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (embed != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "embed", embed)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetModelsByUID", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ModelsEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (ModelsEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(ModelsEndpointType)));
        }

        /// <summary>
        /// Returns the model classes of the classifier. Returns the model classes of the classifier.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="modelUid">Model  UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>List&lt;ModelClassesEndpointType&gt;</returns>
        public List<ModelClassesEndpointType> GetModelsClassesByModel (string modelUid, string envelope = null, List<string> embed = null)
        {
             ApiResponse<List<ModelClassesEndpointType>> localVarResponse = GetModelsClassesByModelWithHttpInfo(modelUid, envelope, embed);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Returns the model classes of the classifier. Returns the model classes of the classifier.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="modelUid">Model  UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>ApiResponse of List&lt;ModelClassesEndpointType&gt;</returns>
        public ApiResponse< List<ModelClassesEndpointType> > GetModelsClassesByModelWithHttpInfo (string modelUid, string envelope = null, List<string> embed = null)
        {
            // verify the required parameter 'modelUid' is set
            if (modelUid == null)
                throw new ApiException(400, "Missing required parameter 'modelUid' when calling ModelsApi->GetModelsClassesByModel");

            var localVarPath = "/models/{model_uid}/modelclasses";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (modelUid != null) localVarPathParams.Add("model_uid", Configuration.ApiClient.ParameterToString(modelUid)); // path parameter
            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (embed != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "embed", embed)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetModelsClassesByModel", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<ModelClassesEndpointType>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<ModelClassesEndpointType>) Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<ModelClassesEndpointType>)));
        }

        /// <summary>
        /// Returns the model classes of the classifier. Returns the model classes of the classifier.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="modelUid">Model  UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of List&lt;ModelClassesEndpointType&gt;</returns>
        public async System.Threading.Tasks.Task<List<ModelClassesEndpointType>> GetModelsClassesByModelAsync (string modelUid, string envelope = null, List<string> embed = null)
        {
             ApiResponse<List<ModelClassesEndpointType>> localVarResponse = await GetModelsClassesByModelAsyncWithHttpInfo(modelUid, envelope, embed);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Returns the model classes of the classifier. Returns the model classes of the classifier.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="modelUid">Model  UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;ModelClassesEndpointType&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<ModelClassesEndpointType>>> GetModelsClassesByModelAsyncWithHttpInfo (string modelUid, string envelope = null, List<string> embed = null)
        {
            // verify the required parameter 'modelUid' is set
            if (modelUid == null)
                throw new ApiException(400, "Missing required parameter 'modelUid' when calling ModelsApi->GetModelsClassesByModel");

            var localVarPath = "/models/{model_uid}/modelclasses";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (modelUid != null) localVarPathParams.Add("model_uid", Configuration.ApiClient.ParameterToString(modelUid)); // path parameter
            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (embed != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "embed", embed)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetModelsClassesByModel", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<ModelClassesEndpointType>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<ModelClassesEndpointType>) Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<ModelClassesEndpointType>)));
        }

        /// <summary>
        /// Create a new model Create a new model. The model can be assigned to a project via the patch://project method. To add a new SpatialSources , the content of Models  must be stored in advanced via the ContentItem endpoint
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newmodel">New Model data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>ModelsEndpointType</returns>
        public ModelsEndpointType NewModel (ModelsPostRequest newmodel, string envelope = null, List<string> embed = null, string i4lProcessUid = null)
        {
             ApiResponse<ModelsEndpointType> localVarResponse = NewModelWithHttpInfo(newmodel, envelope, embed, i4lProcessUid);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Create a new model Create a new model. The model can be assigned to a project via the patch://project method. To add a new SpatialSources , the content of Models  must be stored in advanced via the ContentItem endpoint
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newmodel">New Model data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>ApiResponse of ModelsEndpointType</returns>
        public ApiResponse< ModelsEndpointType > NewModelWithHttpInfo (ModelsPostRequest newmodel, string envelope = null, List<string> embed = null, string i4lProcessUid = null)
        {
            // verify the required parameter 'newmodel' is set
            if (newmodel == null)
                throw new ApiException(400, "Missing required parameter 'newmodel' when calling ModelsApi->NewModel");

            var localVarPath = "/models";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (embed != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "embed", embed)); // query parameter
            if (i4lProcessUid != null) localVarHeaderParams.Add("i4l-process-uid", Configuration.ApiClient.ParameterToString(i4lProcessUid)); // header parameter
            if (newmodel != null && newmodel.GetType() != typeof(byte[]))
            {
                localVarPostBody = Configuration.ApiClient.Serialize(newmodel); // http body (model) parameter
            }
            else
            {
                localVarPostBody = newmodel; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("NewModel", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ModelsEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (ModelsEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(ModelsEndpointType)));
        }

        /// <summary>
        /// Create a new model Create a new model. The model can be assigned to a project via the patch://project method. To add a new SpatialSources , the content of Models  must be stored in advanced via the ContentItem endpoint
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newmodel">New Model data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of ModelsEndpointType</returns>
        public async System.Threading.Tasks.Task<ModelsEndpointType> NewModelAsync (ModelsPostRequest newmodel, string envelope = null, List<string> embed = null, string i4lProcessUid = null)
        {
             ApiResponse<ModelsEndpointType> localVarResponse = await NewModelAsyncWithHttpInfo(newmodel, envelope, embed, i4lProcessUid);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Create a new model Create a new model. The model can be assigned to a project via the patch://project method. To add a new SpatialSources , the content of Models  must be stored in advanced via the ContentItem endpoint
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newmodel">New Model data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of ApiResponse (ModelsEndpointType)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<ModelsEndpointType>> NewModelAsyncWithHttpInfo (ModelsPostRequest newmodel, string envelope = null, List<string> embed = null, string i4lProcessUid = null)
        {
            // verify the required parameter 'newmodel' is set
            if (newmodel == null)
                throw new ApiException(400, "Missing required parameter 'newmodel' when calling ModelsApi->NewModel");

            var localVarPath = "/models";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (embed != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "embed", embed)); // query parameter
            if (i4lProcessUid != null) localVarHeaderParams.Add("i4l-process-uid", Configuration.ApiClient.ParameterToString(i4lProcessUid)); // header parameter
            if (newmodel != null && newmodel.GetType() != typeof(byte[]))
            {
                localVarPostBody = Configuration.ApiClient.Serialize(newmodel); // http body (model) parameter
            }
            else
            {
                localVarPostBody = newmodel; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("NewModel", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ModelsEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (ModelsEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(ModelsEndpointType)));
        }

        /// <summary>
        /// Create a new ModelClass under a model Create a new ModelClass under a model
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="modelUid">Model  UID</param>
        /// <param name="newmodelclass">New ModelClass data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>ModelClassesEndpointType</returns>
        public ModelClassesEndpointType NewModelClassUnderModel (string modelUid, ModelClassesPostRequest newmodelclass, string envelope = null, List<string> embed = null, string i4lProcessUid = null)
        {
             ApiResponse<ModelClassesEndpointType> localVarResponse = NewModelClassUnderModelWithHttpInfo(modelUid, newmodelclass, envelope, embed, i4lProcessUid);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Create a new ModelClass under a model Create a new ModelClass under a model
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="modelUid">Model  UID</param>
        /// <param name="newmodelclass">New ModelClass data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>ApiResponse of ModelClassesEndpointType</returns>
        public ApiResponse< ModelClassesEndpointType > NewModelClassUnderModelWithHttpInfo (string modelUid, ModelClassesPostRequest newmodelclass, string envelope = null, List<string> embed = null, string i4lProcessUid = null)
        {
            // verify the required parameter 'modelUid' is set
            if (modelUid == null)
                throw new ApiException(400, "Missing required parameter 'modelUid' when calling ModelsApi->NewModelClassUnderModel");
            // verify the required parameter 'newmodelclass' is set
            if (newmodelclass == null)
                throw new ApiException(400, "Missing required parameter 'newmodelclass' when calling ModelsApi->NewModelClassUnderModel");

            var localVarPath = "/models/{model_uid}/modelclasses";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (modelUid != null) localVarPathParams.Add("model_uid", Configuration.ApiClient.ParameterToString(modelUid)); // path parameter
            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (embed != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "embed", embed)); // query parameter
            if (i4lProcessUid != null) localVarHeaderParams.Add("i4l-process-uid", Configuration.ApiClient.ParameterToString(i4lProcessUid)); // header parameter
            if (newmodelclass != null && newmodelclass.GetType() != typeof(byte[]))
            {
                localVarPostBody = Configuration.ApiClient.Serialize(newmodelclass); // http body (model) parameter
            }
            else
            {
                localVarPostBody = newmodelclass; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("NewModelClassUnderModel", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ModelClassesEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (ModelClassesEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(ModelClassesEndpointType)));
        }

        /// <summary>
        /// Create a new ModelClass under a model Create a new ModelClass under a model
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="modelUid">Model  UID</param>
        /// <param name="newmodelclass">New ModelClass data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of ModelClassesEndpointType</returns>
        public async System.Threading.Tasks.Task<ModelClassesEndpointType> NewModelClassUnderModelAsync (string modelUid, ModelClassesPostRequest newmodelclass, string envelope = null, List<string> embed = null, string i4lProcessUid = null)
        {
             ApiResponse<ModelClassesEndpointType> localVarResponse = await NewModelClassUnderModelAsyncWithHttpInfo(modelUid, newmodelclass, envelope, embed, i4lProcessUid);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Create a new ModelClass under a model Create a new ModelClass under a model
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="modelUid">Model  UID</param>
        /// <param name="newmodelclass">New ModelClass data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of ApiResponse (ModelClassesEndpointType)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<ModelClassesEndpointType>> NewModelClassUnderModelAsyncWithHttpInfo (string modelUid, ModelClassesPostRequest newmodelclass, string envelope = null, List<string> embed = null, string i4lProcessUid = null)
        {
            // verify the required parameter 'modelUid' is set
            if (modelUid == null)
                throw new ApiException(400, "Missing required parameter 'modelUid' when calling ModelsApi->NewModelClassUnderModel");
            // verify the required parameter 'newmodelclass' is set
            if (newmodelclass == null)
                throw new ApiException(400, "Missing required parameter 'newmodelclass' when calling ModelsApi->NewModelClassUnderModel");

            var localVarPath = "/models/{model_uid}/modelclasses";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (modelUid != null) localVarPathParams.Add("model_uid", Configuration.ApiClient.ParameterToString(modelUid)); // path parameter
            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (embed != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "embed", embed)); // query parameter
            if (i4lProcessUid != null) localVarHeaderParams.Add("i4l-process-uid", Configuration.ApiClient.ParameterToString(i4lProcessUid)); // header parameter
            if (newmodelclass != null && newmodelclass.GetType() != typeof(byte[]))
            {
                localVarPostBody = Configuration.ApiClient.Serialize(newmodelclass); // http body (model) parameter
            }
            else
            {
                localVarPostBody = newmodelclass; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("NewModelClassUnderModel", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ModelClassesEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (ModelClassesEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(ModelClassesEndpointType)));
        }

        /// <summary>
        /// Updates some attributes of a model Updates some attributes of a model
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="modelUid">Model  UID</param>
        /// <param name="patchmodel">Update data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>ModelsEndpointType</returns>
        public ModelsEndpointType UpdateModels (string modelUid, RFC6902PatchRequest patchmodel, string envelope = null, List<string> embed = null, string i4lProcessUid = null)
        {
             ApiResponse<ModelsEndpointType> localVarResponse = UpdateModelsWithHttpInfo(modelUid, patchmodel, envelope, embed, i4lProcessUid);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Updates some attributes of a model Updates some attributes of a model
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="modelUid">Model  UID</param>
        /// <param name="patchmodel">Update data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>ApiResponse of ModelsEndpointType</returns>
        public ApiResponse< ModelsEndpointType > UpdateModelsWithHttpInfo (string modelUid, RFC6902PatchRequest patchmodel, string envelope = null, List<string> embed = null, string i4lProcessUid = null)
        {
            // verify the required parameter 'modelUid' is set
            if (modelUid == null)
                throw new ApiException(400, "Missing required parameter 'modelUid' when calling ModelsApi->UpdateModels");
            // verify the required parameter 'patchmodel' is set
            if (patchmodel == null)
                throw new ApiException(400, "Missing required parameter 'patchmodel' when calling ModelsApi->UpdateModels");

            var localVarPath = "/models/{model_uid}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (modelUid != null) localVarPathParams.Add("model_uid", Configuration.ApiClient.ParameterToString(modelUid)); // path parameter
            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (embed != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "embed", embed)); // query parameter
            if (i4lProcessUid != null) localVarHeaderParams.Add("i4l-process-uid", Configuration.ApiClient.ParameterToString(i4lProcessUid)); // header parameter
            if (patchmodel != null && patchmodel.GetType() != typeof(byte[]))
            {
                localVarPostBody = Configuration.ApiClient.Serialize(patchmodel); // http body (model) parameter
            }
            else
            {
                localVarPostBody = patchmodel; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.PATCH, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("UpdateModels", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ModelsEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (ModelsEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(ModelsEndpointType)));
        }

        /// <summary>
        /// Updates some attributes of a model Updates some attributes of a model
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="modelUid">Model  UID</param>
        /// <param name="patchmodel">Update data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of ModelsEndpointType</returns>
        public async System.Threading.Tasks.Task<ModelsEndpointType> UpdateModelsAsync (string modelUid, RFC6902PatchRequest patchmodel, string envelope = null, List<string> embed = null, string i4lProcessUid = null)
        {
             ApiResponse<ModelsEndpointType> localVarResponse = await UpdateModelsAsyncWithHttpInfo(modelUid, patchmodel, envelope, embed, i4lProcessUid);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Updates some attributes of a model Updates some attributes of a model
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="modelUid">Model  UID</param>
        /// <param name="patchmodel">Update data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of ApiResponse (ModelsEndpointType)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<ModelsEndpointType>> UpdateModelsAsyncWithHttpInfo (string modelUid, RFC6902PatchRequest patchmodel, string envelope = null, List<string> embed = null, string i4lProcessUid = null)
        {
            // verify the required parameter 'modelUid' is set
            if (modelUid == null)
                throw new ApiException(400, "Missing required parameter 'modelUid' when calling ModelsApi->UpdateModels");
            // verify the required parameter 'patchmodel' is set
            if (patchmodel == null)
                throw new ApiException(400, "Missing required parameter 'patchmodel' when calling ModelsApi->UpdateModels");

            var localVarPath = "/models/{model_uid}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (modelUid != null) localVarPathParams.Add("model_uid", Configuration.ApiClient.ParameterToString(modelUid)); // path parameter
            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (embed != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "embed", embed)); // query parameter
            if (i4lProcessUid != null) localVarHeaderParams.Add("i4l-process-uid", Configuration.ApiClient.ParameterToString(i4lProcessUid)); // header parameter
            if (patchmodel != null && patchmodel.GetType() != typeof(byte[]))
            {
                localVarPostBody = Configuration.ApiClient.Serialize(patchmodel); // http body (model) parameter
            }
            else
            {
                localVarPostBody = patchmodel; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.PATCH, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("UpdateModels", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ModelsEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (ModelsEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(ModelsEndpointType)));
        }

    }
}
