/* 
 * its4land Public API
 *
 * The its4land Public API provides access to the services of the its4land Publish and Share platform.
 *
 * OpenAPI spec version: 0.0.2
 * Contact: contact@its4land.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using RestSharp;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace IO.Swagger.Api
{
    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public interface ISpatialSourcesApi : IApiAccessor
    {
        #region Synchronous Operations
        /// <summary>
        /// Removes an additional document for a spatial source.
        /// </summary>
        /// <remarks>
        /// Removes an additional document for a spatial source. By default only the link between additional document and spatial source is removed.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialsourceUid">SpatialSource UID</param>
        /// <param name="adddocUid">SpatialSource UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="forceDelete">Deletes the additional document resource. (optional)</param>
        /// <returns>List&lt;SpatialSourcesEndpointType&gt;</returns>
        List<SpatialSourcesEndpointType> DetachSpatialSourceAddDoc (string spatialsourceUid, string adddocUid, string envelope = null, string forceDelete = null);

        /// <summary>
        /// Removes an additional document for a spatial source.
        /// </summary>
        /// <remarks>
        /// Removes an additional document for a spatial source. By default only the link between additional document and spatial source is removed.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialsourceUid">SpatialSource UID</param>
        /// <param name="adddocUid">SpatialSource UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="forceDelete">Deletes the additional document resource. (optional)</param>
        /// <returns>ApiResponse of List&lt;SpatialSourcesEndpointType&gt;</returns>
        ApiResponse<List<SpatialSourcesEndpointType>> DetachSpatialSourceAddDocWithHttpInfo (string spatialsourceUid, string adddocUid, string envelope = null, string forceDelete = null);
        /// <summary>
        /// Returns the additional documents of a spatial source
        /// </summary>
        /// <remarks>
        /// Returns the additional documents of a spatial source
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialsourceUid">SpatialSource UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of field names (optional)</param>
        /// <returns>List&lt;AdditionalDocumentsEndpointType&gt;</returns>
        List<AdditionalDocumentsEndpointType> GetSpatialSourceAddDocs (string spatialsourceUid, string envelope = null, int? page = null, string sort = null, List<string> fields = null);

        /// <summary>
        /// Returns the additional documents of a spatial source
        /// </summary>
        /// <remarks>
        /// Returns the additional documents of a spatial source
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialsourceUid">SpatialSource UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of field names (optional)</param>
        /// <returns>ApiResponse of List&lt;AdditionalDocumentsEndpointType&gt;</returns>
        ApiResponse<List<AdditionalDocumentsEndpointType>> GetSpatialSourceAddDocsWithHttpInfo (string spatialsourceUid, string envelope = null, int? page = null, string sort = null, List<string> fields = null);
        /// <summary>
        /// Returns a single SpatialSource
        /// </summary>
        /// <remarks>
        /// Returns a single SpatialSource
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialsourceUid">SpatialSource UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>SpatialSourcesEndpointType</returns>
        SpatialSourcesEndpointType GetSpatialSourceByUID (string spatialsourceUid, string envelope = null, List<string> embed = null);

        /// <summary>
        /// Returns a single SpatialSource
        /// </summary>
        /// <remarks>
        /// Returns a single SpatialSource
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialsourceUid">SpatialSource UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>ApiResponse of SpatialSourcesEndpointType</returns>
        ApiResponse<SpatialSourcesEndpointType> GetSpatialSourceByUIDWithHttpInfo (string spatialsourceUid, string envelope = null, List<string> embed = null);
        /// <summary>
        /// Returns the additional documents of a spatial source
        /// </summary>
        /// <remarks>
        /// Returns the additional documents of a spatial source
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialsourceUid">SpatialSource UID</param>
        /// <param name="adddocUid">SpatialSource UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="fields">Comma separated list of field names (optional)</param>
        /// <returns>List&lt;AdditionalDocumentsEndpointType&gt;</returns>
        List<AdditionalDocumentsEndpointType> GetSpatialSourceSingleAddDoc (string spatialsourceUid, string adddocUid, string envelope = null, List<string> fields = null);

        /// <summary>
        /// Returns the additional documents of a spatial source
        /// </summary>
        /// <remarks>
        /// Returns the additional documents of a spatial source
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialsourceUid">SpatialSource UID</param>
        /// <param name="adddocUid">SpatialSource UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="fields">Comma separated list of field names (optional)</param>
        /// <returns>ApiResponse of List&lt;AdditionalDocumentsEndpointType&gt;</returns>
        ApiResponse<List<AdditionalDocumentsEndpointType>> GetSpatialSourceSingleAddDocWithHttpInfo (string spatialsourceUid, string adddocUid, string envelope = null, List<string> fields = null);
        /// <summary>
        /// Returns a list of SpatialSources
        /// </summary>
        /// <remarks>
        /// Returns a list of SpatialSources
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="uid">Comma separated list of SpatialSources UID (optional)</param>
        /// <param name="name">Comma separated list of SpatialSources names (optional)</param>
        /// <param name="type">Comma separated list of SpatialSources types (optional)</param>
        /// <param name="projects">Comma separated list of project UID (optional)</param>
        /// <param name="tags">Comma separated list of tags (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of tags (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>List&lt;SpatialSourcesEndpointType&gt;</returns>
        List<SpatialSourcesEndpointType> GetSpatialSources (string envelope = null, List<string> uid = null, List<string> name = null, List<string> type = null, List<string> projects = null, List<string> tags = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null);

        /// <summary>
        /// Returns a list of SpatialSources
        /// </summary>
        /// <remarks>
        /// Returns a list of SpatialSources
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="uid">Comma separated list of SpatialSources UID (optional)</param>
        /// <param name="name">Comma separated list of SpatialSources names (optional)</param>
        /// <param name="type">Comma separated list of SpatialSources types (optional)</param>
        /// <param name="projects">Comma separated list of project UID (optional)</param>
        /// <param name="tags">Comma separated list of tags (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of tags (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>ApiResponse of List&lt;SpatialSourcesEndpointType&gt;</returns>
        ApiResponse<List<SpatialSourcesEndpointType>> GetSpatialSourcesWithHttpInfo (string envelope = null, List<string> uid = null, List<string> name = null, List<string> type = null, List<string> projects = null, List<string> tags = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null);
        /// <summary>
        /// Create a new SpatialSource
        /// </summary>
        /// <remarks>
        /// Create a new SpatialSource. To add a new SpatialSources , the content of SpatialSources  must be stored in advanced via the ContentItem endpoint.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newspatialsource">New SpatialSource data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="processUid">deprecated (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>SpatialSourcesEndpointType</returns>
        SpatialSourcesEndpointType NewSpatialSource (SpatialSourcesPostRequest newspatialsource, string envelope = null, List<string> embed = null, string processUid = null, string i4lProcessUid = null);

        /// <summary>
        /// Create a new SpatialSource
        /// </summary>
        /// <remarks>
        /// Create a new SpatialSource. To add a new SpatialSources , the content of SpatialSources  must be stored in advanced via the ContentItem endpoint.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newspatialsource">New SpatialSource data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="processUid">deprecated (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>ApiResponse of SpatialSourcesEndpointType</returns>
        ApiResponse<SpatialSourcesEndpointType> NewSpatialSourceWithHttpInfo (SpatialSourcesPostRequest newspatialsource, string envelope = null, List<string> embed = null, string processUid = null, string i4lProcessUid = null);
        /// <summary>
        /// Add a new additional document to a spatial source
        /// </summary>
        /// <remarks>
        /// Add a new additional document to a spatial source
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialsourceUid">SpatialSource UID</param>
        /// <param name="newadddocdata">New additional document data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>AdditionalDocumentsEndpointType</returns>
        AdditionalDocumentsEndpointType NewSpatialSourceAddAddDoc (string spatialsourceUid, AdditionalDocumentsPost newadddocdata, string envelope = null, string i4lProcessUid = null);

        /// <summary>
        /// Add a new additional document to a spatial source
        /// </summary>
        /// <remarks>
        /// Add a new additional document to a spatial source
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialsourceUid">SpatialSource UID</param>
        /// <param name="newadddocdata">New additional document data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>ApiResponse of AdditionalDocumentsEndpointType</returns>
        ApiResponse<AdditionalDocumentsEndpointType> NewSpatialSourceAddAddDocWithHttpInfo (string spatialsourceUid, AdditionalDocumentsPost newadddocdata, string envelope = null, string i4lProcessUid = null);
        /// <summary>
        /// Replace an existing SpatialSource by a newer version
        /// </summary>
        /// <remarks>
        /// An existing SpatialSource will be replaced by a newer version. The UID of SpatialSource remains
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialsourceUid">SpatialSource UID</param>
        /// <param name="updatedspatialsource">Updated spatial source</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>SpatialSourcesEndpointType</returns>
        SpatialSourcesEndpointType PutSpatialSourceByUID (string spatialsourceUid, SpatialSourcesPostRequest updatedspatialsource, string envelope = null, List<string> embed = null, string i4lProcessUid = null);

        /// <summary>
        /// Replace an existing SpatialSource by a newer version
        /// </summary>
        /// <remarks>
        /// An existing SpatialSource will be replaced by a newer version. The UID of SpatialSource remains
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialsourceUid">SpatialSource UID</param>
        /// <param name="updatedspatialsource">Updated spatial source</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>ApiResponse of SpatialSourcesEndpointType</returns>
        ApiResponse<SpatialSourcesEndpointType> PutSpatialSourceByUIDWithHttpInfo (string spatialsourceUid, SpatialSourcesPostRequest updatedspatialsource, string envelope = null, List<string> embed = null, string i4lProcessUid = null);
        #endregion Synchronous Operations
        #region Asynchronous Operations
        /// <summary>
        /// Removes an additional document for a spatial source.
        /// </summary>
        /// <remarks>
        /// Removes an additional document for a spatial source. By default only the link between additional document and spatial source is removed.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialsourceUid">SpatialSource UID</param>
        /// <param name="adddocUid">SpatialSource UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="forceDelete">Deletes the additional document resource. (optional)</param>
        /// <returns>Task of List&lt;SpatialSourcesEndpointType&gt;</returns>
        System.Threading.Tasks.Task<List<SpatialSourcesEndpointType>> DetachSpatialSourceAddDocAsync (string spatialsourceUid, string adddocUid, string envelope = null, string forceDelete = null);

        /// <summary>
        /// Removes an additional document for a spatial source.
        /// </summary>
        /// <remarks>
        /// Removes an additional document for a spatial source. By default only the link between additional document and spatial source is removed.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialsourceUid">SpatialSource UID</param>
        /// <param name="adddocUid">SpatialSource UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="forceDelete">Deletes the additional document resource. (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;SpatialSourcesEndpointType&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<SpatialSourcesEndpointType>>> DetachSpatialSourceAddDocAsyncWithHttpInfo (string spatialsourceUid, string adddocUid, string envelope = null, string forceDelete = null);
        /// <summary>
        /// Returns the additional documents of a spatial source
        /// </summary>
        /// <remarks>
        /// Returns the additional documents of a spatial source
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialsourceUid">SpatialSource UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of field names (optional)</param>
        /// <returns>Task of List&lt;AdditionalDocumentsEndpointType&gt;</returns>
        System.Threading.Tasks.Task<List<AdditionalDocumentsEndpointType>> GetSpatialSourceAddDocsAsync (string spatialsourceUid, string envelope = null, int? page = null, string sort = null, List<string> fields = null);

        /// <summary>
        /// Returns the additional documents of a spatial source
        /// </summary>
        /// <remarks>
        /// Returns the additional documents of a spatial source
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialsourceUid">SpatialSource UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of field names (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;AdditionalDocumentsEndpointType&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<AdditionalDocumentsEndpointType>>> GetSpatialSourceAddDocsAsyncWithHttpInfo (string spatialsourceUid, string envelope = null, int? page = null, string sort = null, List<string> fields = null);
        /// <summary>
        /// Returns a single SpatialSource
        /// </summary>
        /// <remarks>
        /// Returns a single SpatialSource
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialsourceUid">SpatialSource UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of SpatialSourcesEndpointType</returns>
        System.Threading.Tasks.Task<SpatialSourcesEndpointType> GetSpatialSourceByUIDAsync (string spatialsourceUid, string envelope = null, List<string> embed = null);

        /// <summary>
        /// Returns a single SpatialSource
        /// </summary>
        /// <remarks>
        /// Returns a single SpatialSource
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialsourceUid">SpatialSource UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of ApiResponse (SpatialSourcesEndpointType)</returns>
        System.Threading.Tasks.Task<ApiResponse<SpatialSourcesEndpointType>> GetSpatialSourceByUIDAsyncWithHttpInfo (string spatialsourceUid, string envelope = null, List<string> embed = null);
        /// <summary>
        /// Returns the additional documents of a spatial source
        /// </summary>
        /// <remarks>
        /// Returns the additional documents of a spatial source
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialsourceUid">SpatialSource UID</param>
        /// <param name="adddocUid">SpatialSource UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="fields">Comma separated list of field names (optional)</param>
        /// <returns>Task of List&lt;AdditionalDocumentsEndpointType&gt;</returns>
        System.Threading.Tasks.Task<List<AdditionalDocumentsEndpointType>> GetSpatialSourceSingleAddDocAsync (string spatialsourceUid, string adddocUid, string envelope = null, List<string> fields = null);

        /// <summary>
        /// Returns the additional documents of a spatial source
        /// </summary>
        /// <remarks>
        /// Returns the additional documents of a spatial source
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialsourceUid">SpatialSource UID</param>
        /// <param name="adddocUid">SpatialSource UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="fields">Comma separated list of field names (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;AdditionalDocumentsEndpointType&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<AdditionalDocumentsEndpointType>>> GetSpatialSourceSingleAddDocAsyncWithHttpInfo (string spatialsourceUid, string adddocUid, string envelope = null, List<string> fields = null);
        /// <summary>
        /// Returns a list of SpatialSources
        /// </summary>
        /// <remarks>
        /// Returns a list of SpatialSources
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="uid">Comma separated list of SpatialSources UID (optional)</param>
        /// <param name="name">Comma separated list of SpatialSources names (optional)</param>
        /// <param name="type">Comma separated list of SpatialSources types (optional)</param>
        /// <param name="projects">Comma separated list of project UID (optional)</param>
        /// <param name="tags">Comma separated list of tags (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of tags (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of List&lt;SpatialSourcesEndpointType&gt;</returns>
        System.Threading.Tasks.Task<List<SpatialSourcesEndpointType>> GetSpatialSourcesAsync (string envelope = null, List<string> uid = null, List<string> name = null, List<string> type = null, List<string> projects = null, List<string> tags = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null);

        /// <summary>
        /// Returns a list of SpatialSources
        /// </summary>
        /// <remarks>
        /// Returns a list of SpatialSources
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="uid">Comma separated list of SpatialSources UID (optional)</param>
        /// <param name="name">Comma separated list of SpatialSources names (optional)</param>
        /// <param name="type">Comma separated list of SpatialSources types (optional)</param>
        /// <param name="projects">Comma separated list of project UID (optional)</param>
        /// <param name="tags">Comma separated list of tags (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of tags (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;SpatialSourcesEndpointType&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<SpatialSourcesEndpointType>>> GetSpatialSourcesAsyncWithHttpInfo (string envelope = null, List<string> uid = null, List<string> name = null, List<string> type = null, List<string> projects = null, List<string> tags = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null);
        /// <summary>
        /// Create a new SpatialSource
        /// </summary>
        /// <remarks>
        /// Create a new SpatialSource. To add a new SpatialSources , the content of SpatialSources  must be stored in advanced via the ContentItem endpoint.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newspatialsource">New SpatialSource data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="processUid">deprecated (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of SpatialSourcesEndpointType</returns>
        System.Threading.Tasks.Task<SpatialSourcesEndpointType> NewSpatialSourceAsync (SpatialSourcesPostRequest newspatialsource, string envelope = null, List<string> embed = null, string processUid = null, string i4lProcessUid = null);

        /// <summary>
        /// Create a new SpatialSource
        /// </summary>
        /// <remarks>
        /// Create a new SpatialSource. To add a new SpatialSources , the content of SpatialSources  must be stored in advanced via the ContentItem endpoint.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newspatialsource">New SpatialSource data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="processUid">deprecated (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of ApiResponse (SpatialSourcesEndpointType)</returns>
        System.Threading.Tasks.Task<ApiResponse<SpatialSourcesEndpointType>> NewSpatialSourceAsyncWithHttpInfo (SpatialSourcesPostRequest newspatialsource, string envelope = null, List<string> embed = null, string processUid = null, string i4lProcessUid = null);
        /// <summary>
        /// Add a new additional document to a spatial source
        /// </summary>
        /// <remarks>
        /// Add a new additional document to a spatial source
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialsourceUid">SpatialSource UID</param>
        /// <param name="newadddocdata">New additional document data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of AdditionalDocumentsEndpointType</returns>
        System.Threading.Tasks.Task<AdditionalDocumentsEndpointType> NewSpatialSourceAddAddDocAsync (string spatialsourceUid, AdditionalDocumentsPost newadddocdata, string envelope = null, string i4lProcessUid = null);

        /// <summary>
        /// Add a new additional document to a spatial source
        /// </summary>
        /// <remarks>
        /// Add a new additional document to a spatial source
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialsourceUid">SpatialSource UID</param>
        /// <param name="newadddocdata">New additional document data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of ApiResponse (AdditionalDocumentsEndpointType)</returns>
        System.Threading.Tasks.Task<ApiResponse<AdditionalDocumentsEndpointType>> NewSpatialSourceAddAddDocAsyncWithHttpInfo (string spatialsourceUid, AdditionalDocumentsPost newadddocdata, string envelope = null, string i4lProcessUid = null);
        /// <summary>
        /// Replace an existing SpatialSource by a newer version
        /// </summary>
        /// <remarks>
        /// An existing SpatialSource will be replaced by a newer version. The UID of SpatialSource remains
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialsourceUid">SpatialSource UID</param>
        /// <param name="updatedspatialsource">Updated spatial source</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of SpatialSourcesEndpointType</returns>
        System.Threading.Tasks.Task<SpatialSourcesEndpointType> PutSpatialSourceByUIDAsync (string spatialsourceUid, SpatialSourcesPostRequest updatedspatialsource, string envelope = null, List<string> embed = null, string i4lProcessUid = null);

        /// <summary>
        /// Replace an existing SpatialSource by a newer version
        /// </summary>
        /// <remarks>
        /// An existing SpatialSource will be replaced by a newer version. The UID of SpatialSource remains
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialsourceUid">SpatialSource UID</param>
        /// <param name="updatedspatialsource">Updated spatial source</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of ApiResponse (SpatialSourcesEndpointType)</returns>
        System.Threading.Tasks.Task<ApiResponse<SpatialSourcesEndpointType>> PutSpatialSourceByUIDAsyncWithHttpInfo (string spatialsourceUid, SpatialSourcesPostRequest updatedspatialsource, string envelope = null, List<string> embed = null, string i4lProcessUid = null);
        #endregion Asynchronous Operations
    }

    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public partial class SpatialSourcesApi : ISpatialSourcesApi
    {
        private IO.Swagger.Client.ExceptionFactory _exceptionFactory = (name, response) => null;

        /// <summary>
        /// Initializes a new instance of the <see cref="SpatialSourcesApi"/> class.
        /// </summary>
        /// <returns></returns>
        public SpatialSourcesApi(String basePath)
        {
            this.Configuration = new Configuration { BasePath = basePath };

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="SpatialSourcesApi"/> class
        /// using Configuration object
        /// </summary>
        /// <param name="configuration">An instance of Configuration</param>
        /// <returns></returns>
        public SpatialSourcesApi(Configuration configuration = null)
        {
            if (configuration == null) // use the default one in Configuration
                this.Configuration = Configuration.Default;
            else
                this.Configuration = configuration;

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Gets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        public String GetBasePath()
        {
            return this.Configuration.ApiClient.RestClient.BaseUrl.ToString();
        }

        /// <summary>
        /// Sets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        [Obsolete("SetBasePath is deprecated, please do 'Configuration.ApiClient = new ApiClient(\"http://new-path\")' instead.")]
        public void SetBasePath(String basePath)
        {
            // do nothing
        }

        /// <summary>
        /// Gets or sets the configuration object
        /// </summary>
        /// <value>An instance of the Configuration</value>
        public Configuration Configuration {get; set;}

        /// <summary>
        /// Provides a factory method hook for the creation of exceptions.
        /// </summary>
        public IO.Swagger.Client.ExceptionFactory ExceptionFactory
        {
            get
            {
                if (_exceptionFactory != null && _exceptionFactory.GetInvocationList().Length > 1)
                {
                    throw new InvalidOperationException("Multicast delegate for ExceptionFactory is unsupported.");
                }
                return _exceptionFactory;
            }
            set { _exceptionFactory = value; }
        }

        /// <summary>
        /// Gets the default header.
        /// </summary>
        /// <returns>Dictionary of HTTP header</returns>
        [Obsolete("DefaultHeader is deprecated, please use Configuration.DefaultHeader instead.")]
        public IDictionary<String, String> DefaultHeader()
        {
            return new ReadOnlyDictionary<string, string>(this.Configuration.DefaultHeader);
        }

        /// <summary>
        /// Add default header.
        /// </summary>
        /// <param name="key">Header field name.</param>
        /// <param name="value">Header field value.</param>
        /// <returns></returns>
        [Obsolete("AddDefaultHeader is deprecated, please use Configuration.AddDefaultHeader instead.")]
        public void AddDefaultHeader(string key, string value)
        {
            this.Configuration.AddDefaultHeader(key, value);
        }

        /// <summary>
        /// Removes an additional document for a spatial source. Removes an additional document for a spatial source. By default only the link between additional document and spatial source is removed.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialsourceUid">SpatialSource UID</param>
        /// <param name="adddocUid">SpatialSource UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="forceDelete">Deletes the additional document resource. (optional)</param>
        /// <returns>List&lt;SpatialSourcesEndpointType&gt;</returns>
        public List<SpatialSourcesEndpointType> DetachSpatialSourceAddDoc (string spatialsourceUid, string adddocUid, string envelope = null, string forceDelete = null)
        {
             ApiResponse<List<SpatialSourcesEndpointType>> localVarResponse = DetachSpatialSourceAddDocWithHttpInfo(spatialsourceUid, adddocUid, envelope, forceDelete);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Removes an additional document for a spatial source. Removes an additional document for a spatial source. By default only the link between additional document and spatial source is removed.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialsourceUid">SpatialSource UID</param>
        /// <param name="adddocUid">SpatialSource UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="forceDelete">Deletes the additional document resource. (optional)</param>
        /// <returns>ApiResponse of List&lt;SpatialSourcesEndpointType&gt;</returns>
        public ApiResponse< List<SpatialSourcesEndpointType> > DetachSpatialSourceAddDocWithHttpInfo (string spatialsourceUid, string adddocUid, string envelope = null, string forceDelete = null)
        {
            // verify the required parameter 'spatialsourceUid' is set
            if (spatialsourceUid == null)
                throw new ApiException(400, "Missing required parameter 'spatialsourceUid' when calling SpatialSourcesApi->DetachSpatialSourceAddDoc");
            // verify the required parameter 'adddocUid' is set
            if (adddocUid == null)
                throw new ApiException(400, "Missing required parameter 'adddocUid' when calling SpatialSourcesApi->DetachSpatialSourceAddDoc");

            var localVarPath = "/spatialsource/{spatialsource_uid}/AdditionalDocument/{adddoc_uid}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (spatialsourceUid != null) localVarPathParams.Add("spatialsource_uid", Configuration.ApiClient.ParameterToString(spatialsourceUid)); // path parameter
            if (adddocUid != null) localVarPathParams.Add("adddoc_uid", Configuration.ApiClient.ParameterToString(adddocUid)); // path parameter
            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (forceDelete != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "force_delete", forceDelete)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.DELETE, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("DetachSpatialSourceAddDoc", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<SpatialSourcesEndpointType>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<SpatialSourcesEndpointType>) Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<SpatialSourcesEndpointType>)));
        }

        /// <summary>
        /// Removes an additional document for a spatial source. Removes an additional document for a spatial source. By default only the link between additional document and spatial source is removed.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialsourceUid">SpatialSource UID</param>
        /// <param name="adddocUid">SpatialSource UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="forceDelete">Deletes the additional document resource. (optional)</param>
        /// <returns>Task of List&lt;SpatialSourcesEndpointType&gt;</returns>
        public async System.Threading.Tasks.Task<List<SpatialSourcesEndpointType>> DetachSpatialSourceAddDocAsync (string spatialsourceUid, string adddocUid, string envelope = null, string forceDelete = null)
        {
             ApiResponse<List<SpatialSourcesEndpointType>> localVarResponse = await DetachSpatialSourceAddDocAsyncWithHttpInfo(spatialsourceUid, adddocUid, envelope, forceDelete);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Removes an additional document for a spatial source. Removes an additional document for a spatial source. By default only the link between additional document and spatial source is removed.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialsourceUid">SpatialSource UID</param>
        /// <param name="adddocUid">SpatialSource UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="forceDelete">Deletes the additional document resource. (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;SpatialSourcesEndpointType&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<SpatialSourcesEndpointType>>> DetachSpatialSourceAddDocAsyncWithHttpInfo (string spatialsourceUid, string adddocUid, string envelope = null, string forceDelete = null)
        {
            // verify the required parameter 'spatialsourceUid' is set
            if (spatialsourceUid == null)
                throw new ApiException(400, "Missing required parameter 'spatialsourceUid' when calling SpatialSourcesApi->DetachSpatialSourceAddDoc");
            // verify the required parameter 'adddocUid' is set
            if (adddocUid == null)
                throw new ApiException(400, "Missing required parameter 'adddocUid' when calling SpatialSourcesApi->DetachSpatialSourceAddDoc");

            var localVarPath = "/spatialsource/{spatialsource_uid}/AdditionalDocument/{adddoc_uid}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (spatialsourceUid != null) localVarPathParams.Add("spatialsource_uid", Configuration.ApiClient.ParameterToString(spatialsourceUid)); // path parameter
            if (adddocUid != null) localVarPathParams.Add("adddoc_uid", Configuration.ApiClient.ParameterToString(adddocUid)); // path parameter
            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (forceDelete != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "force_delete", forceDelete)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.DELETE, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("DetachSpatialSourceAddDoc", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<SpatialSourcesEndpointType>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<SpatialSourcesEndpointType>) Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<SpatialSourcesEndpointType>)));
        }

        /// <summary>
        /// Returns the additional documents of a spatial source Returns the additional documents of a spatial source
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialsourceUid">SpatialSource UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of field names (optional)</param>
        /// <returns>List&lt;AdditionalDocumentsEndpointType&gt;</returns>
        public List<AdditionalDocumentsEndpointType> GetSpatialSourceAddDocs (string spatialsourceUid, string envelope = null, int? page = null, string sort = null, List<string> fields = null)
        {
             ApiResponse<List<AdditionalDocumentsEndpointType>> localVarResponse = GetSpatialSourceAddDocsWithHttpInfo(spatialsourceUid, envelope, page, sort, fields);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Returns the additional documents of a spatial source Returns the additional documents of a spatial source
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialsourceUid">SpatialSource UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of field names (optional)</param>
        /// <returns>ApiResponse of List&lt;AdditionalDocumentsEndpointType&gt;</returns>
        public ApiResponse< List<AdditionalDocumentsEndpointType> > GetSpatialSourceAddDocsWithHttpInfo (string spatialsourceUid, string envelope = null, int? page = null, string sort = null, List<string> fields = null)
        {
            // verify the required parameter 'spatialsourceUid' is set
            if (spatialsourceUid == null)
                throw new ApiException(400, "Missing required parameter 'spatialsourceUid' when calling SpatialSourcesApi->GetSpatialSourceAddDocs");

            var localVarPath = "/spatialsource/{spatialsource_uid}/AdditionalDocument";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (spatialsourceUid != null) localVarPathParams.Add("spatialsource_uid", Configuration.ApiClient.ParameterToString(spatialsourceUid)); // path parameter
            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (page != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "page", page)); // query parameter
            if (sort != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "sort", sort)); // query parameter
            if (fields != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "fields", fields)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetSpatialSourceAddDocs", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<AdditionalDocumentsEndpointType>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<AdditionalDocumentsEndpointType>) Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<AdditionalDocumentsEndpointType>)));
        }

        /// <summary>
        /// Returns the additional documents of a spatial source Returns the additional documents of a spatial source
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialsourceUid">SpatialSource UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of field names (optional)</param>
        /// <returns>Task of List&lt;AdditionalDocumentsEndpointType&gt;</returns>
        public async System.Threading.Tasks.Task<List<AdditionalDocumentsEndpointType>> GetSpatialSourceAddDocsAsync (string spatialsourceUid, string envelope = null, int? page = null, string sort = null, List<string> fields = null)
        {
             ApiResponse<List<AdditionalDocumentsEndpointType>> localVarResponse = await GetSpatialSourceAddDocsAsyncWithHttpInfo(spatialsourceUid, envelope, page, sort, fields);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Returns the additional documents of a spatial source Returns the additional documents of a spatial source
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialsourceUid">SpatialSource UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of field names (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;AdditionalDocumentsEndpointType&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<AdditionalDocumentsEndpointType>>> GetSpatialSourceAddDocsAsyncWithHttpInfo (string spatialsourceUid, string envelope = null, int? page = null, string sort = null, List<string> fields = null)
        {
            // verify the required parameter 'spatialsourceUid' is set
            if (spatialsourceUid == null)
                throw new ApiException(400, "Missing required parameter 'spatialsourceUid' when calling SpatialSourcesApi->GetSpatialSourceAddDocs");

            var localVarPath = "/spatialsource/{spatialsource_uid}/AdditionalDocument";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (spatialsourceUid != null) localVarPathParams.Add("spatialsource_uid", Configuration.ApiClient.ParameterToString(spatialsourceUid)); // path parameter
            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (page != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "page", page)); // query parameter
            if (sort != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "sort", sort)); // query parameter
            if (fields != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "fields", fields)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetSpatialSourceAddDocs", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<AdditionalDocumentsEndpointType>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<AdditionalDocumentsEndpointType>) Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<AdditionalDocumentsEndpointType>)));
        }

        /// <summary>
        /// Returns a single SpatialSource Returns a single SpatialSource
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialsourceUid">SpatialSource UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>SpatialSourcesEndpointType</returns>
        public SpatialSourcesEndpointType GetSpatialSourceByUID (string spatialsourceUid, string envelope = null, List<string> embed = null)
        {
             ApiResponse<SpatialSourcesEndpointType> localVarResponse = GetSpatialSourceByUIDWithHttpInfo(spatialsourceUid, envelope, embed);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Returns a single SpatialSource Returns a single SpatialSource
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialsourceUid">SpatialSource UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>ApiResponse of SpatialSourcesEndpointType</returns>
        public ApiResponse< SpatialSourcesEndpointType > GetSpatialSourceByUIDWithHttpInfo (string spatialsourceUid, string envelope = null, List<string> embed = null)
        {
            // verify the required parameter 'spatialsourceUid' is set
            if (spatialsourceUid == null)
                throw new ApiException(400, "Missing required parameter 'spatialsourceUid' when calling SpatialSourcesApi->GetSpatialSourceByUID");

            var localVarPath = "/spatialsource/{spatialsource_uid}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (spatialsourceUid != null) localVarPathParams.Add("spatialsource_uid", Configuration.ApiClient.ParameterToString(spatialsourceUid)); // path parameter
            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (embed != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "embed", embed)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetSpatialSourceByUID", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<SpatialSourcesEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (SpatialSourcesEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(SpatialSourcesEndpointType)));
        }

        /// <summary>
        /// Returns a single SpatialSource Returns a single SpatialSource
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialsourceUid">SpatialSource UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of SpatialSourcesEndpointType</returns>
        public async System.Threading.Tasks.Task<SpatialSourcesEndpointType> GetSpatialSourceByUIDAsync (string spatialsourceUid, string envelope = null, List<string> embed = null)
        {
             ApiResponse<SpatialSourcesEndpointType> localVarResponse = await GetSpatialSourceByUIDAsyncWithHttpInfo(spatialsourceUid, envelope, embed);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Returns a single SpatialSource Returns a single SpatialSource
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialsourceUid">SpatialSource UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of ApiResponse (SpatialSourcesEndpointType)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<SpatialSourcesEndpointType>> GetSpatialSourceByUIDAsyncWithHttpInfo (string spatialsourceUid, string envelope = null, List<string> embed = null)
        {
            // verify the required parameter 'spatialsourceUid' is set
            if (spatialsourceUid == null)
                throw new ApiException(400, "Missing required parameter 'spatialsourceUid' when calling SpatialSourcesApi->GetSpatialSourceByUID");

            var localVarPath = "/spatialsource/{spatialsource_uid}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (spatialsourceUid != null) localVarPathParams.Add("spatialsource_uid", Configuration.ApiClient.ParameterToString(spatialsourceUid)); // path parameter
            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (embed != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "embed", embed)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetSpatialSourceByUID", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<SpatialSourcesEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (SpatialSourcesEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(SpatialSourcesEndpointType)));
        }

        /// <summary>
        /// Returns the additional documents of a spatial source Returns the additional documents of a spatial source
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialsourceUid">SpatialSource UID</param>
        /// <param name="adddocUid">SpatialSource UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="fields">Comma separated list of field names (optional)</param>
        /// <returns>List&lt;AdditionalDocumentsEndpointType&gt;</returns>
        public List<AdditionalDocumentsEndpointType> GetSpatialSourceSingleAddDoc (string spatialsourceUid, string adddocUid, string envelope = null, List<string> fields = null)
        {
             ApiResponse<List<AdditionalDocumentsEndpointType>> localVarResponse = GetSpatialSourceSingleAddDocWithHttpInfo(spatialsourceUid, adddocUid, envelope, fields);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Returns the additional documents of a spatial source Returns the additional documents of a spatial source
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialsourceUid">SpatialSource UID</param>
        /// <param name="adddocUid">SpatialSource UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="fields">Comma separated list of field names (optional)</param>
        /// <returns>ApiResponse of List&lt;AdditionalDocumentsEndpointType&gt;</returns>
        public ApiResponse< List<AdditionalDocumentsEndpointType> > GetSpatialSourceSingleAddDocWithHttpInfo (string spatialsourceUid, string adddocUid, string envelope = null, List<string> fields = null)
        {
            // verify the required parameter 'spatialsourceUid' is set
            if (spatialsourceUid == null)
                throw new ApiException(400, "Missing required parameter 'spatialsourceUid' when calling SpatialSourcesApi->GetSpatialSourceSingleAddDoc");
            // verify the required parameter 'adddocUid' is set
            if (adddocUid == null)
                throw new ApiException(400, "Missing required parameter 'adddocUid' when calling SpatialSourcesApi->GetSpatialSourceSingleAddDoc");

            var localVarPath = "/spatialsource/{spatialsource_uid}/AdditionalDocument/{adddoc_uid}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (spatialsourceUid != null) localVarPathParams.Add("spatialsource_uid", Configuration.ApiClient.ParameterToString(spatialsourceUid)); // path parameter
            if (adddocUid != null) localVarPathParams.Add("adddoc_uid", Configuration.ApiClient.ParameterToString(adddocUid)); // path parameter
            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (fields != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "fields", fields)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetSpatialSourceSingleAddDoc", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<AdditionalDocumentsEndpointType>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<AdditionalDocumentsEndpointType>) Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<AdditionalDocumentsEndpointType>)));
        }

        /// <summary>
        /// Returns the additional documents of a spatial source Returns the additional documents of a spatial source
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialsourceUid">SpatialSource UID</param>
        /// <param name="adddocUid">SpatialSource UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="fields">Comma separated list of field names (optional)</param>
        /// <returns>Task of List&lt;AdditionalDocumentsEndpointType&gt;</returns>
        public async System.Threading.Tasks.Task<List<AdditionalDocumentsEndpointType>> GetSpatialSourceSingleAddDocAsync (string spatialsourceUid, string adddocUid, string envelope = null, List<string> fields = null)
        {
             ApiResponse<List<AdditionalDocumentsEndpointType>> localVarResponse = await GetSpatialSourceSingleAddDocAsyncWithHttpInfo(spatialsourceUid, adddocUid, envelope, fields);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Returns the additional documents of a spatial source Returns the additional documents of a spatial source
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialsourceUid">SpatialSource UID</param>
        /// <param name="adddocUid">SpatialSource UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="fields">Comma separated list of field names (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;AdditionalDocumentsEndpointType&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<AdditionalDocumentsEndpointType>>> GetSpatialSourceSingleAddDocAsyncWithHttpInfo (string spatialsourceUid, string adddocUid, string envelope = null, List<string> fields = null)
        {
            // verify the required parameter 'spatialsourceUid' is set
            if (spatialsourceUid == null)
                throw new ApiException(400, "Missing required parameter 'spatialsourceUid' when calling SpatialSourcesApi->GetSpatialSourceSingleAddDoc");
            // verify the required parameter 'adddocUid' is set
            if (adddocUid == null)
                throw new ApiException(400, "Missing required parameter 'adddocUid' when calling SpatialSourcesApi->GetSpatialSourceSingleAddDoc");

            var localVarPath = "/spatialsource/{spatialsource_uid}/AdditionalDocument/{adddoc_uid}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (spatialsourceUid != null) localVarPathParams.Add("spatialsource_uid", Configuration.ApiClient.ParameterToString(spatialsourceUid)); // path parameter
            if (adddocUid != null) localVarPathParams.Add("adddoc_uid", Configuration.ApiClient.ParameterToString(adddocUid)); // path parameter
            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (fields != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "fields", fields)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetSpatialSourceSingleAddDoc", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<AdditionalDocumentsEndpointType>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<AdditionalDocumentsEndpointType>) Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<AdditionalDocumentsEndpointType>)));
        }

        /// <summary>
        /// Returns a list of SpatialSources Returns a list of SpatialSources
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="uid">Comma separated list of SpatialSources UID (optional)</param>
        /// <param name="name">Comma separated list of SpatialSources names (optional)</param>
        /// <param name="type">Comma separated list of SpatialSources types (optional)</param>
        /// <param name="projects">Comma separated list of project UID (optional)</param>
        /// <param name="tags">Comma separated list of tags (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of tags (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>List&lt;SpatialSourcesEndpointType&gt;</returns>
        public List<SpatialSourcesEndpointType> GetSpatialSources (string envelope = null, List<string> uid = null, List<string> name = null, List<string> type = null, List<string> projects = null, List<string> tags = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null)
        {
             ApiResponse<List<SpatialSourcesEndpointType>> localVarResponse = GetSpatialSourcesWithHttpInfo(envelope, uid, name, type, projects, tags, page, sort, fields, embed);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Returns a list of SpatialSources Returns a list of SpatialSources
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="uid">Comma separated list of SpatialSources UID (optional)</param>
        /// <param name="name">Comma separated list of SpatialSources names (optional)</param>
        /// <param name="type">Comma separated list of SpatialSources types (optional)</param>
        /// <param name="projects">Comma separated list of project UID (optional)</param>
        /// <param name="tags">Comma separated list of tags (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of tags (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>ApiResponse of List&lt;SpatialSourcesEndpointType&gt;</returns>
        public ApiResponse< List<SpatialSourcesEndpointType> > GetSpatialSourcesWithHttpInfo (string envelope = null, List<string> uid = null, List<string> name = null, List<string> type = null, List<string> projects = null, List<string> tags = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null)
        {

            var localVarPath = "/spatialsources";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (uid != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "uid", uid)); // query parameter
            if (name != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "name", name)); // query parameter
            if (type != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "type", type)); // query parameter
            if (projects != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "projects", projects)); // query parameter
            if (tags != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "tags", tags)); // query parameter
            if (page != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "page", page)); // query parameter
            if (sort != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "sort", sort)); // query parameter
            if (fields != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "fields", fields)); // query parameter
            if (embed != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "embed", embed)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetSpatialSources", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<SpatialSourcesEndpointType>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<SpatialSourcesEndpointType>) Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<SpatialSourcesEndpointType>)));
        }

        /// <summary>
        /// Returns a list of SpatialSources Returns a list of SpatialSources
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="uid">Comma separated list of SpatialSources UID (optional)</param>
        /// <param name="name">Comma separated list of SpatialSources names (optional)</param>
        /// <param name="type">Comma separated list of SpatialSources types (optional)</param>
        /// <param name="projects">Comma separated list of project UID (optional)</param>
        /// <param name="tags">Comma separated list of tags (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of tags (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of List&lt;SpatialSourcesEndpointType&gt;</returns>
        public async System.Threading.Tasks.Task<List<SpatialSourcesEndpointType>> GetSpatialSourcesAsync (string envelope = null, List<string> uid = null, List<string> name = null, List<string> type = null, List<string> projects = null, List<string> tags = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null)
        {
             ApiResponse<List<SpatialSourcesEndpointType>> localVarResponse = await GetSpatialSourcesAsyncWithHttpInfo(envelope, uid, name, type, projects, tags, page, sort, fields, embed);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Returns a list of SpatialSources Returns a list of SpatialSources
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="uid">Comma separated list of SpatialSources UID (optional)</param>
        /// <param name="name">Comma separated list of SpatialSources names (optional)</param>
        /// <param name="type">Comma separated list of SpatialSources types (optional)</param>
        /// <param name="projects">Comma separated list of project UID (optional)</param>
        /// <param name="tags">Comma separated list of tags (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of tags (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;SpatialSourcesEndpointType&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<SpatialSourcesEndpointType>>> GetSpatialSourcesAsyncWithHttpInfo (string envelope = null, List<string> uid = null, List<string> name = null, List<string> type = null, List<string> projects = null, List<string> tags = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null)
        {

            var localVarPath = "/spatialsources";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (uid != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "uid", uid)); // query parameter
            if (name != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "name", name)); // query parameter
            if (type != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "type", type)); // query parameter
            if (projects != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "projects", projects)); // query parameter
            if (tags != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "tags", tags)); // query parameter
            if (page != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "page", page)); // query parameter
            if (sort != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "sort", sort)); // query parameter
            if (fields != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "fields", fields)); // query parameter
            if (embed != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "embed", embed)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetSpatialSources", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<SpatialSourcesEndpointType>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<SpatialSourcesEndpointType>) Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<SpatialSourcesEndpointType>)));
        }

        /// <summary>
        /// Create a new SpatialSource Create a new SpatialSource. To add a new SpatialSources , the content of SpatialSources  must be stored in advanced via the ContentItem endpoint.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newspatialsource">New SpatialSource data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="processUid">deprecated (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>SpatialSourcesEndpointType</returns>
        public SpatialSourcesEndpointType NewSpatialSource (SpatialSourcesPostRequest newspatialsource, string envelope = null, List<string> embed = null, string processUid = null, string i4lProcessUid = null)
        {
             ApiResponse<SpatialSourcesEndpointType> localVarResponse = NewSpatialSourceWithHttpInfo(newspatialsource, envelope, embed, processUid, i4lProcessUid);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Create a new SpatialSource Create a new SpatialSource. To add a new SpatialSources , the content of SpatialSources  must be stored in advanced via the ContentItem endpoint.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newspatialsource">New SpatialSource data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="processUid">deprecated (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>ApiResponse of SpatialSourcesEndpointType</returns>
        public ApiResponse< SpatialSourcesEndpointType > NewSpatialSourceWithHttpInfo (SpatialSourcesPostRequest newspatialsource, string envelope = null, List<string> embed = null, string processUid = null, string i4lProcessUid = null)
        {
            // verify the required parameter 'newspatialsource' is set
            if (newspatialsource == null)
                throw new ApiException(400, "Missing required parameter 'newspatialsource' when calling SpatialSourcesApi->NewSpatialSource");

            var localVarPath = "/spatialsources";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (embed != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "embed", embed)); // query parameter
            if (processUid != null) localVarHeaderParams.Add("process_uid", Configuration.ApiClient.ParameterToString(processUid)); // header parameter
            if (i4lProcessUid != null) localVarHeaderParams.Add("i4l-process-uid", Configuration.ApiClient.ParameterToString(i4lProcessUid)); // header parameter
            if (newspatialsource != null && newspatialsource.GetType() != typeof(byte[]))
            {
                localVarPostBody = Configuration.ApiClient.Serialize(newspatialsource); // http body (model) parameter
            }
            else
            {
                localVarPostBody = newspatialsource; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("NewSpatialSource", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<SpatialSourcesEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (SpatialSourcesEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(SpatialSourcesEndpointType)));
        }

        /// <summary>
        /// Create a new SpatialSource Create a new SpatialSource. To add a new SpatialSources , the content of SpatialSources  must be stored in advanced via the ContentItem endpoint.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newspatialsource">New SpatialSource data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="processUid">deprecated (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of SpatialSourcesEndpointType</returns>
        public async System.Threading.Tasks.Task<SpatialSourcesEndpointType> NewSpatialSourceAsync (SpatialSourcesPostRequest newspatialsource, string envelope = null, List<string> embed = null, string processUid = null, string i4lProcessUid = null)
        {
             ApiResponse<SpatialSourcesEndpointType> localVarResponse = await NewSpatialSourceAsyncWithHttpInfo(newspatialsource, envelope, embed, processUid, i4lProcessUid);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Create a new SpatialSource Create a new SpatialSource. To add a new SpatialSources , the content of SpatialSources  must be stored in advanced via the ContentItem endpoint.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newspatialsource">New SpatialSource data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="processUid">deprecated (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of ApiResponse (SpatialSourcesEndpointType)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<SpatialSourcesEndpointType>> NewSpatialSourceAsyncWithHttpInfo (SpatialSourcesPostRequest newspatialsource, string envelope = null, List<string> embed = null, string processUid = null, string i4lProcessUid = null)
        {
            // verify the required parameter 'newspatialsource' is set
            if (newspatialsource == null)
                throw new ApiException(400, "Missing required parameter 'newspatialsource' when calling SpatialSourcesApi->NewSpatialSource");

            var localVarPath = "/spatialsources";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (embed != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "embed", embed)); // query parameter
            if (processUid != null) localVarHeaderParams.Add("process_uid", Configuration.ApiClient.ParameterToString(processUid)); // header parameter
            if (i4lProcessUid != null) localVarHeaderParams.Add("i4l-process-uid", Configuration.ApiClient.ParameterToString(i4lProcessUid)); // header parameter
            if (newspatialsource != null && newspatialsource.GetType() != typeof(byte[]))
            {
                localVarPostBody = Configuration.ApiClient.Serialize(newspatialsource); // http body (model) parameter
            }
            else
            {
                localVarPostBody = newspatialsource; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("NewSpatialSource", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<SpatialSourcesEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (SpatialSourcesEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(SpatialSourcesEndpointType)));
        }

        /// <summary>
        /// Add a new additional document to a spatial source Add a new additional document to a spatial source
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialsourceUid">SpatialSource UID</param>
        /// <param name="newadddocdata">New additional document data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>AdditionalDocumentsEndpointType</returns>
        public AdditionalDocumentsEndpointType NewSpatialSourceAddAddDoc (string spatialsourceUid, AdditionalDocumentsPost newadddocdata, string envelope = null, string i4lProcessUid = null)
        {
             ApiResponse<AdditionalDocumentsEndpointType> localVarResponse = NewSpatialSourceAddAddDocWithHttpInfo(spatialsourceUid, newadddocdata, envelope, i4lProcessUid);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Add a new additional document to a spatial source Add a new additional document to a spatial source
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialsourceUid">SpatialSource UID</param>
        /// <param name="newadddocdata">New additional document data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>ApiResponse of AdditionalDocumentsEndpointType</returns>
        public ApiResponse< AdditionalDocumentsEndpointType > NewSpatialSourceAddAddDocWithHttpInfo (string spatialsourceUid, AdditionalDocumentsPost newadddocdata, string envelope = null, string i4lProcessUid = null)
        {
            // verify the required parameter 'spatialsourceUid' is set
            if (spatialsourceUid == null)
                throw new ApiException(400, "Missing required parameter 'spatialsourceUid' when calling SpatialSourcesApi->NewSpatialSourceAddAddDoc");
            // verify the required parameter 'newadddocdata' is set
            if (newadddocdata == null)
                throw new ApiException(400, "Missing required parameter 'newadddocdata' when calling SpatialSourcesApi->NewSpatialSourceAddAddDoc");

            var localVarPath = "/spatialsource/{spatialsource_uid}/AdditionalDocument";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (spatialsourceUid != null) localVarPathParams.Add("spatialsource_uid", Configuration.ApiClient.ParameterToString(spatialsourceUid)); // path parameter
            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (i4lProcessUid != null) localVarHeaderParams.Add("i4l-process-uid", Configuration.ApiClient.ParameterToString(i4lProcessUid)); // header parameter
            if (newadddocdata != null && newadddocdata.GetType() != typeof(byte[]))
            {
                localVarPostBody = Configuration.ApiClient.Serialize(newadddocdata); // http body (model) parameter
            }
            else
            {
                localVarPostBody = newadddocdata; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("NewSpatialSourceAddAddDoc", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<AdditionalDocumentsEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (AdditionalDocumentsEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(AdditionalDocumentsEndpointType)));
        }

        /// <summary>
        /// Add a new additional document to a spatial source Add a new additional document to a spatial source
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialsourceUid">SpatialSource UID</param>
        /// <param name="newadddocdata">New additional document data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of AdditionalDocumentsEndpointType</returns>
        public async System.Threading.Tasks.Task<AdditionalDocumentsEndpointType> NewSpatialSourceAddAddDocAsync (string spatialsourceUid, AdditionalDocumentsPost newadddocdata, string envelope = null, string i4lProcessUid = null)
        {
             ApiResponse<AdditionalDocumentsEndpointType> localVarResponse = await NewSpatialSourceAddAddDocAsyncWithHttpInfo(spatialsourceUid, newadddocdata, envelope, i4lProcessUid);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Add a new additional document to a spatial source Add a new additional document to a spatial source
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialsourceUid">SpatialSource UID</param>
        /// <param name="newadddocdata">New additional document data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of ApiResponse (AdditionalDocumentsEndpointType)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<AdditionalDocumentsEndpointType>> NewSpatialSourceAddAddDocAsyncWithHttpInfo (string spatialsourceUid, AdditionalDocumentsPost newadddocdata, string envelope = null, string i4lProcessUid = null)
        {
            // verify the required parameter 'spatialsourceUid' is set
            if (spatialsourceUid == null)
                throw new ApiException(400, "Missing required parameter 'spatialsourceUid' when calling SpatialSourcesApi->NewSpatialSourceAddAddDoc");
            // verify the required parameter 'newadddocdata' is set
            if (newadddocdata == null)
                throw new ApiException(400, "Missing required parameter 'newadddocdata' when calling SpatialSourcesApi->NewSpatialSourceAddAddDoc");

            var localVarPath = "/spatialsource/{spatialsource_uid}/AdditionalDocument";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (spatialsourceUid != null) localVarPathParams.Add("spatialsource_uid", Configuration.ApiClient.ParameterToString(spatialsourceUid)); // path parameter
            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (i4lProcessUid != null) localVarHeaderParams.Add("i4l-process-uid", Configuration.ApiClient.ParameterToString(i4lProcessUid)); // header parameter
            if (newadddocdata != null && newadddocdata.GetType() != typeof(byte[]))
            {
                localVarPostBody = Configuration.ApiClient.Serialize(newadddocdata); // http body (model) parameter
            }
            else
            {
                localVarPostBody = newadddocdata; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("NewSpatialSourceAddAddDoc", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<AdditionalDocumentsEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (AdditionalDocumentsEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(AdditionalDocumentsEndpointType)));
        }

        /// <summary>
        /// Replace an existing SpatialSource by a newer version An existing SpatialSource will be replaced by a newer version. The UID of SpatialSource remains
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialsourceUid">SpatialSource UID</param>
        /// <param name="updatedspatialsource">Updated spatial source</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>SpatialSourcesEndpointType</returns>
        public SpatialSourcesEndpointType PutSpatialSourceByUID (string spatialsourceUid, SpatialSourcesPostRequest updatedspatialsource, string envelope = null, List<string> embed = null, string i4lProcessUid = null)
        {
             ApiResponse<SpatialSourcesEndpointType> localVarResponse = PutSpatialSourceByUIDWithHttpInfo(spatialsourceUid, updatedspatialsource, envelope, embed, i4lProcessUid);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Replace an existing SpatialSource by a newer version An existing SpatialSource will be replaced by a newer version. The UID of SpatialSource remains
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialsourceUid">SpatialSource UID</param>
        /// <param name="updatedspatialsource">Updated spatial source</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>ApiResponse of SpatialSourcesEndpointType</returns>
        public ApiResponse< SpatialSourcesEndpointType > PutSpatialSourceByUIDWithHttpInfo (string spatialsourceUid, SpatialSourcesPostRequest updatedspatialsource, string envelope = null, List<string> embed = null, string i4lProcessUid = null)
        {
            // verify the required parameter 'spatialsourceUid' is set
            if (spatialsourceUid == null)
                throw new ApiException(400, "Missing required parameter 'spatialsourceUid' when calling SpatialSourcesApi->PutSpatialSourceByUID");
            // verify the required parameter 'updatedspatialsource' is set
            if (updatedspatialsource == null)
                throw new ApiException(400, "Missing required parameter 'updatedspatialsource' when calling SpatialSourcesApi->PutSpatialSourceByUID");

            var localVarPath = "/spatialsource/{spatialsource_uid}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (spatialsourceUid != null) localVarPathParams.Add("spatialsource_uid", Configuration.ApiClient.ParameterToString(spatialsourceUid)); // path parameter
            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (embed != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "embed", embed)); // query parameter
            if (i4lProcessUid != null) localVarHeaderParams.Add("i4l-process-uid", Configuration.ApiClient.ParameterToString(i4lProcessUid)); // header parameter
            if (updatedspatialsource != null && updatedspatialsource.GetType() != typeof(byte[]))
            {
                localVarPostBody = Configuration.ApiClient.Serialize(updatedspatialsource); // http body (model) parameter
            }
            else
            {
                localVarPostBody = updatedspatialsource; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.PUT, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PutSpatialSourceByUID", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<SpatialSourcesEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (SpatialSourcesEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(SpatialSourcesEndpointType)));
        }

        /// <summary>
        /// Replace an existing SpatialSource by a newer version An existing SpatialSource will be replaced by a newer version. The UID of SpatialSource remains
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialsourceUid">SpatialSource UID</param>
        /// <param name="updatedspatialsource">Updated spatial source</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of SpatialSourcesEndpointType</returns>
        public async System.Threading.Tasks.Task<SpatialSourcesEndpointType> PutSpatialSourceByUIDAsync (string spatialsourceUid, SpatialSourcesPostRequest updatedspatialsource, string envelope = null, List<string> embed = null, string i4lProcessUid = null)
        {
             ApiResponse<SpatialSourcesEndpointType> localVarResponse = await PutSpatialSourceByUIDAsyncWithHttpInfo(spatialsourceUid, updatedspatialsource, envelope, embed, i4lProcessUid);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Replace an existing SpatialSource by a newer version An existing SpatialSource will be replaced by a newer version. The UID of SpatialSource remains
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialsourceUid">SpatialSource UID</param>
        /// <param name="updatedspatialsource">Updated spatial source</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of ApiResponse (SpatialSourcesEndpointType)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<SpatialSourcesEndpointType>> PutSpatialSourceByUIDAsyncWithHttpInfo (string spatialsourceUid, SpatialSourcesPostRequest updatedspatialsource, string envelope = null, List<string> embed = null, string i4lProcessUid = null)
        {
            // verify the required parameter 'spatialsourceUid' is set
            if (spatialsourceUid == null)
                throw new ApiException(400, "Missing required parameter 'spatialsourceUid' when calling SpatialSourcesApi->PutSpatialSourceByUID");
            // verify the required parameter 'updatedspatialsource' is set
            if (updatedspatialsource == null)
                throw new ApiException(400, "Missing required parameter 'updatedspatialsource' when calling SpatialSourcesApi->PutSpatialSourceByUID");

            var localVarPath = "/spatialsource/{spatialsource_uid}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (spatialsourceUid != null) localVarPathParams.Add("spatialsource_uid", Configuration.ApiClient.ParameterToString(spatialsourceUid)); // path parameter
            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (embed != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "embed", embed)); // query parameter
            if (i4lProcessUid != null) localVarHeaderParams.Add("i4l-process-uid", Configuration.ApiClient.ParameterToString(i4lProcessUid)); // header parameter
            if (updatedspatialsource != null && updatedspatialsource.GetType() != typeof(byte[]))
            {
                localVarPostBody = Configuration.ApiClient.Serialize(updatedspatialsource); // http body (model) parameter
            }
            else
            {
                localVarPostBody = updatedspatialsource; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.PUT, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PutSpatialSourceByUID", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<SpatialSourcesEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (SpatialSourcesEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(SpatialSourcesEndpointType)));
        }

    }
}
