/* 
 * its4land Public API
 *
 * The its4land Public API provides access to the services of the its4land Publish and Share platform.
 *
 * OpenAPI spec version: 0.0.2
 * Contact: contact@its4land.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using RestSharp;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace IO.Swagger.Api
{
    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public interface ITrainingSetsApi : IApiAccessor
    {
        #region Synchronous Operations
        /// <summary>
        /// Returns a single TrainingSet
        /// </summary>
        /// <remarks>
        /// Returns a single TrainingSet
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="trainingsetsUid">TrainingSet UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>TrainingsSetEndpointType</returns>
        TrainingsSetEndpointType GetTrainingSetByUID (string trainingsetsUid, string envelope = null, List<string> embed = null);

        /// <summary>
        /// Returns a single TrainingSet
        /// </summary>
        /// <remarks>
        /// Returns a single TrainingSet
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="trainingsetsUid">TrainingSet UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>ApiResponse of TrainingsSetEndpointType</returns>
        ApiResponse<TrainingsSetEndpointType> GetTrainingSetByUIDWithHttpInfo (string trainingsetsUid, string envelope = null, List<string> embed = null);
        /// <summary>
        /// Returns a list of TrainingSets
        /// </summary>
        /// <remarks>
        /// Returns a list of TrainingSets
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="uid">Comma separated list of TrainingSet UID (optional)</param>
        /// <param name="name">Comma separated list of TrainingSet Names (optional)</param>
        /// <param name="models">Comma separated list of model UID (optional)</param>
        /// <param name="tags">Comma separated list of tags (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of field names (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>List&lt;TrainingsSetEndpointType&gt;</returns>
        List<TrainingsSetEndpointType> GetTrainingSets (string envelope = null, List<string> uid = null, List<string> name = null, List<string> models = null, List<string> tags = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null);

        /// <summary>
        /// Returns a list of TrainingSets
        /// </summary>
        /// <remarks>
        /// Returns a list of TrainingSets
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="uid">Comma separated list of TrainingSet UID (optional)</param>
        /// <param name="name">Comma separated list of TrainingSet Names (optional)</param>
        /// <param name="models">Comma separated list of model UID (optional)</param>
        /// <param name="tags">Comma separated list of tags (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of field names (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>ApiResponse of List&lt;TrainingsSetEndpointType&gt;</returns>
        ApiResponse<List<TrainingsSetEndpointType>> GetTrainingSetsWithHttpInfo (string envelope = null, List<string> uid = null, List<string> name = null, List<string> models = null, List<string> tags = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null);
        /// <summary>
        /// Create a new TrainingSet
        /// </summary>
        /// <remarks>
        /// Create a new TrainingSet. To add a new TrainingSet , the content of TrainingSet  must be stored in advanced via the ContentItem endpoint
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newtrainingset">New TrainingSet data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>TrainingsSetEndpointType</returns>
        TrainingsSetEndpointType NewTrainingSet (TrainingSetsPostRequest newtrainingset, string envelope = null, List<string> embed = null, string i4lProcessUid = null);

        /// <summary>
        /// Create a new TrainingSet
        /// </summary>
        /// <remarks>
        /// Create a new TrainingSet. To add a new TrainingSet , the content of TrainingSet  must be stored in advanced via the ContentItem endpoint
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newtrainingset">New TrainingSet data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>ApiResponse of TrainingsSetEndpointType</returns>
        ApiResponse<TrainingsSetEndpointType> NewTrainingSetWithHttpInfo (TrainingSetsPostRequest newtrainingset, string envelope = null, List<string> embed = null, string i4lProcessUid = null);
        #endregion Synchronous Operations
        #region Asynchronous Operations
        /// <summary>
        /// Returns a single TrainingSet
        /// </summary>
        /// <remarks>
        /// Returns a single TrainingSet
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="trainingsetsUid">TrainingSet UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of TrainingsSetEndpointType</returns>
        System.Threading.Tasks.Task<TrainingsSetEndpointType> GetTrainingSetByUIDAsync (string trainingsetsUid, string envelope = null, List<string> embed = null);

        /// <summary>
        /// Returns a single TrainingSet
        /// </summary>
        /// <remarks>
        /// Returns a single TrainingSet
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="trainingsetsUid">TrainingSet UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of ApiResponse (TrainingsSetEndpointType)</returns>
        System.Threading.Tasks.Task<ApiResponse<TrainingsSetEndpointType>> GetTrainingSetByUIDAsyncWithHttpInfo (string trainingsetsUid, string envelope = null, List<string> embed = null);
        /// <summary>
        /// Returns a list of TrainingSets
        /// </summary>
        /// <remarks>
        /// Returns a list of TrainingSets
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="uid">Comma separated list of TrainingSet UID (optional)</param>
        /// <param name="name">Comma separated list of TrainingSet Names (optional)</param>
        /// <param name="models">Comma separated list of model UID (optional)</param>
        /// <param name="tags">Comma separated list of tags (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of field names (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of List&lt;TrainingsSetEndpointType&gt;</returns>
        System.Threading.Tasks.Task<List<TrainingsSetEndpointType>> GetTrainingSetsAsync (string envelope = null, List<string> uid = null, List<string> name = null, List<string> models = null, List<string> tags = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null);

        /// <summary>
        /// Returns a list of TrainingSets
        /// </summary>
        /// <remarks>
        /// Returns a list of TrainingSets
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="uid">Comma separated list of TrainingSet UID (optional)</param>
        /// <param name="name">Comma separated list of TrainingSet Names (optional)</param>
        /// <param name="models">Comma separated list of model UID (optional)</param>
        /// <param name="tags">Comma separated list of tags (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of field names (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;TrainingsSetEndpointType&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<TrainingsSetEndpointType>>> GetTrainingSetsAsyncWithHttpInfo (string envelope = null, List<string> uid = null, List<string> name = null, List<string> models = null, List<string> tags = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null);
        /// <summary>
        /// Create a new TrainingSet
        /// </summary>
        /// <remarks>
        /// Create a new TrainingSet. To add a new TrainingSet , the content of TrainingSet  must be stored in advanced via the ContentItem endpoint
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newtrainingset">New TrainingSet data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of TrainingsSetEndpointType</returns>
        System.Threading.Tasks.Task<TrainingsSetEndpointType> NewTrainingSetAsync (TrainingSetsPostRequest newtrainingset, string envelope = null, List<string> embed = null, string i4lProcessUid = null);

        /// <summary>
        /// Create a new TrainingSet
        /// </summary>
        /// <remarks>
        /// Create a new TrainingSet. To add a new TrainingSet , the content of TrainingSet  must be stored in advanced via the ContentItem endpoint
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newtrainingset">New TrainingSet data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of ApiResponse (TrainingsSetEndpointType)</returns>
        System.Threading.Tasks.Task<ApiResponse<TrainingsSetEndpointType>> NewTrainingSetAsyncWithHttpInfo (TrainingSetsPostRequest newtrainingset, string envelope = null, List<string> embed = null, string i4lProcessUid = null);
        #endregion Asynchronous Operations
    }

    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public partial class TrainingSetsApi : ITrainingSetsApi
    {
        private IO.Swagger.Client.ExceptionFactory _exceptionFactory = (name, response) => null;

        /// <summary>
        /// Initializes a new instance of the <see cref="TrainingSetsApi"/> class.
        /// </summary>
        /// <returns></returns>
        public TrainingSetsApi(String basePath)
        {
            this.Configuration = new Configuration { BasePath = basePath };

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="TrainingSetsApi"/> class
        /// using Configuration object
        /// </summary>
        /// <param name="configuration">An instance of Configuration</param>
        /// <returns></returns>
        public TrainingSetsApi(Configuration configuration = null)
        {
            if (configuration == null) // use the default one in Configuration
                this.Configuration = Configuration.Default;
            else
                this.Configuration = configuration;

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Gets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        public String GetBasePath()
        {
            return this.Configuration.ApiClient.RestClient.BaseUrl.ToString();
        }

        /// <summary>
        /// Sets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        [Obsolete("SetBasePath is deprecated, please do 'Configuration.ApiClient = new ApiClient(\"http://new-path\")' instead.")]
        public void SetBasePath(String basePath)
        {
            // do nothing
        }

        /// <summary>
        /// Gets or sets the configuration object
        /// </summary>
        /// <value>An instance of the Configuration</value>
        public Configuration Configuration {get; set;}

        /// <summary>
        /// Provides a factory method hook for the creation of exceptions.
        /// </summary>
        public IO.Swagger.Client.ExceptionFactory ExceptionFactory
        {
            get
            {
                if (_exceptionFactory != null && _exceptionFactory.GetInvocationList().Length > 1)
                {
                    throw new InvalidOperationException("Multicast delegate for ExceptionFactory is unsupported.");
                }
                return _exceptionFactory;
            }
            set { _exceptionFactory = value; }
        }

        /// <summary>
        /// Gets the default header.
        /// </summary>
        /// <returns>Dictionary of HTTP header</returns>
        [Obsolete("DefaultHeader is deprecated, please use Configuration.DefaultHeader instead.")]
        public IDictionary<String, String> DefaultHeader()
        {
            return new ReadOnlyDictionary<string, string>(this.Configuration.DefaultHeader);
        }

        /// <summary>
        /// Add default header.
        /// </summary>
        /// <param name="key">Header field name.</param>
        /// <param name="value">Header field value.</param>
        /// <returns></returns>
        [Obsolete("AddDefaultHeader is deprecated, please use Configuration.AddDefaultHeader instead.")]
        public void AddDefaultHeader(string key, string value)
        {
            this.Configuration.AddDefaultHeader(key, value);
        }

        /// <summary>
        /// Returns a single TrainingSet Returns a single TrainingSet
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="trainingsetsUid">TrainingSet UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>TrainingsSetEndpointType</returns>
        public TrainingsSetEndpointType GetTrainingSetByUID (string trainingsetsUid, string envelope = null, List<string> embed = null)
        {
             ApiResponse<TrainingsSetEndpointType> localVarResponse = GetTrainingSetByUIDWithHttpInfo(trainingsetsUid, envelope, embed);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Returns a single TrainingSet Returns a single TrainingSet
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="trainingsetsUid">TrainingSet UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>ApiResponse of TrainingsSetEndpointType</returns>
        public ApiResponse< TrainingsSetEndpointType > GetTrainingSetByUIDWithHttpInfo (string trainingsetsUid, string envelope = null, List<string> embed = null)
        {
            // verify the required parameter 'trainingsetsUid' is set
            if (trainingsetsUid == null)
                throw new ApiException(400, "Missing required parameter 'trainingsetsUid' when calling TrainingSetsApi->GetTrainingSetByUID");

            var localVarPath = "/trainingsets/{trainingsets_uid}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (trainingsetsUid != null) localVarPathParams.Add("trainingsets_uid", Configuration.ApiClient.ParameterToString(trainingsetsUid)); // path parameter
            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (embed != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "embed", embed)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetTrainingSetByUID", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<TrainingsSetEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (TrainingsSetEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(TrainingsSetEndpointType)));
        }

        /// <summary>
        /// Returns a single TrainingSet Returns a single TrainingSet
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="trainingsetsUid">TrainingSet UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of TrainingsSetEndpointType</returns>
        public async System.Threading.Tasks.Task<TrainingsSetEndpointType> GetTrainingSetByUIDAsync (string trainingsetsUid, string envelope = null, List<string> embed = null)
        {
             ApiResponse<TrainingsSetEndpointType> localVarResponse = await GetTrainingSetByUIDAsyncWithHttpInfo(trainingsetsUid, envelope, embed);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Returns a single TrainingSet Returns a single TrainingSet
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="trainingsetsUid">TrainingSet UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of ApiResponse (TrainingsSetEndpointType)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<TrainingsSetEndpointType>> GetTrainingSetByUIDAsyncWithHttpInfo (string trainingsetsUid, string envelope = null, List<string> embed = null)
        {
            // verify the required parameter 'trainingsetsUid' is set
            if (trainingsetsUid == null)
                throw new ApiException(400, "Missing required parameter 'trainingsetsUid' when calling TrainingSetsApi->GetTrainingSetByUID");

            var localVarPath = "/trainingsets/{trainingsets_uid}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (trainingsetsUid != null) localVarPathParams.Add("trainingsets_uid", Configuration.ApiClient.ParameterToString(trainingsetsUid)); // path parameter
            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (embed != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "embed", embed)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetTrainingSetByUID", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<TrainingsSetEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (TrainingsSetEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(TrainingsSetEndpointType)));
        }

        /// <summary>
        /// Returns a list of TrainingSets Returns a list of TrainingSets
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="uid">Comma separated list of TrainingSet UID (optional)</param>
        /// <param name="name">Comma separated list of TrainingSet Names (optional)</param>
        /// <param name="models">Comma separated list of model UID (optional)</param>
        /// <param name="tags">Comma separated list of tags (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of field names (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>List&lt;TrainingsSetEndpointType&gt;</returns>
        public List<TrainingsSetEndpointType> GetTrainingSets (string envelope = null, List<string> uid = null, List<string> name = null, List<string> models = null, List<string> tags = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null)
        {
             ApiResponse<List<TrainingsSetEndpointType>> localVarResponse = GetTrainingSetsWithHttpInfo(envelope, uid, name, models, tags, page, sort, fields, embed);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Returns a list of TrainingSets Returns a list of TrainingSets
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="uid">Comma separated list of TrainingSet UID (optional)</param>
        /// <param name="name">Comma separated list of TrainingSet Names (optional)</param>
        /// <param name="models">Comma separated list of model UID (optional)</param>
        /// <param name="tags">Comma separated list of tags (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of field names (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>ApiResponse of List&lt;TrainingsSetEndpointType&gt;</returns>
        public ApiResponse< List<TrainingsSetEndpointType> > GetTrainingSetsWithHttpInfo (string envelope = null, List<string> uid = null, List<string> name = null, List<string> models = null, List<string> tags = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null)
        {

            var localVarPath = "/trainingsets";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (uid != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "uid", uid)); // query parameter
            if (name != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "name", name)); // query parameter
            if (models != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "models", models)); // query parameter
            if (tags != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "tags", tags)); // query parameter
            if (page != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "page", page)); // query parameter
            if (sort != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "sort", sort)); // query parameter
            if (fields != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "fields", fields)); // query parameter
            if (embed != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "embed", embed)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetTrainingSets", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<TrainingsSetEndpointType>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<TrainingsSetEndpointType>) Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<TrainingsSetEndpointType>)));
        }

        /// <summary>
        /// Returns a list of TrainingSets Returns a list of TrainingSets
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="uid">Comma separated list of TrainingSet UID (optional)</param>
        /// <param name="name">Comma separated list of TrainingSet Names (optional)</param>
        /// <param name="models">Comma separated list of model UID (optional)</param>
        /// <param name="tags">Comma separated list of tags (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of field names (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of List&lt;TrainingsSetEndpointType&gt;</returns>
        public async System.Threading.Tasks.Task<List<TrainingsSetEndpointType>> GetTrainingSetsAsync (string envelope = null, List<string> uid = null, List<string> name = null, List<string> models = null, List<string> tags = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null)
        {
             ApiResponse<List<TrainingsSetEndpointType>> localVarResponse = await GetTrainingSetsAsyncWithHttpInfo(envelope, uid, name, models, tags, page, sort, fields, embed);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Returns a list of TrainingSets Returns a list of TrainingSets
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="uid">Comma separated list of TrainingSet UID (optional)</param>
        /// <param name="name">Comma separated list of TrainingSet Names (optional)</param>
        /// <param name="models">Comma separated list of model UID (optional)</param>
        /// <param name="tags">Comma separated list of tags (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of field names (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;TrainingsSetEndpointType&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<TrainingsSetEndpointType>>> GetTrainingSetsAsyncWithHttpInfo (string envelope = null, List<string> uid = null, List<string> name = null, List<string> models = null, List<string> tags = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null)
        {

            var localVarPath = "/trainingsets";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (uid != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "uid", uid)); // query parameter
            if (name != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "name", name)); // query parameter
            if (models != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "models", models)); // query parameter
            if (tags != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "tags", tags)); // query parameter
            if (page != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "page", page)); // query parameter
            if (sort != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "sort", sort)); // query parameter
            if (fields != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "fields", fields)); // query parameter
            if (embed != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "embed", embed)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetTrainingSets", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<TrainingsSetEndpointType>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<TrainingsSetEndpointType>) Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<TrainingsSetEndpointType>)));
        }

        /// <summary>
        /// Create a new TrainingSet Create a new TrainingSet. To add a new TrainingSet , the content of TrainingSet  must be stored in advanced via the ContentItem endpoint
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newtrainingset">New TrainingSet data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>TrainingsSetEndpointType</returns>
        public TrainingsSetEndpointType NewTrainingSet (TrainingSetsPostRequest newtrainingset, string envelope = null, List<string> embed = null, string i4lProcessUid = null)
        {
             ApiResponse<TrainingsSetEndpointType> localVarResponse = NewTrainingSetWithHttpInfo(newtrainingset, envelope, embed, i4lProcessUid);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Create a new TrainingSet Create a new TrainingSet. To add a new TrainingSet , the content of TrainingSet  must be stored in advanced via the ContentItem endpoint
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newtrainingset">New TrainingSet data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>ApiResponse of TrainingsSetEndpointType</returns>
        public ApiResponse< TrainingsSetEndpointType > NewTrainingSetWithHttpInfo (TrainingSetsPostRequest newtrainingset, string envelope = null, List<string> embed = null, string i4lProcessUid = null)
        {
            // verify the required parameter 'newtrainingset' is set
            if (newtrainingset == null)
                throw new ApiException(400, "Missing required parameter 'newtrainingset' when calling TrainingSetsApi->NewTrainingSet");

            var localVarPath = "/trainingsets";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (embed != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "embed", embed)); // query parameter
            if (i4lProcessUid != null) localVarHeaderParams.Add("i4l-process-uid", Configuration.ApiClient.ParameterToString(i4lProcessUid)); // header parameter
            if (newtrainingset != null && newtrainingset.GetType() != typeof(byte[]))
            {
                localVarPostBody = Configuration.ApiClient.Serialize(newtrainingset); // http body (model) parameter
            }
            else
            {
                localVarPostBody = newtrainingset; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("NewTrainingSet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<TrainingsSetEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (TrainingsSetEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(TrainingsSetEndpointType)));
        }

        /// <summary>
        /// Create a new TrainingSet Create a new TrainingSet. To add a new TrainingSet , the content of TrainingSet  must be stored in advanced via the ContentItem endpoint
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newtrainingset">New TrainingSet data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of TrainingsSetEndpointType</returns>
        public async System.Threading.Tasks.Task<TrainingsSetEndpointType> NewTrainingSetAsync (TrainingSetsPostRequest newtrainingset, string envelope = null, List<string> embed = null, string i4lProcessUid = null)
        {
             ApiResponse<TrainingsSetEndpointType> localVarResponse = await NewTrainingSetAsyncWithHttpInfo(newtrainingset, envelope, embed, i4lProcessUid);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Create a new TrainingSet Create a new TrainingSet. To add a new TrainingSet , the content of TrainingSet  must be stored in advanced via the ContentItem endpoint
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newtrainingset">New TrainingSet data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of ApiResponse (TrainingsSetEndpointType)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<TrainingsSetEndpointType>> NewTrainingSetAsyncWithHttpInfo (TrainingSetsPostRequest newtrainingset, string envelope = null, List<string> embed = null, string i4lProcessUid = null)
        {
            // verify the required parameter 'newtrainingset' is set
            if (newtrainingset == null)
                throw new ApiException(400, "Missing required parameter 'newtrainingset' when calling TrainingSetsApi->NewTrainingSet");

            var localVarPath = "/trainingsets";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (embed != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "embed", embed)); // query parameter
            if (i4lProcessUid != null) localVarHeaderParams.Add("i4l-process-uid", Configuration.ApiClient.ParameterToString(i4lProcessUid)); // header parameter
            if (newtrainingset != null && newtrainingset.GetType() != typeof(byte[]))
            {
                localVarPostBody = Configuration.ApiClient.Serialize(newtrainingset); // http body (model) parameter
            }
            else
            {
                localVarPostBody = newtrainingset; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("NewTrainingSet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<TrainingsSetEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (TrainingsSetEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(TrainingsSetEndpointType)));
        }

    }
}
