/* 
 * its4land Public API
 *
 * The its4land Public API provides access to the services of the its4land Publish and Share platform.
 *
 * OpenAPI spec version: 0.0.2
 * Contact: contact@its4land.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// Post Request of he /adminsources endpoint
    /// </summary>
    [DataContract]
    public partial class AdminSourcesPostRequest :  IEquatable<AdminSourcesPostRequest>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="AdminSourcesPostRequest" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected AdminSourcesPostRequest() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="AdminSourcesPostRequest" /> class.
        /// </summary>
        /// <param name="Name">Freely chosen name (required).</param>
        /// <param name="Description">Free text for description. Only plain text. Max 255 char. (required).</param>
        /// <param name="LongDescription">Text for description. Can contain html. Max 4000 char..</param>
        /// <param name="ExtDescriptionURL">URL to an external description of the document..</param>
        /// <param name="Type">Admin Source type..</param>
        /// <param name="ContentItem">UID of the ContentItem (required).</param>
        /// <param name="Concept">Zeigt auf ein Konzept (UID) in einer auf LADM aufbauenden Ontologie. Was ist der Unterscheid zu Type? Besserer Name, daa ansosnsten Verwechselung mit Concept aus Models.</param>
        /// <param name="SpatialUnits">Array of Spatial Units. The Admin Source document provides the legal evidenace for the registartion of the Spatial Unit in the LAS..</param>
        /// <param name="Tags">Array of tags (strings)..</param>
        /// <param name="Projects">Array of Projects (UID)..</param>
        public AdminSourcesPostRequest(string Name = default(string), string Description = default(string), string LongDescription = default(string), string ExtDescriptionURL = default(string), string Type = default(string), string ContentItem = default(string), string Concept = default(string), List<AdminSourcesEndpointTypeSpatialUnits> SpatialUnits = default(List<AdminSourcesEndpointTypeSpatialUnits>), List<string> Tags = default(List<string>), List<ModelsEndpointTypeProjects> Projects = default(List<ModelsEndpointTypeProjects>))
        {
            // to ensure "Name" is required (not null)
            if (Name == null)
            {
                throw new InvalidDataException("Name is a required property for AdminSourcesPostRequest and cannot be null");
            }
            else
            {
                this.Name = Name;
            }
            // to ensure "Description" is required (not null)
            if (Description == null)
            {
                throw new InvalidDataException("Description is a required property for AdminSourcesPostRequest and cannot be null");
            }
            else
            {
                this.Description = Description;
            }
            // to ensure "ContentItem" is required (not null)
            if (ContentItem == null)
            {
                throw new InvalidDataException("ContentItem is a required property for AdminSourcesPostRequest and cannot be null");
            }
            else
            {
                this.ContentItem = ContentItem;
            }
            this.LongDescription = LongDescription;
            this.ExtDescriptionURL = ExtDescriptionURL;
            this.Type = Type;
            this.Concept = Concept;
            this.SpatialUnits = SpatialUnits;
            this.Tags = Tags;
            this.Projects = Projects;
        }
        
        /// <summary>
        /// Freely chosen name
        /// </summary>
        /// <value>Freely chosen name</value>
        [DataMember(Name="Name", EmitDefaultValue=false)]
        public string Name { get; set; }

        /// <summary>
        /// Free text for description. Only plain text. Max 255 char.
        /// </summary>
        /// <value>Free text for description. Only plain text. Max 255 char.</value>
        [DataMember(Name="Description", EmitDefaultValue=false)]
        public string Description { get; set; }

        /// <summary>
        /// Text for description. Can contain html. Max 4000 char.
        /// </summary>
        /// <value>Text for description. Can contain html. Max 4000 char.</value>
        [DataMember(Name="LongDescription", EmitDefaultValue=false)]
        public string LongDescription { get; set; }

        /// <summary>
        /// URL to an external description of the document.
        /// </summary>
        /// <value>URL to an external description of the document.</value>
        [DataMember(Name="ExtDescriptionURL", EmitDefaultValue=false)]
        public string ExtDescriptionURL { get; set; }

        /// <summary>
        /// Admin Source type.
        /// </summary>
        /// <value>Admin Source type.</value>
        [DataMember(Name="Type", EmitDefaultValue=false)]
        public string Type { get; set; }

        /// <summary>
        /// UID of the ContentItem
        /// </summary>
        /// <value>UID of the ContentItem</value>
        [DataMember(Name="ContentItem", EmitDefaultValue=false)]
        public string ContentItem { get; set; }

        /// <summary>
        /// Zeigt auf ein Konzept (UID) in einer auf LADM aufbauenden Ontologie. Was ist der Unterscheid zu Type? Besserer Name, daa ansosnsten Verwechselung mit Concept aus Models
        /// </summary>
        /// <value>Zeigt auf ein Konzept (UID) in einer auf LADM aufbauenden Ontologie. Was ist der Unterscheid zu Type? Besserer Name, daa ansosnsten Verwechselung mit Concept aus Models</value>
        [DataMember(Name="Concept", EmitDefaultValue=false)]
        public string Concept { get; set; }

        /// <summary>
        /// Array of Spatial Units. The Admin Source document provides the legal evidenace for the registartion of the Spatial Unit in the LAS.
        /// </summary>
        /// <value>Array of Spatial Units. The Admin Source document provides the legal evidenace for the registartion of the Spatial Unit in the LAS.</value>
        [DataMember(Name="SpatialUnits", EmitDefaultValue=false)]
        public List<AdminSourcesEndpointTypeSpatialUnits> SpatialUnits { get; set; }

        /// <summary>
        /// Array of tags (strings).
        /// </summary>
        /// <value>Array of tags (strings).</value>
        [DataMember(Name="Tags", EmitDefaultValue=false)]
        public List<string> Tags { get; set; }

        /// <summary>
        /// Array of Projects (UID).
        /// </summary>
        /// <value>Array of Projects (UID).</value>
        [DataMember(Name="Projects", EmitDefaultValue=false)]
        public List<ModelsEndpointTypeProjects> Projects { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class AdminSourcesPostRequest {\n");
            sb.Append("  Name: ").Append(Name).Append("\n");
            sb.Append("  Description: ").Append(Description).Append("\n");
            sb.Append("  LongDescription: ").Append(LongDescription).Append("\n");
            sb.Append("  ExtDescriptionURL: ").Append(ExtDescriptionURL).Append("\n");
            sb.Append("  Type: ").Append(Type).Append("\n");
            sb.Append("  ContentItem: ").Append(ContentItem).Append("\n");
            sb.Append("  Concept: ").Append(Concept).Append("\n");
            sb.Append("  SpatialUnits: ").Append(SpatialUnits).Append("\n");
            sb.Append("  Tags: ").Append(Tags).Append("\n");
            sb.Append("  Projects: ").Append(Projects).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as AdminSourcesPostRequest);
        }

        /// <summary>
        /// Returns true if AdminSourcesPostRequest instances are equal
        /// </summary>
        /// <param name="input">Instance of AdminSourcesPostRequest to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(AdminSourcesPostRequest input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Name == input.Name ||
                    (this.Name != null &&
                    this.Name.Equals(input.Name))
                ) && 
                (
                    this.Description == input.Description ||
                    (this.Description != null &&
                    this.Description.Equals(input.Description))
                ) && 
                (
                    this.LongDescription == input.LongDescription ||
                    (this.LongDescription != null &&
                    this.LongDescription.Equals(input.LongDescription))
                ) && 
                (
                    this.ExtDescriptionURL == input.ExtDescriptionURL ||
                    (this.ExtDescriptionURL != null &&
                    this.ExtDescriptionURL.Equals(input.ExtDescriptionURL))
                ) && 
                (
                    this.Type == input.Type ||
                    (this.Type != null &&
                    this.Type.Equals(input.Type))
                ) && 
                (
                    this.ContentItem == input.ContentItem ||
                    (this.ContentItem != null &&
                    this.ContentItem.Equals(input.ContentItem))
                ) && 
                (
                    this.Concept == input.Concept ||
                    (this.Concept != null &&
                    this.Concept.Equals(input.Concept))
                ) && 
                (
                    this.SpatialUnits == input.SpatialUnits ||
                    this.SpatialUnits != null &&
                    this.SpatialUnits.SequenceEqual(input.SpatialUnits)
                ) && 
                (
                    this.Tags == input.Tags ||
                    this.Tags != null &&
                    this.Tags.SequenceEqual(input.Tags)
                ) && 
                (
                    this.Projects == input.Projects ||
                    this.Projects != null &&
                    this.Projects.SequenceEqual(input.Projects)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Name != null)
                    hashCode = hashCode * 59 + this.Name.GetHashCode();
                if (this.Description != null)
                    hashCode = hashCode * 59 + this.Description.GetHashCode();
                if (this.LongDescription != null)
                    hashCode = hashCode * 59 + this.LongDescription.GetHashCode();
                if (this.ExtDescriptionURL != null)
                    hashCode = hashCode * 59 + this.ExtDescriptionURL.GetHashCode();
                if (this.Type != null)
                    hashCode = hashCode * 59 + this.Type.GetHashCode();
                if (this.ContentItem != null)
                    hashCode = hashCode * 59 + this.ContentItem.GetHashCode();
                if (this.Concept != null)
                    hashCode = hashCode * 59 + this.Concept.GetHashCode();
                if (this.SpatialUnits != null)
                    hashCode = hashCode * 59 + this.SpatialUnits.GetHashCode();
                if (this.Tags != null)
                    hashCode = hashCode * 59 + this.Tags.GetHashCode();
                if (this.Projects != null)
                    hashCode = hashCode * 59 + this.Projects.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
