/* 
 * its4land Public API
 *
 * The its4land Public API provides access to the services of the its4land Publish and Share platform.
 *
 * OpenAPI spec version: 0.0.2
 * Contact: contact@its4land.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// ConnectedObjectsEndpointTypeInner
    /// </summary>
    [DataContract]
    public partial class ConnectedObjectsEndpointTypeInner :  IEquatable<ConnectedObjectsEndpointTypeInner>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ConnectedObjectsEndpointTypeInner" /> class.
        /// </summary>
        /// <param name="ProjectUID">UUID of the project.</param>
        /// <param name="TypeOfConnectedObject">Type of the connected object from item2item.</param>
        /// <param name="NameOfConnectedObject">Name of the object, taken from the object table.</param>
        /// <param name="UUIDofConnectObject">UUID of the connected object.</param>
        public ConnectedObjectsEndpointTypeInner(string ProjectUID = default(string), string TypeOfConnectedObject = default(string), string NameOfConnectedObject = default(string), string UUIDofConnectObject = default(string))
        {
            this.ProjectUID = ProjectUID;
            this.TypeOfConnectedObject = TypeOfConnectedObject;
            this.NameOfConnectedObject = NameOfConnectedObject;
            this.UUIDofConnectObject = UUIDofConnectObject;
        }
        
        /// <summary>
        /// UUID of the project
        /// </summary>
        /// <value>UUID of the project</value>
        [DataMember(Name="projectUID", EmitDefaultValue=false)]
        public string ProjectUID { get; set; }

        /// <summary>
        /// Type of the connected object from item2item
        /// </summary>
        /// <value>Type of the connected object from item2item</value>
        [DataMember(Name="TypeOfConnectedObject", EmitDefaultValue=false)]
        public string TypeOfConnectedObject { get; set; }

        /// <summary>
        /// Name of the object, taken from the object table
        /// </summary>
        /// <value>Name of the object, taken from the object table</value>
        [DataMember(Name="NameOfConnectedObject", EmitDefaultValue=false)]
        public string NameOfConnectedObject { get; set; }

        /// <summary>
        /// UUID of the connected object
        /// </summary>
        /// <value>UUID of the connected object</value>
        [DataMember(Name="UUIDofConnectObject", EmitDefaultValue=false)]
        public string UUIDofConnectObject { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ConnectedObjectsEndpointTypeInner {\n");
            sb.Append("  ProjectUID: ").Append(ProjectUID).Append("\n");
            sb.Append("  TypeOfConnectedObject: ").Append(TypeOfConnectedObject).Append("\n");
            sb.Append("  NameOfConnectedObject: ").Append(NameOfConnectedObject).Append("\n");
            sb.Append("  UUIDofConnectObject: ").Append(UUIDofConnectObject).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ConnectedObjectsEndpointTypeInner);
        }

        /// <summary>
        /// Returns true if ConnectedObjectsEndpointTypeInner instances are equal
        /// </summary>
        /// <param name="input">Instance of ConnectedObjectsEndpointTypeInner to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ConnectedObjectsEndpointTypeInner input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.ProjectUID == input.ProjectUID ||
                    (this.ProjectUID != null &&
                    this.ProjectUID.Equals(input.ProjectUID))
                ) && 
                (
                    this.TypeOfConnectedObject == input.TypeOfConnectedObject ||
                    (this.TypeOfConnectedObject != null &&
                    this.TypeOfConnectedObject.Equals(input.TypeOfConnectedObject))
                ) && 
                (
                    this.NameOfConnectedObject == input.NameOfConnectedObject ||
                    (this.NameOfConnectedObject != null &&
                    this.NameOfConnectedObject.Equals(input.NameOfConnectedObject))
                ) && 
                (
                    this.UUIDofConnectObject == input.UUIDofConnectObject ||
                    (this.UUIDofConnectObject != null &&
                    this.UUIDofConnectObject.Equals(input.UUIDofConnectObject))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.ProjectUID != null)
                    hashCode = hashCode * 59 + this.ProjectUID.GetHashCode();
                if (this.TypeOfConnectedObject != null)
                    hashCode = hashCode * 59 + this.TypeOfConnectedObject.GetHashCode();
                if (this.NameOfConnectedObject != null)
                    hashCode = hashCode * 59 + this.NameOfConnectedObject.GetHashCode();
                if (this.UUIDofConnectObject != null)
                    hashCode = hashCode * 59 + this.UUIDofConnectObject.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
