/* 
 * its4land Public API
 *
 * The its4land Public API provides access to the services of the its4land Publish and Share platform.
 *
 * OpenAPI spec version: 0.0.2
 * Contact: contact@its4land.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// ContentItemEndpointType
    /// </summary>
    [DataContract]
    public partial class ContentItemEndpointType :  IEquatable<ContentItemEndpointType>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ContentItemEndpointType" /> class.
        /// </summary>
        /// <param name="ContentID">UID of the ContentItem.</param>
        /// <param name="ContentType">mime/type of the content.</param>
        /// <param name="ContentName">Name of the contentitem. Typically the file name.</param>
        /// <param name="ContentSize">Size of the file in bytes.</param>
        /// <param name="ContentDescription">Free text for description. Only plain text..</param>
        public ContentItemEndpointType(string ContentID = default(string), string ContentType = default(string), string ContentName = default(string), int? ContentSize = default(int?), string ContentDescription = default(string))
        {
            this.ContentID = ContentID;
            this.ContentType = ContentType;
            this.ContentName = ContentName;
            this.ContentSize = ContentSize;
            this.ContentDescription = ContentDescription;
        }
        
        /// <summary>
        /// UID of the ContentItem
        /// </summary>
        /// <value>UID of the ContentItem</value>
        [DataMember(Name="ContentID", EmitDefaultValue=false)]
        public string ContentID { get; set; }

        /// <summary>
        /// mime/type of the content
        /// </summary>
        /// <value>mime/type of the content</value>
        [DataMember(Name="ContentType", EmitDefaultValue=false)]
        public string ContentType { get; set; }

        /// <summary>
        /// Name of the contentitem. Typically the file name
        /// </summary>
        /// <value>Name of the contentitem. Typically the file name</value>
        [DataMember(Name="ContentName", EmitDefaultValue=false)]
        public string ContentName { get; set; }

        /// <summary>
        /// Size of the file in bytes
        /// </summary>
        /// <value>Size of the file in bytes</value>
        [DataMember(Name="ContentSize", EmitDefaultValue=false)]
        public int? ContentSize { get; set; }

        /// <summary>
        /// Free text for description. Only plain text.
        /// </summary>
        /// <value>Free text for description. Only plain text.</value>
        [DataMember(Name="ContentDescription", EmitDefaultValue=false)]
        public string ContentDescription { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ContentItemEndpointType {\n");
            sb.Append("  ContentID: ").Append(ContentID).Append("\n");
            sb.Append("  ContentType: ").Append(ContentType).Append("\n");
            sb.Append("  ContentName: ").Append(ContentName).Append("\n");
            sb.Append("  ContentSize: ").Append(ContentSize).Append("\n");
            sb.Append("  ContentDescription: ").Append(ContentDescription).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ContentItemEndpointType);
        }

        /// <summary>
        /// Returns true if ContentItemEndpointType instances are equal
        /// </summary>
        /// <param name="input">Instance of ContentItemEndpointType to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ContentItemEndpointType input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.ContentID == input.ContentID ||
                    (this.ContentID != null &&
                    this.ContentID.Equals(input.ContentID))
                ) && 
                (
                    this.ContentType == input.ContentType ||
                    (this.ContentType != null &&
                    this.ContentType.Equals(input.ContentType))
                ) && 
                (
                    this.ContentName == input.ContentName ||
                    (this.ContentName != null &&
                    this.ContentName.Equals(input.ContentName))
                ) && 
                (
                    this.ContentSize == input.ContentSize ||
                    (this.ContentSize != null &&
                    this.ContentSize.Equals(input.ContentSize))
                ) && 
                (
                    this.ContentDescription == input.ContentDescription ||
                    (this.ContentDescription != null &&
                    this.ContentDescription.Equals(input.ContentDescription))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.ContentID != null)
                    hashCode = hashCode * 59 + this.ContentID.GetHashCode();
                if (this.ContentType != null)
                    hashCode = hashCode * 59 + this.ContentType.GetHashCode();
                if (this.ContentName != null)
                    hashCode = hashCode * 59 + this.ContentName.GetHashCode();
                if (this.ContentSize != null)
                    hashCode = hashCode * 59 + this.ContentSize.GetHashCode();
                if (this.ContentDescription != null)
                    hashCode = hashCode * 59 + this.ContentDescription.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
