/* 
 * its4land Public API
 *
 * The its4land Public API provides access to the services of the its4land Publish and Share platform.
 *
 * OpenAPI spec version: 0.0.2
 * Contact: contact@its4land.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// ImageSetsEndpointType
    /// </summary>
    [DataContract]
    public partial class ImageSetsEndpointType :  IEquatable<ImageSetsEndpointType>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ImageSetsEndpointType" /> class.
        /// </summary>
        /// <param name="UID">UUID.</param>
        /// <param name="Name">Name of the image. Filename ?.</param>
        /// <param name="Description">Free text for description. Only plain text. Max 255 char..</param>
        /// <param name="LongDescription">Text for description. Can contain html. Max 4000 char..</param>
        /// <param name="ExtDescriptionURL">URL to an external description of the document..</param>
        /// <param name="Metadata">Metadata for the image set. Like, flight date, etc..</param>
        /// <param name="ContentItems">Metadata for the image set. Like, flight date, etc..</param>
        /// <param name="Tags">Array of tags (strings)..</param>
        /// <param name="Projects">Array of Projects (UID)..</param>
        public ImageSetsEndpointType(string UID = default(string), string Name = default(string), string Description = default(string), string LongDescription = default(string), string ExtDescriptionURL = default(string), List<ImageSetsEndpointTypeMetadata> Metadata = default(List<ImageSetsEndpointTypeMetadata>), List<ImageSetsEndpointTypeContentItems> ContentItems = default(List<ImageSetsEndpointTypeContentItems>), List<string> Tags = default(List<string>), List<ModelsEndpointTypeProjects> Projects = default(List<ModelsEndpointTypeProjects>))
        {
            this.UID = UID;
            this.Name = Name;
            this.Description = Description;
            this.LongDescription = LongDescription;
            this.ExtDescriptionURL = ExtDescriptionURL;
            this.Metadata = Metadata;
            this.ContentItems = ContentItems;
            this.Tags = Tags;
            this.Projects = Projects;
        }
        
        /// <summary>
        /// UUID
        /// </summary>
        /// <value>UUID</value>
        [DataMember(Name="UID", EmitDefaultValue=false)]
        public string UID { get; set; }

        /// <summary>
        /// Name of the image. Filename ?
        /// </summary>
        /// <value>Name of the image. Filename ?</value>
        [DataMember(Name="Name", EmitDefaultValue=false)]
        public string Name { get; set; }

        /// <summary>
        /// Free text for description. Only plain text. Max 255 char.
        /// </summary>
        /// <value>Free text for description. Only plain text. Max 255 char.</value>
        [DataMember(Name="Description", EmitDefaultValue=false)]
        public string Description { get; set; }

        /// <summary>
        /// Text for description. Can contain html. Max 4000 char.
        /// </summary>
        /// <value>Text for description. Can contain html. Max 4000 char.</value>
        [DataMember(Name="LongDescription", EmitDefaultValue=false)]
        public string LongDescription { get; set; }

        /// <summary>
        /// URL to an external description of the document.
        /// </summary>
        /// <value>URL to an external description of the document.</value>
        [DataMember(Name="ExtDescriptionURL", EmitDefaultValue=false)]
        public string ExtDescriptionURL { get; set; }

        /// <summary>
        /// Metadata for the image set. Like, flight date, etc.
        /// </summary>
        /// <value>Metadata for the image set. Like, flight date, etc.</value>
        [DataMember(Name="Metadata", EmitDefaultValue=false)]
        public List<ImageSetsEndpointTypeMetadata> Metadata { get; set; }

        /// <summary>
        /// Metadata for the image set. Like, flight date, etc.
        /// </summary>
        /// <value>Metadata for the image set. Like, flight date, etc.</value>
        [DataMember(Name="ContentItems", EmitDefaultValue=false)]
        public List<ImageSetsEndpointTypeContentItems> ContentItems { get; set; }

        /// <summary>
        /// Array of tags (strings).
        /// </summary>
        /// <value>Array of tags (strings).</value>
        [DataMember(Name="Tags", EmitDefaultValue=false)]
        public List<string> Tags { get; set; }

        /// <summary>
        /// Array of Projects (UID).
        /// </summary>
        /// <value>Array of Projects (UID).</value>
        [DataMember(Name="Projects", EmitDefaultValue=false)]
        public List<ModelsEndpointTypeProjects> Projects { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ImageSetsEndpointType {\n");
            sb.Append("  UID: ").Append(UID).Append("\n");
            sb.Append("  Name: ").Append(Name).Append("\n");
            sb.Append("  Description: ").Append(Description).Append("\n");
            sb.Append("  LongDescription: ").Append(LongDescription).Append("\n");
            sb.Append("  ExtDescriptionURL: ").Append(ExtDescriptionURL).Append("\n");
            sb.Append("  Metadata: ").Append(Metadata).Append("\n");
            sb.Append("  ContentItems: ").Append(ContentItems).Append("\n");
            sb.Append("  Tags: ").Append(Tags).Append("\n");
            sb.Append("  Projects: ").Append(Projects).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ImageSetsEndpointType);
        }

        /// <summary>
        /// Returns true if ImageSetsEndpointType instances are equal
        /// </summary>
        /// <param name="input">Instance of ImageSetsEndpointType to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ImageSetsEndpointType input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.UID == input.UID ||
                    (this.UID != null &&
                    this.UID.Equals(input.UID))
                ) && 
                (
                    this.Name == input.Name ||
                    (this.Name != null &&
                    this.Name.Equals(input.Name))
                ) && 
                (
                    this.Description == input.Description ||
                    (this.Description != null &&
                    this.Description.Equals(input.Description))
                ) && 
                (
                    this.LongDescription == input.LongDescription ||
                    (this.LongDescription != null &&
                    this.LongDescription.Equals(input.LongDescription))
                ) && 
                (
                    this.ExtDescriptionURL == input.ExtDescriptionURL ||
                    (this.ExtDescriptionURL != null &&
                    this.ExtDescriptionURL.Equals(input.ExtDescriptionURL))
                ) && 
                (
                    this.Metadata == input.Metadata ||
                    this.Metadata != null &&
                    this.Metadata.SequenceEqual(input.Metadata)
                ) && 
                (
                    this.ContentItems == input.ContentItems ||
                    this.ContentItems != null &&
                    this.ContentItems.SequenceEqual(input.ContentItems)
                ) && 
                (
                    this.Tags == input.Tags ||
                    this.Tags != null &&
                    this.Tags.SequenceEqual(input.Tags)
                ) && 
                (
                    this.Projects == input.Projects ||
                    this.Projects != null &&
                    this.Projects.SequenceEqual(input.Projects)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.UID != null)
                    hashCode = hashCode * 59 + this.UID.GetHashCode();
                if (this.Name != null)
                    hashCode = hashCode * 59 + this.Name.GetHashCode();
                if (this.Description != null)
                    hashCode = hashCode * 59 + this.Description.GetHashCode();
                if (this.LongDescription != null)
                    hashCode = hashCode * 59 + this.LongDescription.GetHashCode();
                if (this.ExtDescriptionURL != null)
                    hashCode = hashCode * 59 + this.ExtDescriptionURL.GetHashCode();
                if (this.Metadata != null)
                    hashCode = hashCode * 59 + this.Metadata.GetHashCode();
                if (this.ContentItems != null)
                    hashCode = hashCode * 59 + this.ContentItems.GetHashCode();
                if (this.Tags != null)
                    hashCode = hashCode * 59 + this.Tags.GetHashCode();
                if (this.Projects != null)
                    hashCode = hashCode * 59 + this.Projects.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
