/* 
 * its4land Public API
 *
 * The its4land Public API provides access to the services of the its4land Publish and Share platform.
 *
 * OpenAPI spec version: 0.0.2
 * Contact: contact@its4land.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// ImageSetsEndpointTypeContentItems
    /// </summary>
    [DataContract]
    public partial class ImageSetsEndpointTypeContentItems :  IEquatable<ImageSetsEndpointTypeContentItems>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ImageSetsEndpointTypeContentItems" /> class.
        /// </summary>
        /// <param name="ContentUID">UUID of a ContentItem.</param>
        /// <param name="Description">Description related to the image set.</param>
        public ImageSetsEndpointTypeContentItems(string ContentUID = default(string), string Description = default(string))
        {
            this.ContentUID = ContentUID;
            this.Description = Description;
        }
        
        /// <summary>
        /// UUID of a ContentItem
        /// </summary>
        /// <value>UUID of a ContentItem</value>
        [DataMember(Name="ContentUID", EmitDefaultValue=false)]
        public string ContentUID { get; set; }

        /// <summary>
        /// Description related to the image set
        /// </summary>
        /// <value>Description related to the image set</value>
        [DataMember(Name="Description", EmitDefaultValue=false)]
        public string Description { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ImageSetsEndpointTypeContentItems {\n");
            sb.Append("  ContentUID: ").Append(ContentUID).Append("\n");
            sb.Append("  Description: ").Append(Description).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ImageSetsEndpointTypeContentItems);
        }

        /// <summary>
        /// Returns true if ImageSetsEndpointTypeContentItems instances are equal
        /// </summary>
        /// <param name="input">Instance of ImageSetsEndpointTypeContentItems to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ImageSetsEndpointTypeContentItems input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.ContentUID == input.ContentUID ||
                    (this.ContentUID != null &&
                    this.ContentUID.Equals(input.ContentUID))
                ) && 
                (
                    this.Description == input.Description ||
                    (this.Description != null &&
                    this.Description.Equals(input.Description))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.ContentUID != null)
                    hashCode = hashCode * 59 + this.ContentUID.GetHashCode();
                if (this.Description != null)
                    hashCode = hashCode * 59 + this.Description.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
