/* 
 * its4land Public API
 *
 * The its4land Public API provides access to the services of the its4land Publish and Share platform.
 *
 * OpenAPI spec version: 0.0.2
 * Contact: contact@its4land.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// Log entry
    /// </summary>
    [DataContract]
    public partial class LogEntryPostRequest :  IEquatable<LogEntryPostRequest>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="LogEntryPostRequest" /> class.
        /// </summary>
        /// <param name="LogSource">Source of the log. Could be either GUI, Tool, ....</param>
        /// <param name="LogLevel">error, info, warning, debug.</param>
        /// <param name="LogMsg">Log message. Free text.</param>
        public LogEntryPostRequest(string LogSource = default(string), string LogLevel = default(string), string LogMsg = default(string))
        {
            this.LogSource = LogSource;
            this.LogLevel = LogLevel;
            this.LogMsg = LogMsg;
        }
        
        /// <summary>
        /// Source of the log. Could be either GUI, Tool, ...
        /// </summary>
        /// <value>Source of the log. Could be either GUI, Tool, ...</value>
        [DataMember(Name="LogSource", EmitDefaultValue=false)]
        public string LogSource { get; set; }

        /// <summary>
        /// error, info, warning, debug
        /// </summary>
        /// <value>error, info, warning, debug</value>
        [DataMember(Name="LogLevel", EmitDefaultValue=false)]
        public string LogLevel { get; set; }

        /// <summary>
        /// Log message. Free text
        /// </summary>
        /// <value>Log message. Free text</value>
        [DataMember(Name="LogMsg", EmitDefaultValue=false)]
        public string LogMsg { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class LogEntryPostRequest {\n");
            sb.Append("  LogSource: ").Append(LogSource).Append("\n");
            sb.Append("  LogLevel: ").Append(LogLevel).Append("\n");
            sb.Append("  LogMsg: ").Append(LogMsg).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as LogEntryPostRequest);
        }

        /// <summary>
        /// Returns true if LogEntryPostRequest instances are equal
        /// </summary>
        /// <param name="input">Instance of LogEntryPostRequest to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(LogEntryPostRequest input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.LogSource == input.LogSource ||
                    (this.LogSource != null &&
                    this.LogSource.Equals(input.LogSource))
                ) && 
                (
                    this.LogLevel == input.LogLevel ||
                    (this.LogLevel != null &&
                    this.LogLevel.Equals(input.LogLevel))
                ) && 
                (
                    this.LogMsg == input.LogMsg ||
                    (this.LogMsg != null &&
                    this.LogMsg.Equals(input.LogMsg))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.LogSource != null)
                    hashCode = hashCode * 59 + this.LogSource.GetHashCode();
                if (this.LogLevel != null)
                    hashCode = hashCode * 59 + this.LogLevel.GetHashCode();
                if (this.LogMsg != null)
                    hashCode = hashCode * 59 + this.LogMsg.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
