/* 
 * its4land Public API
 *
 * The its4land Public API provides access to the services of the its4land Publish and Share platform.
 *
 * OpenAPI spec version: 0.0.2
 * Contact: contact@its4land.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// ProcessEndpointType
    /// </summary>
    [DataContract]
    public partial class ProcessEndpointType :  IEquatable<ProcessEndpointType>, IValidatableObject
    {
        /// <summary>
        /// Status of the project. Can be one of:   * WAITING: Process is queued for execution   * RUNNING: Process is currently executing   * FINISHED: Process terminated normally   * ABORTED: Process terminated unexpectedly   * ZOMBIE: Process is listed in the platform process table, but the internal (process) API has no information about it. Possible in case of historical/archived processes or due to platform error. 
        /// </summary>
        /// <value>Status of the project. Can be one of:   * WAITING: Process is queued for execution   * RUNNING: Process is currently executing   * FINISHED: Process terminated normally   * ABORTED: Process terminated unexpectedly   * ZOMBIE: Process is listed in the platform process table, but the internal (process) API has no information about it. Possible in case of historical/archived processes or due to platform error. </value>
        [JsonConverter(typeof(StringEnumConverter))]
        public enum StatusEnum
        {
            
            /// <summary>
            /// Enum WAITING for value: WAITING
            /// </summary>
            [EnumMember(Value = "WAITING")]
            WAITING = 1,
            
            /// <summary>
            /// Enum RUNNING for value: RUNNING
            /// </summary>
            [EnumMember(Value = "RUNNING")]
            RUNNING = 2,
            
            /// <summary>
            /// Enum FINISHED for value: FINISHED
            /// </summary>
            [EnumMember(Value = "FINISHED")]
            FINISHED = 3,
            
            /// <summary>
            /// Enum ABORTED for value: ABORTED
            /// </summary>
            [EnumMember(Value = "ABORTED")]
            ABORTED = 4,
            
            /// <summary>
            /// Enum ZOMBIE for value: ZOMBIE
            /// </summary>
            [EnumMember(Value = "ZOMBIE")]
            ZOMBIE = 5
        }

        /// <summary>
        /// Status of the project. Can be one of:   * WAITING: Process is queued for execution   * RUNNING: Process is currently executing   * FINISHED: Process terminated normally   * ABORTED: Process terminated unexpectedly   * ZOMBIE: Process is listed in the platform process table, but the internal (process) API has no information about it. Possible in case of historical/archived processes or due to platform error. 
        /// </summary>
        /// <value>Status of the project. Can be one of:   * WAITING: Process is queued for execution   * RUNNING: Process is currently executing   * FINISHED: Process terminated normally   * ABORTED: Process terminated unexpectedly   * ZOMBIE: Process is listed in the platform process table, but the internal (process) API has no information about it. Possible in case of historical/archived processes or due to platform error. </value>
        [DataMember(Name="Status", EmitDefaultValue=false)]
        public StatusEnum? Status { get; set; }
        /// <summary>
        /// Initializes a new instance of the <see cref="ProcessEndpointType" /> class.
        /// </summary>
        /// <param name="UID">UID of the process.</param>
        /// <param name="Project">Project.</param>
        /// <param name="Status">Status of the project. Can be one of:   * WAITING: Process is queued for execution   * RUNNING: Process is currently executing   * FINISHED: Process terminated normally   * ABORTED: Process terminated unexpectedly   * ZOMBIE: Process is listed in the platform process table, but the internal (process) API has no information about it. Possible in case of historical/archived processes or due to platform error. .</param>
        /// <param name="CreatedAt">Creation date.</param>
        /// <param name="CreatedBy">User name of the creator.</param>
        /// <param name="LastModifiedAt">Last modification date.</param>
        /// <param name="LastModifiedBy">User name of the last modifier.</param>
        /// <param name="Tool">Tool.</param>
        /// <param name="Logs">Logs from the process.</param>
        /// <param name="Results">Results from the process.</param>
        public ProcessEndpointType(string UID = default(string), ProcessEndpointTypeProject Project = default(ProcessEndpointTypeProject), StatusEnum? Status = default(StatusEnum?), DateTime? CreatedAt = default(DateTime?), string CreatedBy = default(string), DateTime? LastModifiedAt = default(DateTime?), string LastModifiedBy = default(string), ProcessEndpointTypeTool Tool = default(ProcessEndpointTypeTool), string Logs = default(string), List<ProcessEndpointTypeResults> Results = default(List<ProcessEndpointTypeResults>))
        {
            this.UID = UID;
            this.Project = Project;
            this.Status = Status;
            this.CreatedAt = CreatedAt;
            this.CreatedBy = CreatedBy;
            this.LastModifiedAt = LastModifiedAt;
            this.LastModifiedBy = LastModifiedBy;
            this.Tool = Tool;
            this.Logs = Logs;
            this.Results = Results;
        }
        
        /// <summary>
        /// UID of the process
        /// </summary>
        /// <value>UID of the process</value>
        [DataMember(Name="UID", EmitDefaultValue=false)]
        public string UID { get; set; }

        /// <summary>
        /// Gets or Sets Project
        /// </summary>
        [DataMember(Name="Project", EmitDefaultValue=false)]
        public ProcessEndpointTypeProject Project { get; set; }


        /// <summary>
        /// Creation date
        /// </summary>
        /// <value>Creation date</value>
        [DataMember(Name="CreatedAt", EmitDefaultValue=false)]
        [JsonConverter(typeof(SwaggerDateConverter))]
        public DateTime? CreatedAt { get; set; }

        /// <summary>
        /// User name of the creator
        /// </summary>
        /// <value>User name of the creator</value>
        [DataMember(Name="CreatedBy", EmitDefaultValue=false)]
        public string CreatedBy { get; set; }

        /// <summary>
        /// Last modification date
        /// </summary>
        /// <value>Last modification date</value>
        [DataMember(Name="LastModifiedAt", EmitDefaultValue=false)]
        [JsonConverter(typeof(SwaggerDateConverter))]
        public DateTime? LastModifiedAt { get; set; }

        /// <summary>
        /// User name of the last modifier
        /// </summary>
        /// <value>User name of the last modifier</value>
        [DataMember(Name="LastModifiedBy", EmitDefaultValue=false)]
        public string LastModifiedBy { get; set; }

        /// <summary>
        /// Gets or Sets Tool
        /// </summary>
        [DataMember(Name="Tool", EmitDefaultValue=false)]
        public ProcessEndpointTypeTool Tool { get; set; }

        /// <summary>
        /// Logs from the process
        /// </summary>
        /// <value>Logs from the process</value>
        [DataMember(Name="Logs", EmitDefaultValue=false)]
        public string Logs { get; set; }

        /// <summary>
        /// Results from the process
        /// </summary>
        /// <value>Results from the process</value>
        [DataMember(Name="Results", EmitDefaultValue=false)]
        public List<ProcessEndpointTypeResults> Results { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ProcessEndpointType {\n");
            sb.Append("  UID: ").Append(UID).Append("\n");
            sb.Append("  Project: ").Append(Project).Append("\n");
            sb.Append("  Status: ").Append(Status).Append("\n");
            sb.Append("  CreatedAt: ").Append(CreatedAt).Append("\n");
            sb.Append("  CreatedBy: ").Append(CreatedBy).Append("\n");
            sb.Append("  LastModifiedAt: ").Append(LastModifiedAt).Append("\n");
            sb.Append("  LastModifiedBy: ").Append(LastModifiedBy).Append("\n");
            sb.Append("  Tool: ").Append(Tool).Append("\n");
            sb.Append("  Logs: ").Append(Logs).Append("\n");
            sb.Append("  Results: ").Append(Results).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ProcessEndpointType);
        }

        /// <summary>
        /// Returns true if ProcessEndpointType instances are equal
        /// </summary>
        /// <param name="input">Instance of ProcessEndpointType to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ProcessEndpointType input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.UID == input.UID ||
                    (this.UID != null &&
                    this.UID.Equals(input.UID))
                ) && 
                (
                    this.Project == input.Project ||
                    (this.Project != null &&
                    this.Project.Equals(input.Project))
                ) && 
                (
                    this.Status == input.Status ||
                    (this.Status != null &&
                    this.Status.Equals(input.Status))
                ) && 
                (
                    this.CreatedAt == input.CreatedAt ||
                    (this.CreatedAt != null &&
                    this.CreatedAt.Equals(input.CreatedAt))
                ) && 
                (
                    this.CreatedBy == input.CreatedBy ||
                    (this.CreatedBy != null &&
                    this.CreatedBy.Equals(input.CreatedBy))
                ) && 
                (
                    this.LastModifiedAt == input.LastModifiedAt ||
                    (this.LastModifiedAt != null &&
                    this.LastModifiedAt.Equals(input.LastModifiedAt))
                ) && 
                (
                    this.LastModifiedBy == input.LastModifiedBy ||
                    (this.LastModifiedBy != null &&
                    this.LastModifiedBy.Equals(input.LastModifiedBy))
                ) && 
                (
                    this.Tool == input.Tool ||
                    (this.Tool != null &&
                    this.Tool.Equals(input.Tool))
                ) && 
                (
                    this.Logs == input.Logs ||
                    (this.Logs != null &&
                    this.Logs.Equals(input.Logs))
                ) && 
                (
                    this.Results == input.Results ||
                    this.Results != null &&
                    this.Results.SequenceEqual(input.Results)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.UID != null)
                    hashCode = hashCode * 59 + this.UID.GetHashCode();
                if (this.Project != null)
                    hashCode = hashCode * 59 + this.Project.GetHashCode();
                if (this.Status != null)
                    hashCode = hashCode * 59 + this.Status.GetHashCode();
                if (this.CreatedAt != null)
                    hashCode = hashCode * 59 + this.CreatedAt.GetHashCode();
                if (this.CreatedBy != null)
                    hashCode = hashCode * 59 + this.CreatedBy.GetHashCode();
                if (this.LastModifiedAt != null)
                    hashCode = hashCode * 59 + this.LastModifiedAt.GetHashCode();
                if (this.LastModifiedBy != null)
                    hashCode = hashCode * 59 + this.LastModifiedBy.GetHashCode();
                if (this.Tool != null)
                    hashCode = hashCode * 59 + this.Tool.GetHashCode();
                if (this.Logs != null)
                    hashCode = hashCode * 59 + this.Logs.GetHashCode();
                if (this.Results != null)
                    hashCode = hashCode * 59 + this.Results.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
