/* 
 * its4land Public API
 *
 * The its4land Public API provides access to the services of the its4land Publish and Share platform.
 *
 * OpenAPI spec version: 0.0.2
 * Contact: contact@its4land.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// Information about the tool executed by the process
    /// </summary>
    [DataContract]
    public partial class ProcessEndpointTypeTool :  IEquatable<ProcessEndpointTypeTool>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ProcessEndpointTypeTool" /> class.
        /// </summary>
        /// <param name="ToolName">Name of the tool.</param>
        /// <param name="Version">Version of the tool.</param>
        /// <param name="EntryPoint">EntryPoint.</param>
        public ProcessEndpointTypeTool(string ToolName = default(string), string Version = default(string), ProcessEndpointTypeToolEntryPoint EntryPoint = default(ProcessEndpointTypeToolEntryPoint))
        {
            this.ToolName = ToolName;
            this.Version = Version;
            this.EntryPoint = EntryPoint;
        }
        
        /// <summary>
        /// Name of the tool
        /// </summary>
        /// <value>Name of the tool</value>
        [DataMember(Name="ToolName", EmitDefaultValue=false)]
        public string ToolName { get; set; }

        /// <summary>
        /// Version of the tool
        /// </summary>
        /// <value>Version of the tool</value>
        [DataMember(Name="Version", EmitDefaultValue=false)]
        public string Version { get; set; }

        /// <summary>
        /// Gets or Sets EntryPoint
        /// </summary>
        [DataMember(Name="EntryPoint", EmitDefaultValue=false)]
        public ProcessEndpointTypeToolEntryPoint EntryPoint { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ProcessEndpointTypeTool {\n");
            sb.Append("  ToolName: ").Append(ToolName).Append("\n");
            sb.Append("  Version: ").Append(Version).Append("\n");
            sb.Append("  EntryPoint: ").Append(EntryPoint).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ProcessEndpointTypeTool);
        }

        /// <summary>
        /// Returns true if ProcessEndpointTypeTool instances are equal
        /// </summary>
        /// <param name="input">Instance of ProcessEndpointTypeTool to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ProcessEndpointTypeTool input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.ToolName == input.ToolName ||
                    (this.ToolName != null &&
                    this.ToolName.Equals(input.ToolName))
                ) && 
                (
                    this.Version == input.Version ||
                    (this.Version != null &&
                    this.Version.Equals(input.Version))
                ) && 
                (
                    this.EntryPoint == input.EntryPoint ||
                    (this.EntryPoint != null &&
                    this.EntryPoint.Equals(input.EntryPoint))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.ToolName != null)
                    hashCode = hashCode * 59 + this.ToolName.GetHashCode();
                if (this.Version != null)
                    hashCode = hashCode * 59 + this.Version.GetHashCode();
                if (this.EntryPoint != null)
                    hashCode = hashCode * 59 + this.EntryPoint.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
