/* 
 * its4land Public API
 *
 * The its4land Public API provides access to the services of the its4land Publish and Share platform.
 *
 * OpenAPI spec version: 0.0.2
 * Contact: contact@its4land.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// Entry point used in the process
    /// </summary>
    [DataContract]
    public partial class ProcessEndpointTypeToolEntryPoint :  IEquatable<ProcessEndpointTypeToolEntryPoint>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ProcessEndpointTypeToolEntryPoint" /> class.
        /// </summary>
        /// <param name="EntryPointName">Name of the entry point.</param>
        /// <param name="_Parameter">Parameters used in the process.</param>
        public ProcessEndpointTypeToolEntryPoint(string EntryPointName = default(string), List<ProcessEndpointTypeToolEntryPointParameter> _Parameter = default(List<ProcessEndpointTypeToolEntryPointParameter>))
        {
            this.EntryPointName = EntryPointName;
            this._Parameter = _Parameter;
        }
        
        /// <summary>
        /// Name of the entry point
        /// </summary>
        /// <value>Name of the entry point</value>
        [DataMember(Name="EntryPointName", EmitDefaultValue=false)]
        public string EntryPointName { get; set; }

        /// <summary>
        /// Parameters used in the process
        /// </summary>
        /// <value>Parameters used in the process</value>
        [DataMember(Name="Parameter", EmitDefaultValue=false)]
        public List<ProcessEndpointTypeToolEntryPointParameter> _Parameter { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ProcessEndpointTypeToolEntryPoint {\n");
            sb.Append("  EntryPointName: ").Append(EntryPointName).Append("\n");
            sb.Append("  _Parameter: ").Append(_Parameter).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ProcessEndpointTypeToolEntryPoint);
        }

        /// <summary>
        /// Returns true if ProcessEndpointTypeToolEntryPoint instances are equal
        /// </summary>
        /// <param name="input">Instance of ProcessEndpointTypeToolEntryPoint to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ProcessEndpointTypeToolEntryPoint input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.EntryPointName == input.EntryPointName ||
                    (this.EntryPointName != null &&
                    this.EntryPointName.Equals(input.EntryPointName))
                ) && 
                (
                    this._Parameter == input._Parameter ||
                    this._Parameter != null &&
                    this._Parameter.SequenceEqual(input._Parameter)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.EntryPointName != null)
                    hashCode = hashCode * 59 + this.EntryPointName.GetHashCode();
                if (this._Parameter != null)
                    hashCode = hashCode * 59 + this._Parameter.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
