/* 
 * its4land Public API
 *
 * The its4land Public API provides access to the services of the its4land Publish and Share platform.
 *
 * OpenAPI spec version: 0.0.2
 * Contact: contact@its4land.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// ProjectsEndpointType2
    /// </summary>
    [DataContract]
    public partial class ProjectsEndpointType2 :  IEquatable<ProjectsEndpointType2>, IValidatableObject
    {
        /// <summary>
        /// GeoJson feature collection
        /// </summary>
        /// <value>GeoJson feature collection</value>
        [JsonConverter(typeof(StringEnumConverter))]
        public enum TypeEnum
        {
            
            /// <summary>
            /// Enum FeatureCollection for value: FeatureCollection
            /// </summary>
            [EnumMember(Value = "FeatureCollection")]
            FeatureCollection = 1
        }

        /// <summary>
        /// GeoJson feature collection
        /// </summary>
        /// <value>GeoJson feature collection</value>
        [DataMember(Name="type", EmitDefaultValue=false)]
        public TypeEnum? Type { get; set; }
        /// <summary>
        /// Name of the feature collection. Always i4lProject
        /// </summary>
        /// <value>Name of the feature collection. Always i4lProject</value>
        [JsonConverter(typeof(StringEnumConverter))]
        public enum NameEnum
        {
            
            /// <summary>
            /// Enum I4lProject for value: i4lProject
            /// </summary>
            [EnumMember(Value = "i4lProject")]
            I4lProject = 1
        }

        /// <summary>
        /// Name of the feature collection. Always i4lProject
        /// </summary>
        /// <value>Name of the feature collection. Always i4lProject</value>
        [DataMember(Name="name", EmitDefaultValue=false)]
        public NameEnum? Name { get; set; }
        /// <summary>
        /// Initializes a new instance of the <see cref="ProjectsEndpointType2" /> class.
        /// </summary>
        /// <param name="Type">GeoJson feature collection.</param>
        /// <param name="Name">Name of the feature collection. Always i4lProject.</param>
        /// <param name="Crs">Crs.</param>
        /// <param name="Features">Features.</param>
        public ProjectsEndpointType2(TypeEnum? Type = default(TypeEnum?), NameEnum? Name = default(NameEnum?), ProjectsEndpointTypeCrs Crs = default(ProjectsEndpointTypeCrs), List<ProjectsEndpointType2Features> Features = default(List<ProjectsEndpointType2Features>))
        {
            this.Type = Type;
            this.Name = Name;
            this.Crs = Crs;
            this.Features = Features;
        }
        


        /// <summary>
        /// Gets or Sets Crs
        /// </summary>
        [DataMember(Name="crs", EmitDefaultValue=false)]
        public ProjectsEndpointTypeCrs Crs { get; set; }

        /// <summary>
        /// Gets or Sets Features
        /// </summary>
        [DataMember(Name="features", EmitDefaultValue=false)]
        public List<ProjectsEndpointType2Features> Features { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ProjectsEndpointType2 {\n");
            sb.Append("  Type: ").Append(Type).Append("\n");
            sb.Append("  Name: ").Append(Name).Append("\n");
            sb.Append("  Crs: ").Append(Crs).Append("\n");
            sb.Append("  Features: ").Append(Features).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ProjectsEndpointType2);
        }

        /// <summary>
        /// Returns true if ProjectsEndpointType2 instances are equal
        /// </summary>
        /// <param name="input">Instance of ProjectsEndpointType2 to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ProjectsEndpointType2 input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Type == input.Type ||
                    (this.Type != null &&
                    this.Type.Equals(input.Type))
                ) && 
                (
                    this.Name == input.Name ||
                    (this.Name != null &&
                    this.Name.Equals(input.Name))
                ) && 
                (
                    this.Crs == input.Crs ||
                    (this.Crs != null &&
                    this.Crs.Equals(input.Crs))
                ) && 
                (
                    this.Features == input.Features ||
                    this.Features != null &&
                    this.Features.SequenceEqual(input.Features)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Type != null)
                    hashCode = hashCode * 59 + this.Type.GetHashCode();
                if (this.Name != null)
                    hashCode = hashCode * 59 + this.Name.GetHashCode();
                if (this.Crs != null)
                    hashCode = hashCode * 59 + this.Crs.GetHashCode();
                if (this.Features != null)
                    hashCode = hashCode * 59 + this.Features.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
