/* 
 * its4land Public API
 *
 * The its4land Public API provides access to the services of the its4land Publish and Share platform.
 *
 * OpenAPI spec version: 0.0.2
 * Contact: contact@its4land.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// ProjectsPostRequestProperties
    /// </summary>
    [DataContract]
    public partial class ProjectsPostRequestProperties :  IEquatable<ProjectsPostRequestProperties>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ProjectsPostRequestProperties" /> class.
        /// </summary>
        /// <param name="Name">Freely chosen name.</param>
        /// <param name="Description">Free text for description. Only plain text..</param>
        /// <param name="LongDescription">Text for description. Can contain html. Max 4000 char..</param>
        /// <param name="ExtDescriptionURL">URL to an external description of the document..</param>
        /// <param name="ProjectDir">URI to a directory resource. Not clear if needed..</param>
        /// <param name="Models">Array of models (UID)..</param>
        /// <param name="SpatialSources">Array of SpatialSources (UID)..</param>
        /// <param name="Tags">Array of tags (strings)..</param>
        public ProjectsPostRequestProperties(string Name = default(string), string Description = default(string), string LongDescription = default(string), string ExtDescriptionURL = default(string), string ProjectDir = default(string), List<ProjectsEndpointTypePropertiesModels> Models = default(List<ProjectsEndpointTypePropertiesModels>), List<ProjectsPostRequestPropertiesSpatialSources> SpatialSources = default(List<ProjectsPostRequestPropertiesSpatialSources>), List<string> Tags = default(List<string>))
        {
            this.Name = Name;
            this.Description = Description;
            this.LongDescription = LongDescription;
            this.ExtDescriptionURL = ExtDescriptionURL;
            this.ProjectDir = ProjectDir;
            this.Models = Models;
            this.SpatialSources = SpatialSources;
            this.Tags = Tags;
        }
        
        /// <summary>
        /// Freely chosen name
        /// </summary>
        /// <value>Freely chosen name</value>
        [DataMember(Name="Name", EmitDefaultValue=false)]
        public string Name { get; set; }

        /// <summary>
        /// Free text for description. Only plain text.
        /// </summary>
        /// <value>Free text for description. Only plain text.</value>
        [DataMember(Name="Description", EmitDefaultValue=false)]
        public string Description { get; set; }

        /// <summary>
        /// Text for description. Can contain html. Max 4000 char.
        /// </summary>
        /// <value>Text for description. Can contain html. Max 4000 char.</value>
        [DataMember(Name="LongDescription", EmitDefaultValue=false)]
        public string LongDescription { get; set; }

        /// <summary>
        /// URL to an external description of the document.
        /// </summary>
        /// <value>URL to an external description of the document.</value>
        [DataMember(Name="ExtDescriptionURL", EmitDefaultValue=false)]
        public string ExtDescriptionURL { get; set; }

        /// <summary>
        /// URI to a directory resource. Not clear if needed.
        /// </summary>
        /// <value>URI to a directory resource. Not clear if needed.</value>
        [DataMember(Name="ProjectDir", EmitDefaultValue=false)]
        public string ProjectDir { get; set; }

        /// <summary>
        /// Array of models (UID).
        /// </summary>
        /// <value>Array of models (UID).</value>
        [DataMember(Name="Models", EmitDefaultValue=false)]
        public List<ProjectsEndpointTypePropertiesModels> Models { get; set; }

        /// <summary>
        /// Array of SpatialSources (UID).
        /// </summary>
        /// <value>Array of SpatialSources (UID).</value>
        [DataMember(Name="SpatialSources", EmitDefaultValue=false)]
        public List<ProjectsPostRequestPropertiesSpatialSources> SpatialSources { get; set; }

        /// <summary>
        /// Array of tags (strings).
        /// </summary>
        /// <value>Array of tags (strings).</value>
        [DataMember(Name="Tags", EmitDefaultValue=false)]
        public List<string> Tags { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ProjectsPostRequestProperties {\n");
            sb.Append("  Name: ").Append(Name).Append("\n");
            sb.Append("  Description: ").Append(Description).Append("\n");
            sb.Append("  LongDescription: ").Append(LongDescription).Append("\n");
            sb.Append("  ExtDescriptionURL: ").Append(ExtDescriptionURL).Append("\n");
            sb.Append("  ProjectDir: ").Append(ProjectDir).Append("\n");
            sb.Append("  Models: ").Append(Models).Append("\n");
            sb.Append("  SpatialSources: ").Append(SpatialSources).Append("\n");
            sb.Append("  Tags: ").Append(Tags).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ProjectsPostRequestProperties);
        }

        /// <summary>
        /// Returns true if ProjectsPostRequestProperties instances are equal
        /// </summary>
        /// <param name="input">Instance of ProjectsPostRequestProperties to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ProjectsPostRequestProperties input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Name == input.Name ||
                    (this.Name != null &&
                    this.Name.Equals(input.Name))
                ) && 
                (
                    this.Description == input.Description ||
                    (this.Description != null &&
                    this.Description.Equals(input.Description))
                ) && 
                (
                    this.LongDescription == input.LongDescription ||
                    (this.LongDescription != null &&
                    this.LongDescription.Equals(input.LongDescription))
                ) && 
                (
                    this.ExtDescriptionURL == input.ExtDescriptionURL ||
                    (this.ExtDescriptionURL != null &&
                    this.ExtDescriptionURL.Equals(input.ExtDescriptionURL))
                ) && 
                (
                    this.ProjectDir == input.ProjectDir ||
                    (this.ProjectDir != null &&
                    this.ProjectDir.Equals(input.ProjectDir))
                ) && 
                (
                    this.Models == input.Models ||
                    this.Models != null &&
                    this.Models.SequenceEqual(input.Models)
                ) && 
                (
                    this.SpatialSources == input.SpatialSources ||
                    this.SpatialSources != null &&
                    this.SpatialSources.SequenceEqual(input.SpatialSources)
                ) && 
                (
                    this.Tags == input.Tags ||
                    this.Tags != null &&
                    this.Tags.SequenceEqual(input.Tags)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Name != null)
                    hashCode = hashCode * 59 + this.Name.GetHashCode();
                if (this.Description != null)
                    hashCode = hashCode * 59 + this.Description.GetHashCode();
                if (this.LongDescription != null)
                    hashCode = hashCode * 59 + this.LongDescription.GetHashCode();
                if (this.ExtDescriptionURL != null)
                    hashCode = hashCode * 59 + this.ExtDescriptionURL.GetHashCode();
                if (this.ProjectDir != null)
                    hashCode = hashCode * 59 + this.ProjectDir.GetHashCode();
                if (this.Models != null)
                    hashCode = hashCode * 59 + this.Models.GetHashCode();
                if (this.SpatialSources != null)
                    hashCode = hashCode * 59 + this.SpatialSources.GetHashCode();
                if (this.Tags != null)
                    hashCode = hashCode * 59 + this.Tags.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
