/* 
 * its4land Public API
 *
 * The its4land Public API provides access to the services of the its4land Publish and Share platform.
 *
 * OpenAPI spec version: 0.0.2
 * Contact: contact@its4land.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// SpatialUnitsFeatureEndpointTypeProperties
    /// </summary>
    [DataContract]
    public partial class SpatialUnitsFeatureEndpointTypeProperties :  IEquatable<SpatialUnitsFeatureEndpointTypeProperties>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="SpatialUnitsFeatureEndpointTypeProperties" /> class.
        /// </summary>
        /// <param name="UID">UUID.</param>
        /// <param name="Name">Name of the Spatial Unit.</param>
        /// <param name="Description">Free text for description. Only plain text. Max 255 char..</param>
        /// <param name="LongDescription">Text for description. Can contain html. Max 4000 char..</param>
        /// <param name="ExtDescriptionURL">URL to an external description of the document..</param>
        /// <param name="Concept">According to the ontology based on LADM.</param>
        /// <param name="Level">Level according to LADM.</param>
        /// <param name="AdminSource">Related Admin Source Documents.</param>
        /// <param name="Projects">Related Projects.</param>
        public SpatialUnitsFeatureEndpointTypeProperties(string UID = default(string), string Name = default(string), string Description = default(string), string LongDescription = default(string), string ExtDescriptionURL = default(string), string Concept = default(string), string Level = default(string), List<SpatialUnitsFeatureEndpointTypePropertiesAdminSource> AdminSource = default(List<SpatialUnitsFeatureEndpointTypePropertiesAdminSource>), List<SpatialUnitsFeatureEndpointTypePropertiesProjects> Projects = default(List<SpatialUnitsFeatureEndpointTypePropertiesProjects>))
        {
            this.UID = UID;
            this.Name = Name;
            this.Description = Description;
            this.LongDescription = LongDescription;
            this.ExtDescriptionURL = ExtDescriptionURL;
            this.Concept = Concept;
            this.Level = Level;
            this.AdminSource = AdminSource;
            this.Projects = Projects;
        }
        
        /// <summary>
        /// UUID
        /// </summary>
        /// <value>UUID</value>
        [DataMember(Name="UID", EmitDefaultValue=false)]
        public string UID { get; set; }

        /// <summary>
        /// Name of the Spatial Unit
        /// </summary>
        /// <value>Name of the Spatial Unit</value>
        [DataMember(Name="Name", EmitDefaultValue=false)]
        public string Name { get; set; }

        /// <summary>
        /// Free text for description. Only plain text. Max 255 char.
        /// </summary>
        /// <value>Free text for description. Only plain text. Max 255 char.</value>
        [DataMember(Name="Description", EmitDefaultValue=false)]
        public string Description { get; set; }

        /// <summary>
        /// Text for description. Can contain html. Max 4000 char.
        /// </summary>
        /// <value>Text for description. Can contain html. Max 4000 char.</value>
        [DataMember(Name="LongDescription", EmitDefaultValue=false)]
        public string LongDescription { get; set; }

        /// <summary>
        /// URL to an external description of the document.
        /// </summary>
        /// <value>URL to an external description of the document.</value>
        [DataMember(Name="ExtDescriptionURL", EmitDefaultValue=false)]
        public string ExtDescriptionURL { get; set; }

        /// <summary>
        /// According to the ontology based on LADM
        /// </summary>
        /// <value>According to the ontology based on LADM</value>
        [DataMember(Name="Concept", EmitDefaultValue=false)]
        public string Concept { get; set; }

        /// <summary>
        /// Level according to LADM
        /// </summary>
        /// <value>Level according to LADM</value>
        [DataMember(Name="Level", EmitDefaultValue=false)]
        public string Level { get; set; }

        /// <summary>
        /// Related Admin Source Documents
        /// </summary>
        /// <value>Related Admin Source Documents</value>
        [DataMember(Name="AdminSource", EmitDefaultValue=false)]
        public List<SpatialUnitsFeatureEndpointTypePropertiesAdminSource> AdminSource { get; set; }

        /// <summary>
        /// Related Projects
        /// </summary>
        /// <value>Related Projects</value>
        [DataMember(Name="Projects", EmitDefaultValue=false)]
        public List<SpatialUnitsFeatureEndpointTypePropertiesProjects> Projects { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class SpatialUnitsFeatureEndpointTypeProperties {\n");
            sb.Append("  UID: ").Append(UID).Append("\n");
            sb.Append("  Name: ").Append(Name).Append("\n");
            sb.Append("  Description: ").Append(Description).Append("\n");
            sb.Append("  LongDescription: ").Append(LongDescription).Append("\n");
            sb.Append("  ExtDescriptionURL: ").Append(ExtDescriptionURL).Append("\n");
            sb.Append("  Concept: ").Append(Concept).Append("\n");
            sb.Append("  Level: ").Append(Level).Append("\n");
            sb.Append("  AdminSource: ").Append(AdminSource).Append("\n");
            sb.Append("  Projects: ").Append(Projects).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as SpatialUnitsFeatureEndpointTypeProperties);
        }

        /// <summary>
        /// Returns true if SpatialUnitsFeatureEndpointTypeProperties instances are equal
        /// </summary>
        /// <param name="input">Instance of SpatialUnitsFeatureEndpointTypeProperties to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(SpatialUnitsFeatureEndpointTypeProperties input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.UID == input.UID ||
                    (this.UID != null &&
                    this.UID.Equals(input.UID))
                ) && 
                (
                    this.Name == input.Name ||
                    (this.Name != null &&
                    this.Name.Equals(input.Name))
                ) && 
                (
                    this.Description == input.Description ||
                    (this.Description != null &&
                    this.Description.Equals(input.Description))
                ) && 
                (
                    this.LongDescription == input.LongDescription ||
                    (this.LongDescription != null &&
                    this.LongDescription.Equals(input.LongDescription))
                ) && 
                (
                    this.ExtDescriptionURL == input.ExtDescriptionURL ||
                    (this.ExtDescriptionURL != null &&
                    this.ExtDescriptionURL.Equals(input.ExtDescriptionURL))
                ) && 
                (
                    this.Concept == input.Concept ||
                    (this.Concept != null &&
                    this.Concept.Equals(input.Concept))
                ) && 
                (
                    this.Level == input.Level ||
                    (this.Level != null &&
                    this.Level.Equals(input.Level))
                ) && 
                (
                    this.AdminSource == input.AdminSource ||
                    this.AdminSource != null &&
                    this.AdminSource.SequenceEqual(input.AdminSource)
                ) && 
                (
                    this.Projects == input.Projects ||
                    this.Projects != null &&
                    this.Projects.SequenceEqual(input.Projects)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.UID != null)
                    hashCode = hashCode * 59 + this.UID.GetHashCode();
                if (this.Name != null)
                    hashCode = hashCode * 59 + this.Name.GetHashCode();
                if (this.Description != null)
                    hashCode = hashCode * 59 + this.Description.GetHashCode();
                if (this.LongDescription != null)
                    hashCode = hashCode * 59 + this.LongDescription.GetHashCode();
                if (this.ExtDescriptionURL != null)
                    hashCode = hashCode * 59 + this.ExtDescriptionURL.GetHashCode();
                if (this.Concept != null)
                    hashCode = hashCode * 59 + this.Concept.GetHashCode();
                if (this.Level != null)
                    hashCode = hashCode * 59 + this.Level.GetHashCode();
                if (this.AdminSource != null)
                    hashCode = hashCode * 59 + this.AdminSource.GetHashCode();
                if (this.Projects != null)
                    hashCode = hashCode * 59 + this.Projects.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
