/* 
 * its4land Public API
 *
 * The its4land Public API provides access to the services of the its4land Publish and Share platform.
 *
 * OpenAPI spec version: 0.0.2
 * Contact: contact@its4land.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// TagsEndpointTypeTaggedObjects
    /// </summary>
    [DataContract]
    public partial class TagsEndpointTypeTaggedObjects :  IEquatable<TagsEndpointTypeTaggedObjects>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="TagsEndpointTypeTaggedObjects" /> class.
        /// </summary>
        /// <param name="ObjectType">Project, Model, TrainingSet, etc..</param>
        /// <param name="ObjectUUID">UUID of the object.</param>
        /// <param name="Name">Name of the object.</param>
        /// <param name="Description">Description of the object..</param>
        public TagsEndpointTypeTaggedObjects(string ObjectType = default(string), string ObjectUUID = default(string), string Name = default(string), string Description = default(string))
        {
            this.ObjectType = ObjectType;
            this.ObjectUUID = ObjectUUID;
            this.Name = Name;
            this.Description = Description;
        }
        
        /// <summary>
        /// Project, Model, TrainingSet, etc.
        /// </summary>
        /// <value>Project, Model, TrainingSet, etc.</value>
        [DataMember(Name="ObjectType", EmitDefaultValue=false)]
        public string ObjectType { get; set; }

        /// <summary>
        /// UUID of the object
        /// </summary>
        /// <value>UUID of the object</value>
        [DataMember(Name="ObjectUUID", EmitDefaultValue=false)]
        public string ObjectUUID { get; set; }

        /// <summary>
        /// Name of the object
        /// </summary>
        /// <value>Name of the object</value>
        [DataMember(Name="Name", EmitDefaultValue=false)]
        public string Name { get; set; }

        /// <summary>
        /// Description of the object.
        /// </summary>
        /// <value>Description of the object.</value>
        [DataMember(Name="Description", EmitDefaultValue=false)]
        public string Description { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class TagsEndpointTypeTaggedObjects {\n");
            sb.Append("  ObjectType: ").Append(ObjectType).Append("\n");
            sb.Append("  ObjectUUID: ").Append(ObjectUUID).Append("\n");
            sb.Append("  Name: ").Append(Name).Append("\n");
            sb.Append("  Description: ").Append(Description).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as TagsEndpointTypeTaggedObjects);
        }

        /// <summary>
        /// Returns true if TagsEndpointTypeTaggedObjects instances are equal
        /// </summary>
        /// <param name="input">Instance of TagsEndpointTypeTaggedObjects to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(TagsEndpointTypeTaggedObjects input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.ObjectType == input.ObjectType ||
                    (this.ObjectType != null &&
                    this.ObjectType.Equals(input.ObjectType))
                ) && 
                (
                    this.ObjectUUID == input.ObjectUUID ||
                    (this.ObjectUUID != null &&
                    this.ObjectUUID.Equals(input.ObjectUUID))
                ) && 
                (
                    this.Name == input.Name ||
                    (this.Name != null &&
                    this.Name.Equals(input.Name))
                ) && 
                (
                    this.Description == input.Description ||
                    (this.Description != null &&
                    this.Description.Equals(input.Description))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.ObjectType != null)
                    hashCode = hashCode * 59 + this.ObjectType.GetHashCode();
                if (this.ObjectUUID != null)
                    hashCode = hashCode * 59 + this.ObjectUUID.GetHashCode();
                if (this.Name != null)
                    hashCode = hashCode * 59 + this.Name.GetHashCode();
                if (this.Description != null)
                    hashCode = hashCode * 59 + this.Description.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
