/* 
 * its4land Public API
 *
 * The its4land Public API provides access to the services of the its4land Publish and Share platform.
 *
 * OpenAPI spec version: 0.0.2
 * Contact: contact@its4land.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// ToolsEndpointType
    /// </summary>
    [DataContract]
    public partial class ToolsEndpointType :  IEquatable<ToolsEndpointType>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ToolsEndpointType" /> class.
        /// </summary>
        /// <param name="UID">UID of the tool.</param>
        /// <param name="Name">Name of the tool. Should be WP name.</param>
        /// <param name="Description">Free text for description. Only plain text..</param>
        /// <param name="LongDescription">Free text for long description..</param>
        /// <param name="ExtDescriptionURL">URL to an external content. The content is added as static html in the the standard web client..</param>
        /// <param name="Supplier">Free text for description. Only plain text..</param>
        /// <param name="Version">Tool version..</param>
        /// <param name="ToolURL">Link to external documentation.</param>
        /// <param name="Image">Image.</param>
        /// <param name="EntryPoints">EntryPoints.</param>
        public ToolsEndpointType(string UID = default(string), string Name = default(string), string Description = default(string), string LongDescription = default(string), string ExtDescriptionURL = default(string), string Supplier = default(string), string Version = default(string), string ToolURL = default(string), ToolsEndpointTypeImage Image = default(ToolsEndpointTypeImage), List<ToolsEndpointTypeEntryPoints> EntryPoints = default(List<ToolsEndpointTypeEntryPoints>))
        {
            this.UID = UID;
            this.Name = Name;
            this.Description = Description;
            this.LongDescription = LongDescription;
            this.ExtDescriptionURL = ExtDescriptionURL;
            this.Supplier = Supplier;
            this.Version = Version;
            this.ToolURL = ToolURL;
            this.Image = Image;
            this.EntryPoints = EntryPoints;
        }
        
        /// <summary>
        /// UID of the tool
        /// </summary>
        /// <value>UID of the tool</value>
        [DataMember(Name="UID", EmitDefaultValue=false)]
        public string UID { get; set; }

        /// <summary>
        /// Name of the tool. Should be WP name
        /// </summary>
        /// <value>Name of the tool. Should be WP name</value>
        [DataMember(Name="Name", EmitDefaultValue=false)]
        public string Name { get; set; }

        /// <summary>
        /// Free text for description. Only plain text.
        /// </summary>
        /// <value>Free text for description. Only plain text.</value>
        [DataMember(Name="Description", EmitDefaultValue=false)]
        public string Description { get; set; }

        /// <summary>
        /// Free text for long description.
        /// </summary>
        /// <value>Free text for long description.</value>
        [DataMember(Name="LongDescription", EmitDefaultValue=false)]
        public string LongDescription { get; set; }

        /// <summary>
        /// URL to an external content. The content is added as static html in the the standard web client.
        /// </summary>
        /// <value>URL to an external content. The content is added as static html in the the standard web client.</value>
        [DataMember(Name="ExtDescriptionURL", EmitDefaultValue=false)]
        public string ExtDescriptionURL { get; set; }

        /// <summary>
        /// Free text for description. Only plain text.
        /// </summary>
        /// <value>Free text for description. Only plain text.</value>
        [DataMember(Name="Supplier", EmitDefaultValue=false)]
        public string Supplier { get; set; }

        /// <summary>
        /// Tool version.
        /// </summary>
        /// <value>Tool version.</value>
        [DataMember(Name="Version", EmitDefaultValue=false)]
        public string Version { get; set; }

        /// <summary>
        /// Link to external documentation
        /// </summary>
        /// <value>Link to external documentation</value>
        [DataMember(Name="ToolURL", EmitDefaultValue=false)]
        public string ToolURL { get; set; }

        /// <summary>
        /// Gets or Sets Image
        /// </summary>
        [DataMember(Name="Image", EmitDefaultValue=false)]
        public ToolsEndpointTypeImage Image { get; set; }

        /// <summary>
        /// Gets or Sets EntryPoints
        /// </summary>
        [DataMember(Name="EntryPoints", EmitDefaultValue=false)]
        public List<ToolsEndpointTypeEntryPoints> EntryPoints { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ToolsEndpointType {\n");
            sb.Append("  UID: ").Append(UID).Append("\n");
            sb.Append("  Name: ").Append(Name).Append("\n");
            sb.Append("  Description: ").Append(Description).Append("\n");
            sb.Append("  LongDescription: ").Append(LongDescription).Append("\n");
            sb.Append("  ExtDescriptionURL: ").Append(ExtDescriptionURL).Append("\n");
            sb.Append("  Supplier: ").Append(Supplier).Append("\n");
            sb.Append("  Version: ").Append(Version).Append("\n");
            sb.Append("  ToolURL: ").Append(ToolURL).Append("\n");
            sb.Append("  Image: ").Append(Image).Append("\n");
            sb.Append("  EntryPoints: ").Append(EntryPoints).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ToolsEndpointType);
        }

        /// <summary>
        /// Returns true if ToolsEndpointType instances are equal
        /// </summary>
        /// <param name="input">Instance of ToolsEndpointType to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ToolsEndpointType input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.UID == input.UID ||
                    (this.UID != null &&
                    this.UID.Equals(input.UID))
                ) && 
                (
                    this.Name == input.Name ||
                    (this.Name != null &&
                    this.Name.Equals(input.Name))
                ) && 
                (
                    this.Description == input.Description ||
                    (this.Description != null &&
                    this.Description.Equals(input.Description))
                ) && 
                (
                    this.LongDescription == input.LongDescription ||
                    (this.LongDescription != null &&
                    this.LongDescription.Equals(input.LongDescription))
                ) && 
                (
                    this.ExtDescriptionURL == input.ExtDescriptionURL ||
                    (this.ExtDescriptionURL != null &&
                    this.ExtDescriptionURL.Equals(input.ExtDescriptionURL))
                ) && 
                (
                    this.Supplier == input.Supplier ||
                    (this.Supplier != null &&
                    this.Supplier.Equals(input.Supplier))
                ) && 
                (
                    this.Version == input.Version ||
                    (this.Version != null &&
                    this.Version.Equals(input.Version))
                ) && 
                (
                    this.ToolURL == input.ToolURL ||
                    (this.ToolURL != null &&
                    this.ToolURL.Equals(input.ToolURL))
                ) && 
                (
                    this.Image == input.Image ||
                    (this.Image != null &&
                    this.Image.Equals(input.Image))
                ) && 
                (
                    this.EntryPoints == input.EntryPoints ||
                    this.EntryPoints != null &&
                    this.EntryPoints.SequenceEqual(input.EntryPoints)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.UID != null)
                    hashCode = hashCode * 59 + this.UID.GetHashCode();
                if (this.Name != null)
                    hashCode = hashCode * 59 + this.Name.GetHashCode();
                if (this.Description != null)
                    hashCode = hashCode * 59 + this.Description.GetHashCode();
                if (this.LongDescription != null)
                    hashCode = hashCode * 59 + this.LongDescription.GetHashCode();
                if (this.ExtDescriptionURL != null)
                    hashCode = hashCode * 59 + this.ExtDescriptionURL.GetHashCode();
                if (this.Supplier != null)
                    hashCode = hashCode * 59 + this.Supplier.GetHashCode();
                if (this.Version != null)
                    hashCode = hashCode * 59 + this.Version.GetHashCode();
                if (this.ToolURL != null)
                    hashCode = hashCode * 59 + this.ToolURL.GetHashCode();
                if (this.Image != null)
                    hashCode = hashCode * 59 + this.Image.GetHashCode();
                if (this.EntryPoints != null)
                    hashCode = hashCode * 59 + this.EntryPoints.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
