/* 
 * its4land Public API
 *
 * The its4land Public API provides access to the services of the its4land Publish and Share platform.
 *
 * OpenAPI spec version: 0.0.2
 * Contact: contact@its4land.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// ToolsEndpointTypeEntryPoints
    /// </summary>
    [DataContract]
    public partial class ToolsEndpointTypeEntryPoints :  IEquatable<ToolsEndpointTypeEntryPoints>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ToolsEndpointTypeEntryPoints" /> class.
        /// </summary>
        /// <param name="Name">Name of the EntryPoint or sub tool.</param>
        /// <param name="Description">Free text for description. Only plain text..</param>
        /// <param name="LongDescription">Free text for long description. Only plain text..</param>
        /// <param name="EntryPoint">How to start the sub tool.</param>
        public ToolsEndpointTypeEntryPoints(string Name = default(string), string Description = default(string), string LongDescription = default(string), string EntryPoint = default(string))
        {
            this.Name = Name;
            this.Description = Description;
            this.LongDescription = LongDescription;
            this.EntryPoint = EntryPoint;
        }
        
        /// <summary>
        /// Name of the EntryPoint or sub tool
        /// </summary>
        /// <value>Name of the EntryPoint or sub tool</value>
        [DataMember(Name="Name", EmitDefaultValue=false)]
        public string Name { get; set; }

        /// <summary>
        /// Free text for description. Only plain text.
        /// </summary>
        /// <value>Free text for description. Only plain text.</value>
        [DataMember(Name="Description", EmitDefaultValue=false)]
        public string Description { get; set; }

        /// <summary>
        /// Free text for long description. Only plain text.
        /// </summary>
        /// <value>Free text for long description. Only plain text.</value>
        [DataMember(Name="LongDescription", EmitDefaultValue=false)]
        public string LongDescription { get; set; }

        /// <summary>
        /// How to start the sub tool
        /// </summary>
        /// <value>How to start the sub tool</value>
        [DataMember(Name="EntryPoint", EmitDefaultValue=false)]
        public string EntryPoint { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ToolsEndpointTypeEntryPoints {\n");
            sb.Append("  Name: ").Append(Name).Append("\n");
            sb.Append("  Description: ").Append(Description).Append("\n");
            sb.Append("  LongDescription: ").Append(LongDescription).Append("\n");
            sb.Append("  EntryPoint: ").Append(EntryPoint).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ToolsEndpointTypeEntryPoints);
        }

        /// <summary>
        /// Returns true if ToolsEndpointTypeEntryPoints instances are equal
        /// </summary>
        /// <param name="input">Instance of ToolsEndpointTypeEntryPoints to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ToolsEndpointTypeEntryPoints input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Name == input.Name ||
                    (this.Name != null &&
                    this.Name.Equals(input.Name))
                ) && 
                (
                    this.Description == input.Description ||
                    (this.Description != null &&
                    this.Description.Equals(input.Description))
                ) && 
                (
                    this.LongDescription == input.LongDescription ||
                    (this.LongDescription != null &&
                    this.LongDescription.Equals(input.LongDescription))
                ) && 
                (
                    this.EntryPoint == input.EntryPoint ||
                    (this.EntryPoint != null &&
                    this.EntryPoint.Equals(input.EntryPoint))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Name != null)
                    hashCode = hashCode * 59 + this.Name.GetHashCode();
                if (this.Description != null)
                    hashCode = hashCode * 59 + this.Description.GetHashCode();
                if (this.LongDescription != null)
                    hashCode = hashCode * 59 + this.LongDescription.GetHashCode();
                if (this.EntryPoint != null)
                    hashCode = hashCode * 59 + this.EntryPoint.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
